package org.okiproject.serviceapi.authorization;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/authorization/AuthorizationException.java,v $
 */
/**
</p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.1 $ / $Date: 2002/02/18 15:23:20 $
*/

public class RolesException
extends java.lang.Exception {
  public static final String QUERYAUTHORIZATIONFAILED           =
    "Query authorization failed ";
  public static final String CREATEAUTHORIZATIONFAILED          =
    "Create authorization failed ";
  public static final String DELETEAUTHORIZATIONFAILED          =
    "Delete authorization failed ";
  public static final String UPDATEAUTHORIZATIONFAILED          =
    "Update authorization failed ";
  public static final String AUTHORIZATIONENUMERATIONFAILED     =
    "Enumeration of authorizations failed ";
  public static final String AUTHORIZATIONFIELDDOESNOTEXIST     =
    "Authorization field does not exist ";

  public static final String FUNCTIONIDALREADYEXISTS            =
    "Function already exists ";
  public static final String INVALIDDATABASE                    =
    "Invalid database ";
  public static final String INVALIDFUNCTION                    =
    "Invalid function ";
  public static final String FUNCTIONNOTFOUNDINROLES            =
    "Function not found in Roles ";
  public static final String FUNCTIONCATEGORYNOTFOUNDINROLES    =
    "Function category not found in Roles ";
  public static final String FUNCTIONENUMERATIONFAILED          =
    "Enumeration of functions failed ";

  public static final String INVALIDPERSONKEY                   =
    "Invalid person key ";
  public static final String PERSONNOTFOUNDINAUTHORIZATIONS              =
    "Person not found in Authorizations ";
  public static final String PEOPLEENUMERATIONFAILED            =
    "Enumeration of people failed ";

  public static final String INVALIDQUALIFIER                   =
    "Invalid qualifier ";
  public static final String QUALIFIERNOTFOUNDINAUTHORIZATIONS           =
    "Qualifier not found in Authorizations ";
  public static final String QUALIFIERCODENOTFOUNDINAUTHORIZATIONS       =
    "Qualifier code not found in Authorizations ";
  public static final String QUALIFIERTYPENOTFOUNDINAUTHORIZATIONS       =
    "Qualifier type not found in Authorizations ";
  public static final String QUALIFIERENUMERATIONFAILED         =
    "Enumeration of qualifiers failed ";

  public static final String INVALIDGRANTPRIVILEGE              =
    "Invalid grant privilege ";

  public static final String DATABASESYMBOLICNAMELISTDIDNOTLOAD =
    "Database symbolic name list did not load ";
  public static final String MISSINGDATABASESYMBOLICNAME        =
    "Current database symbolic name is not set ";

  /**
   * Constructor AuthorizationException
   *
   *
   * @param message
   *
   */
  public AuthorizationException(String message) {
    super(message);
  }

}
