package org.okiproject.serviceapi.authorization;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/authorization/Person.java,v $ 
 */
/**
 *  @see org.okiproject.serviceapi.authorization.Field
 *  @see org.okiproject.serviceapi.authorization.RolesFactory
 
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.1 $ / $Date: 2002/02/16 06:08:33 $
*/
public interface Person
extends org.okiproject.serviceapi.common.Person {

  /**
   * Determines if this Person has a matching Person in the Roles DB.
   *
   * @return true indicates Person is in the Roles DB as are its properties.
   * @return false        indicates Roles DB hasn't been queried or Person is not in the Roles DB.
   */
  Boolean isFoundInRoles()
  throws Exception;

  /**
   * Refresh properties from a changing Roles DB.
   */
  void refresh()
  throws Exception;

}
