package org.okiproject.serviceapi.authorization;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/authorization/Qualifier.java,v $ 
 */
/**
</p>
 *  @see org.okiproject.serviceapi.authorization.Qualifiers
 *  @see org.okiproject.serviceapi.authorization.QualifierType
 *  @see org.okiproject.serviceapi.authorization.Field
 *  @see org.okiproject.serviceapi.authorization.RolesFactory
 
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.1 $ / $Date: 2002/02/16 06:08:33 $
*/
public interface Qualifier
extends java.io.Serializable {

  /**
   * Method getId
   *
   *
   * @return
   *
   */
  Object getId();

  /**
   * Method getCode
   *
   *
   * @return
   *
   */
  String getCode();

  /**
   * Method getDescription
   *
   *
   * @return
   *
   */
  String getDescription();

  /**
   * Method getHasChild
   *
   *
   * @return
   *
   */
  Boolean getHasChild();

  /**
   * Method getProperties
   *
   *
   * @return
   *
   */
  java.util.Properties getProperties();

  /**
   * Method getQualifierType
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.authorization.QualifierType getQualifierType();

  /**
   * Method setId
   *
   *
   * @param id
   *
   */
  void setId(Object id);

  /**
   * Method setCode
   *
   *
   * @param code
   *
   */
  void setCode(String code);

  /**
   * Method setQualifierType
   *
   *
   * @param qualifierType
   *
   */
  void setQualifierType(
    org.okiproject.serviceapi.authorization.QualifierType qualifierType);

  /**
   * Adds a parent-child relationship between two existing qualifiers
   * in the Roles DB.
   */
  void addLink(org.okiproject.serviceapi.authorization.Qualifier parent)
  throws Exception;

  /**
   * Deletes a parent-child relationship between two existing qualifiers
   * in the Roles DB.
   */
  void deleteLink()
  throws Exception;

  /**
   * For an existing qualifier, moves the parent link from one existing
   * qualifier to another.
   */
  void moveLink(org.okiproject.serviceapi.authorization.Qualifier oldParent,
                org.okiproject.serviceapi.authorization.Qualifier newParent)
  throws Exception;

  /**
   * For an existing qualifier, determines if the qualifier is the child a
   * given parent
   */

  //Boolean isChildOf( org.okiproject.serviceapi.authorization.Qualifier parent ) throws Exception ;

  /**
   * For an existing qualifier, get its descendents
   */
  //org.okiproject.serviceapi.authorization.Qualifiers getDescendents() throws Exception ;

}
