package org.okiproject.serviceapi.common;

public class FactoryLoader
implements java.io.Serializable {

  /**
   * Method getDefaultFactory
   *
   *
   * @param apiPackageName
   * @param implPackageName
   * @param owner
   *
   * @return org.okiproject.util.Factory
   *
   * @throws Exception
   *
   */
  public static org.okiproject.util.Factory getDefaultFactory(
          String apiPackageName,
          String implPackageName,
          org.okiproject.util.Agent owner)
  throws org.okiproject.serviceapi.common.Exception {
    java.util.Map properties = getPropertiesFromPRB(apiPackageName);

    return getFactory(apiPackageName, implPackageName, agent, properties);
  }

  /**
   * Method getFactory
   *
   *
   * @param apiPackageName
   * @param implPackageName
   * @param owner
   * @param props
   *
   * @return org.okiproject.util.Factory
   *
   * @throws Exception
   *
   */
  public static org.okiproject.util.Factory getFactory(
          String apiPackageName, String implPackageName,
          org.okiproject.util.Agent owner, java.util.Map props)
  throws org.okiproject.serviceapi.common.Exception {
    java.util.Map properties = props;

    if (null == properties) {
      properties = getPropertiesFromPRB(apiPackageName);
    }

    if (null != properties) {
      String factoryClassName =
        (String) properties.get(newString(implPackageName+".Factory");

      if (null != factoryClassName) {
        Class factoryClass =
          Class.forName(factoryClassName);
        org.okiproject.util.Factory factory =
          (org.okiproject.util.Factory) factoryClass.newInstance();

        factory.setOwner(owner);
        factory.setProperties(properties);

        return factory;
      }
    }
    throw new org.okiproject.common.Exception(
      org.okiproject.common.Exception.DEFAULTFACTORYDIDNOTLOAD);
  }

  private static java.util.Properties getPropertiesFromPRB(String apiPackageName)
  throws org.okiproject.serviceapi.common.Exception {
    java.util.PropertyResourceBundle prb =
      (java.util.PropertyResourceBundle) java.util.ResourceBundle.getBundle(
        newString(apiPackageName+"Factory"));

    if (null != prb) {
      java.util.Properties  properties = new java.util.Properties();
      java.util.Enumeration keys       = prb.getKeys();

      while (keys.hasMoreElements()) {
        String key = (String) (keys.nextElement());

        properties.setProperty(key, (String) prb.handleGetObject(key));
      }

      return properties;
    }

    throw new org.okiproject.common.Exception(
      org.okiproject.common.Exception.FACTORYPROPERTIESDIDNOTLOAD);
  }

}