package org.okiproject.serviceapi.dbc;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/dbc/Connection.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.1 $ / $Date: 2002/02/16 06:13:29 $
*/
public interface Connection
extends java.io.Serializable {

  /**
   * Method getDatabase
   *
   *
   * @return
   *
   */
  String getDatabase();

  /**
   * Method getUsername
   *
   *
   * @return
   *
   */
  String getUsername();

  /**
   * Method getId
   *
   *
   * @return
   *
   */
  String getId();

  /**
   * Method getAutoCommit
   *
   *
   * @return
   *
   */
  Boolean getAutoCommit();

  /**
   * Method setAutoCommit
   *
   *
   * @param autoCommit
   *
   */
  void setAutoCommit(Boolean autoCommit);

  /**
   * Method getProcedures
   *
   *
   * @param catalog
   * @param schemaPattern
   * @param procedureNamePattern
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table getProcedures(String catalog,
          String schemaPattern, String procedureNamePattern)
  throws Exception;

  /**
   * Method getProcedureColumns
   *
   *
   * @param catalog
   * @param schemaPattern
   * @param procedureName
   * @param columnNamePattern
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table getProcedureColumns(String catalog,
          String schemaPattern, String procedureName,
          String columnNamePattern)
  throws Exception;

  /**
   * Method executeQuery
   *
   *
   * @param sql
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table executeQuery(String sql)
  throws Exception;

  /**
   * Method executeQuery
   *
   *
   * @param sql
   * @param objs
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table executeQuery(String sql, Object[] objs)
  throws Exception;

  /**
   * Method executeQuery
   *
   *
   * @param sql
   * @param objs
   * @param targetSqlTypes
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table executeQuery(String sql, Object[] objs,
          int[] targetSqlTypes)
  throws Exception;

  /**
   * Method executeQuery
   *
   *
   * @param sql
   * @param objs
   * @param targetSqlTypes
   * @param scales
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table executeQuery(String sql, Object[] objs,
          int[] targetSqlTypes, int[] scales)
  throws Exception;

  /**
   * Method executeUpdate
   *
   *
   * @param sql
   *
   * @return
   *
   * @throws Exception
   *
   */
  int executeUpdate(String sql)
  throws Exception;

  /**
   * Method executeUpdate
   *
   *
   * @param sql
   * @param objs
   *
   * @return
   *
   * @throws Exception
   *
   */
  int executeUpdate(String sql, Object[] objs)
  throws Exception;

  /**
   * Method executeUpdate
   *
   *
   * @param sql
   * @param objs
   * @param targetSqlTypes
   *
   * @return
   *
   * @throws Exception
   *
   */
  int executeUpdate(String sql, Object[] objs, int[] targetSqlTypes)
  throws Exception;

  /**
   * Method executeUpdate
   *
   *
   * @param sql
   * @param objs
   * @param targetSqlTypes
   * @param scales
   *
   * @return
   *
   * @throws Exception
   *
   */
  int executeUpdate(String sql, Object[] objs, int[] targetSqlTypes,
                    int[] scales)
  throws Exception;

  /**
   * Method getTables
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table getTables()
  throws Exception;

  /**
   * Method getTables
   *
   *
   * @param catalog
   * @param schemaPattern
   * @param tableNamePattern
   * @param tableTypes
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table getTables(String catalog,
          String schemaPattern, String tableNamePattern, String[] tableTypes)
  throws Exception;

  /**
   * Method callProcedure
   *
   *
   * @param procedureName
   * @param args
   * @param columnTypes
   * @param datatypes
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table callProcedure(String procedureName,
          Object[] args, int[] columnTypes, int[] datatypes)
  throws Exception;

  /**
   * Method callProcedure
   *
   *
   * @param catalog
   * @param schemaPattern
   * @param procedureName
   * @param columnNamePattern
   * @param args
   * @param columnTypes
   * @param datatypes
   *
   * @return
   *
   * @throws Exception
   *
   */
  org.okiproject.serviceapi.dbc.Table callProcedure(String catalog,
          String schemaPattern, String procedureName,
          String columnNamePattern, Object[] args, int[] columnTypes,
          int[] datatypes)
  throws Exception;

  /**
   * Method connect
   *
   *
   * @throws Exception
   *
   */
  void connect()
  throws Exception;

  /**
   * Method disconnect
   *
   *
   * @throws Exception
   *
   */
  void disconnect()
  throws Exception;

  /**
   * Method commit
   *
   *
   * @throws Exception
   *
   */
  void commit()
  throws Exception;

  /**
   * Method rollback
   *
   *
   * @throws Exception
   *
   */
  void rollback()
  throws Exception;

}
