package org.okiproject.serviceapi.romi.client;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/romi/client/Client.java,v $
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.1 $ / $Date: 2002/02/18 15:42:47 $
*/
public interface Client {

  /**
   *  This method gets the Host that this Client uses.
   */
  String getHost();

  /**
   *  This method gets the Port that this Client uses.
   */
  Integer getPort();

  /**
   *  This method gets the Service that this Client uses.
   */
  String getService();

  /**
   *  This method gets the Agent for whom the Client acts.
   */
  org.okiproject.serviceapi.common.Agent getForAgent();

  /**
   * Method invoke
   *
   *  Given an object, a methodname, an array of method argument types,
   *  and an array of arguments, this method will invoke the method.
   *
   *
   * @param object
   * @param methodName
   * @param argTypes
   * @param args
   *
   * @return the result of a successful invocation
   */
  Object invoke(java.io.Serializable object, String methodName,
                Class[] argTypes, Object[] args)
  throws Exception;

  /**
   *  The test method sends a test object to the Server which returns
   *  a string that indicates that the test was successful or throws
   *  an exception.
   *
   *  @return the result of a successful test
   */
  String test()
  throws Exception;
}
