package org.okiproject.serviceapi.rules;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/rules/Rule.java,v $ 
 */
/**
<pre>
 *  @see org.okiproject.serviceapi.rules.Predicate
 *  @see org.okiproject.serviceapi.rules.Verb
 *  @see org.okiproject.serviceapi.rules.Subject
 *  @see org.okiproject.serviceapi.rules.PredicateType
 *  @see org.okiproject.serviceapi.rules.VerbType
 *  @see org.okiproject.serviceapi.rules.SubjectType
 *  @see org.okiproject.serviceapi.rules.RulesFactory
<p> 
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.4 $ / $Date: 2002/02/16 05:02:54 $
*/
public interface Rule
extends java.io.Serializable {

  /**
   * Method getId
   *
   *
   * @return
   *
   */
  Object getId();

  /**
   * Method getEffectiveDate
   *
   *
   * @return
   *
   */
  java.sql.Timestamp getEffectiveDate();

  /**
   * Method getExpirationDate
   *
   *
   * @return
   *
   */
  java.sql.Timestamp getExpirationDate();

  /**
   * Method getModifiedDate
   *
   *
   * @return
   *
   */
  java.sql.Timestamp getModifiedDate();

  /**
   * Method getModifiedBy
   *
   *
   * @return
   *
   */
  String getModifiedBy();

  /**
   * Method getPredicate
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.rules.Predicate getPredicate();

  /**
   * Method getVerb
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.rules.Verb getVerb();

  /**
   * Method getSubject
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.rules.Subject getSubject();

  /**
   * Method getPredicateType
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.rules.PredicateType getPredicateType();

  /**
   * Method getVerbType
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.rules.VerbType getVerbType();

  /**
   * Method getSubjectType
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.rules.VerbType getSubjectType();

  /**
   * Deletes an existing rule in the Rules DB.
   */
  void delete()
  throws Exception;

  /**
   * Updates one or more fields in an existing rule
   * in the Rules DB.
   */
  void update(org.okiproject.serviceapi.rules.Subject subject,
              org.okiproject.serviceapi.rules.Verb verb,
              org.okiproject.serviceapi.rules.Predicate predicate,
              org.okiproject.serviceapi.rules.SubjectType subjectType,
              org.okiproject.serviceapi.rules.VerbType verbType,
              org.okiproject.serviceapi.rules.PredicateType predicateType,
              java.sql.Timestamp effectiveDate,
              java.sql.Timestamp expirationDate)
  throws Exception;
}
