package org.okiproject.serviceapi.sched;
/*
Copyright (c) 2001 Massachusetts Institute of Technology

Permission is hereby granted, free of charge, to any
person obtaining a copy of this software and associated
documentation files (the "Software"), to deal in the
Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the
Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice
shall be included in all copies or substantial portions of
the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.
*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/sched/ScheduleItem.java,v $
 */
/**
Purpose: Represents the schedule abstraction
<p>
@version $Revision: 1.6 $ / $Date: 2002/02/25 18:23:00 $
*/
public interface ScheduleItem
extends java.io.Serializable {

	public static final String CANCELED = "CANCELED";
	public static final String ACTIVE = "ACTIVE";
	public static final String INACTIVE = "INACTIVE";

  /**
		* Title of the schedule item. A Scheduled Item is a named entity.
    *
  **/
  public String getItemName();

  public String getScheduleItemType();
  
 


  /**
		* Method getResourceCommitments
		* List of ResourceCommitments associated with this item.
  **/
 public org.okiproject.serviceapi.sched.ResourceCommitment[] getResourceCommitments();


  /**
   * Method getLocation
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.sched.Location getLocation();

  /**
   * Method getTimeSpan
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.sched.TimeSpan getTimeSpan();

  
  /**
   * Method getScheduleItemStatus
   *
   *
   *
   */
 public ScheduleItemStatus getScheduleItemStatus();

 /**
   * Method unsetTimeSpan
   *
   *
   * @param span
   *
   */
  //public void unsetTimeSpan(org.okiproject.serviceapi.sched.TimeSpan span);

  /**
   * Method getPriority
   *
   *
   *
   */
  //public int getPriority();


  //public org.okiproject.serviceapi.ScheduleItemIterator getScheduleItemIterator();
}


/*--- Formatted in OKI Style on Fri, Feb 8, '02 ---*/


/*------ Formatted by Jindent 3.24 Basic 1.0 --- http://www.jindent.de ------*/
