
/**
<p>
   Copyright (c) 2002 Massachusetts Institute of Technology
<p>
   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:
<p>
   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.
<p>
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.
<p>
$Source: /cvs/oki/org/okiproject/serviceapi/test/authen/authen_api_example.java,v $
@version@ $Revision: 1.10 $
$Date: 2002/02/16 17:31:56 $

*****************************************************************************
*
*  Sample pseudo-application demonstrating Authen API
*     01/23/2002
*
****************************************************************************
*/
package org.okiproject.serviceapi.test.authen;



/**
 * Class authen_api_example
 *
 *
 * @author
 * @version %I%, %G%
 */
public class authen_api_example {

  /**
   * Constructor authen_api_example
   *
   *
   */
  public authen_api_example(java.io.PrintStream out) {
    try {

      /*************************************************************************
       ** Get the MIT implementation of the Authen API
       *************************************************************************/
      org.okiproject.serviceapi.authentication.AuthenFactory myFactory =
        org.okiproject.serviceapi.authentication.AuthenFactory.getDefaultAuthenFactory(
          null);

      /*************************************************************************
       ** Get an authentication types
       *************************************************************************/
      out.println("Authen types:");

      String[] types = myFactory.getAuthenTypes();

      if (null != types) {
        for (int i = 0; types.length != i; i++) {
          out.println(types[i]);
          System.err.println(types[i]);
        }
      }

      out.println("end of Authen types");

      /*************************************************************************
       ** Get an authenticated user
       *************************************************************************/
      out.println("Authenticated user:");

      org.okiproject.serviceapi.common.Agent user = myFactory.getAgent();

      out.println("user.getName():" + user.getName());
      out.println(user);

      if (null != user) {
        java.util.Properties userProperties =
          ((org.okiproject.serviceapi.common.Person) user).getProperties();

        java.util.Iterator   propertiesKeys =
          userProperties.keySet().iterator();

        while (propertiesKeys.hasNext()) {
          Object key = propertiesKeys.next();

          out.println("Key:" + key + " value:" + userProperties.get(key));
        }

      }

      out.println("end of Authenticated user");

      if (null != user) {
        String kerberos = null;

        /*************************************************************************
         ** Get an authentication types for authenticated user
         *************************************************************************/
        out.println("Authen types for Authenticated user:");

        types = myFactory.getAuthenTypes(user);

        if (null != types) {
          for (int i = 0; types.length != i; i++) {
            if (-1 != types[i].toLowerCase().indexOf("kerberos")) {
              kerberos = types[i];
            }

            out.println(types[i]);
          }
        }

        out.println("end of Authen types for Authenticated user");

        /*************************************************************************
         ** Destroy all authentication for authenticated user
         *************************************************************************/
        out.println("Destroy all authentication for Authenticated user:");
        myFactory.destroyAuthen(user);

        types = myFactory.getAuthenTypes(user);

        if (null != types) {
          for (int i = 0; types.length != i; i++) {
            out.println(types[i]);
          }
        }

        out.println(
          "end of Destroy all authentication for Authenticated user");

        /*************************************************************************
         ** Get an authenticated user with a specific authentication type
         *************************************************************************/
        out.println(
          "Get an Authenticated user with authentication type of KERBEROS4:");

        try {
          user = myFactory.getAgent(user, kerberos);

          out.println("user.getName():" + user.getName());
          out.println(user);

          if (null != user) {
            java.util.Properties userProperties =
              ((org.okiproject.serviceapi.common.Person) user).getProperties();

            java.util.Iterator   propertiesKeys =
              userProperties.keySet().iterator();

            while (propertiesKeys.hasNext()) {
              Object key = propertiesKeys.next();

              out.println("Key:" + key + " value:" + userProperties.get(key));
            }
          }

          types = myFactory.getAuthenTypes(user);

          if (null != types) {
            for (int i = 0; types.length != i; i++) {
              out.println(types[i]);
            }
          }
        }
        catch (Exception e) {
          out.println("Exception: " + e);
        }

        out.println(
          "end of Get an Authenticated user with authentication type of KERBEROS4");

        if (null != user) {

          /*************************************************************************
           ** Destroy authentication of type KERBEROS4 for authenticated user
           *************************************************************************/
          out.println(
            "Destroy authentication of type KERBEROS4 for Authenticated user:");

          try {
            myFactory.destroyAuthen(user, kerberos);

            types = myFactory.getAuthenTypes(user);

            if (null != types) {
              for (int i = 0; types.length != i; i++) {
                out.println(types[i]);
              }
            }
          }
          catch (Exception e) {
            out.println("Exception: " + e);
          }

          out.println(
            "end of Destroy authentication of type KERBEROS4 for Authenticated user");

          /*************************************************************************
           ** Get another authenticated user with a specific authentication type
           *************************************************************************/
          out.println(
            "Get another Authenticated user with authentication type of KERBEROS4:");

          try {
            user = myFactory.getAgent(user, kerberos);

            out.println("user.getName():" + user.getName());
            out.println(user);

            if (null != user) {
              java.util.Properties userProperties =
                ((org.okiproject.serviceapi.common.Person) user).getProperties();

              java.util.Iterator   propertiesKeys =
                userProperties.keySet().iterator();

              while (propertiesKeys.hasNext()) {
                Object key = propertiesKeys.next();

                out.println("Key:" + key + " value:"
                            + userProperties.get(key));
              }
            }

            types = myFactory.getAuthenTypes(user);

            if (null != types) {
              for (int i = 0; types.length != i; i++) {
                out.println(types[i]);
              }
            }
          }
          catch (Exception e) {
            out.println("Exception: " + e);
          }

          out.println(
            "end of Get another Authenticated user with authentication type of KERBEROS4");

          if (null != user) {

            /*************************************************************************
             ** Destroy authentication array of types for authenticated user
             *************************************************************************/
            out.println(
              "Destroy authentication array of types for Authenticated user:");

            try {
              types = myFactory.getAuthenTypes(user);

              myFactory.destroyAuthen(user, types);

              types = null;
            }
            catch (Exception e) {
              out.println("Exception: " + e);
            }

            out.println(
              "end of Destroy authentication array of types for Authenticated user");
          }
        }
      }
    }
    catch (Throwable exx) {
      out.println(exx.getMessage());
      exx.printStackTrace();
    }
  }

  /**
   * Method main
   *
   *
   * @param args
   *
   */
  public static void main(String[] args) {
    new org.okiproject.serviceapi.test.authen.authen_api_example(
      (java.io.PrintStream) System.out);
    System.exit(0);
  }
}


/*--- Formatted in OKI Style on Fri, Feb 8, '02 ---*/


/*------ Formatted by Jindent 3.24 Basic 1.0 --- http://www.jindent.de ------*/
