
public class roles_api_test{

  // Set some constants
  static final Boolean TRUE = new Boolean (true);
  static final Boolean FALSE = new Boolean (false);

  static org.okiproject.serviceapi.roles.RolesFactory getDefaultRolesFactory()
  throws Exception
  {
   return
       org.okiproject.serviceapi.roles.RolesFactory.getDefaultRolesFactory("Roles", "test_roles");
  }

  static void test_getAuthsSimpleForm(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

     String apiName = "getAuthsSimpleForm";

        /**********************************************************
	     * given Person
	     **********************************************************/
	    System.out.println("No.0 test api :  "+ apiName +"===>Given at Person\r\n");

	    org.okiproject.serviceapi.roles.Authorizations authList0 = null;

		org.okiproject.serviceapi.roles.Person person0 = myFactory.newPerson ("cshubert");

	    authList0 = myFactory.getAuthsSimpleForm (
	      person0,        // 1st argument is a person
	      FALSE,
	      FALSE,
	      FALSE
	    );

	    int cnt0 = 0;
	    while (authList0.hasMoreAuthorizations()) { // Print the list of auths.
	      //System.out.println (authList0.nextAuthorization().getId());
	      org.okiproject.serviceapi.roles.Authorization auth = authList0.nextAuthorization();
	      if(auth!=null) print_authorization(auth, myFactory);
	      cnt0++;
	    }

	   System.out.println("The total authorization is " + cnt0);
	   System.out.println ("end of authorizations for API " + apiName + " for " + person0.getID());
	   System.out.println ();


    /**********************************************************
     * given Person + functioncategory  arguments
     **********************************************************/
    System.out.println("No.1 test api :  "+ apiName +"===>Given at Person+functioncategory\r\n");

    org.okiproject.serviceapi.roles.Authorizations authList1 = null;

	org.okiproject.serviceapi.roles.Person person1 = myFactory.newPerson ("cshubert");

    org.okiproject.serviceapi.roles.FunctionCategory category1 = myFactory.newFunctionCategory ("TEST");

    authList1 = myFactory.getAuthsSimpleForm (
       person1,
       category1,
       FALSE,
       FALSE,
       FALSE
    );

    System.out.println (person1.getID()
                       +" has the following authorizations in category: "
                       +category1.getCategory()
                       );

    int cnt1 = 0;
    while (authList1.hasMoreAuthorizations()) {
      org.okiproject.serviceapi.roles.Authorization auth1 = authList1.nextAuthorization();
	  if(auth1!=null) print_authorization(auth1, myFactory);
      cnt1++;
    }

   System.out.println("The total authorization is " + cnt1);
   System.out.println ("end of authorizations for API " + apiName + " for " + person1.getID());
   System.out.println ();




     /**********************************************************
	  * given Person  + function + qualifier  arguments
      **********************************************************/

       System.out.println("No.3 test api :  "+ apiName +"===>Given Person+function+qualifer\r\n");

       org.okiproject.serviceapi.roles.Authorizations authList3 = null;
       org.okiproject.serviceapi.roles.Person person3 = myFactory.newPerson ("cshubert");
       org.okiproject.serviceapi.roles.Function function3 = myFactory.newFunction ("TEST", "TESTFUN1");
       org.okiproject.serviceapi.roles.Qualifier qualifier3 = myFactory.newQualifier ("ORGU", "321000");

       System.out.println("is the qualifier found in roles : " + (myFactory.isQualifierFoundInRoles(qualifier3)).booleanValue());
       System.out.println("is the function found in roles : " + (myFactory.isFunctionFoundInRoles(function3)).booleanValue());

       print_qualifier(qualifier3, myFactory);

       authList3 = myFactory.getAuthsSimpleForm (
 	      person3,
 	      function3,
 	      qualifier3,
 	      FALSE,
 	      FALSE,
 	      FALSE
    );

     int cnt3 = 0;

	 while (authList3.hasMoreAuthorizations()) { // Print the list of auths.
		org.okiproject.serviceapi.roles.Authorization auth3 = authList3.nextAuthorization();
		cnt3++;
		if(auth3!=null) print_authorization(auth3, myFactory);
	 }

   System.out.println ("total  " + cnt3 + " authorizations for API " + apiName + " for " + person3.getID());
   System.out.println ();


     /**********************************************************
      * given Person  + function  arguments
      **********************************************************/

      System.out.println("No.4 test api :  "+ apiName +"===> Given Person+function\r\n");

      org.okiproject.serviceapi.roles.Authorizations authList4 = null;
      org.okiproject.serviceapi.roles.Person  person4 = myFactory.newPerson ("cshubert");
      org.okiproject.serviceapi.roles.Function function4 = myFactory.newFunction ("TEST", "TESTFUN1");

      authList4 = myFactory.getAuthsSimpleForm (
	      person4,
	      function4,
	      FALSE,
	      FALSE,
	      FALSE
    );

     int cnt = 0;
	 while (authList4.hasMoreAuthorizations()) {
	     System.out.println("=== the list of the authorizations\r\n");
	     org.okiproject.serviceapi.roles.Authorization auth4 = authList4.nextAuthorization();
	 	 if(auth4!=null) print_authorization(auth4, myFactory);
	     cnt++;
	  }

	   System.out.println("The total authorization is " + cnt);
	   System.out.println ("\r\nend of authorizations for API " + apiName + " for " + person4.getID());
	   System.out.println ();


     /**********************************************************
      * given Person  + functionCategory+Qualifier  arguments
      **********************************************************/

       System.out.println("No.5 test api :  "+ apiName +
                          "===> Given Person + functionCategory + Qualifier\r\n");

       org.okiproject.serviceapi.roles.Authorizations authList5 = null;
       org.okiproject.serviceapi.roles.Person  person5 = myFactory.newPerson ("cshubert");
       org.okiproject.serviceapi.roles.FunctionCategory category5 = myFactory.newFunctionCategory ("TEST");
       org.okiproject.serviceapi.roles.Qualifier qualifier5 = myFactory.newQualifier ("ORGU", "321000");

       authList5 = myFactory.getAuthsSimpleForm (
          person5,
 	      category5,
 	      qualifier5,
 	      FALSE,
 	      FALSE,
 	      FALSE
     );

      int cnt5 = 0;
      while (authList5.hasMoreAuthorizations()) {
 	     System.out.println("=== the list of the authorizations\r\n");
         org.okiproject.serviceapi.roles.Authorization auth5 = authList5.nextAuthorization();
		 cnt5++;
	 	 if(auth5!=null) print_authorization(auth5, myFactory);
	  }

	   System.out.println("The total authorization is " + cnt5);
	   System.out.println ("\r\nend of authorizations for API " + apiName + " for " + person5.getID());
	   System.out.println ();

 }


 static void test_getAuthsForDoingFWithQ(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

     String apiName = "getAuthsForDoingFWithQ";

    /**********************************************************
     * Test 1   given Function and Qualifier arguments
     **********************************************************/
    System.out.println("No.1 test api :  "+ apiName +"===>Given a function and a qualifier\r\n");

    org.okiproject.serviceapi.roles.Authorizations authList1 = null;

	org.okiproject.serviceapi.roles.Function function1 = myFactory.newFunction ("TEST", "TESTFUN1");

    org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ("ORGU", "321000");

    System.out.println("is the function in roles: " + myFactory.isFunctionFoundInRoles(function1).booleanValue());

    authList1 = myFactory.getAuthsForDoingFWithQ (
      function1,
      qualifier1,
      TRUE
    );


    int cnt1 = 0;
    while (authList1.hasMoreAuthorizations()) {
	 System.out.println("=== the list of the authorizations\r\n");
	 org.okiproject.serviceapi.roles.Authorization auth1 = authList1.nextAuthorization();
	 cnt1++;
	 if(auth1!=null) print_authorization(auth1, myFactory);
    }

       System.out.println("The total authorization is " + cnt1);
       System.out.println ("end of authorizations for API " + apiName + " for " + function1.getName());
       System.out.println ();


    /**********************************************************
     * Test 2 given FunctionCategory and Qualifier arguments
     **********************************************************/
    System.out.println("No.2 test api :  "+ apiName +"===>Given a functionCategory and a qualifier\r\n");

    org.okiproject.serviceapi.roles.Authorizations authList2 = null;
    org.okiproject.serviceapi.roles.FunctionCategory category2 = myFactory.newFunctionCategory ("TEST");
    org.okiproject.serviceapi.roles.Qualifier qualifier2 = myFactory.newQualifier ("ORGU", "321000");

    authList2 = myFactory.getAuthsForDoingFWithQ (
      category2,
      qualifier2,
      TRUE
    );


    int cnt2 = 0;
     while (authList2.hasMoreAuthorizations()) {
		 System.out.println("=== the list of the authorizations\r\n");
		 org.okiproject.serviceapi.roles.Authorization auth2 = authList2.nextAuthorization();
		 cnt2++;
		 if(auth2!=null) print_authorization(auth2, myFactory);
    }

	System.out.println("The total authorization is " + cnt2);
	System.out.println ("end of authorizations for API " + apiName + " for " + category2.getCategory());
	System.out.println ();
  }

 static void test_getWhoCanDo(org.okiproject.serviceapi.roles.RolesFactory myFactory)
             throws Exception{

     String apiName = "test_getWhoCanDo";

    /**********************************************************
     * Test 1   given Function and Qualifier arguments
     **********************************************************/
    System.out.println("No.1 test api :  "+ apiName +"===>Given a function and a qualifier\r\n");

    org.okiproject.serviceapi.common.Agents  peopleList1 = null;
	org.okiproject.serviceapi.roles.Function function1 = myFactory.newFunction ("TEST", "TESTFUN1");
    org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ("ORGU", "321000");
    peopleList1 = myFactory.getWhoCanDo(
      function1,
      qualifier1,
      TRUE
    );

    int cnt1 = 0;
    while (peopleList1.hasMoreAgents()) {
		Object obj1 = peopleList1.nextAgent();
		org.okiproject.serviceapi.roles.Person person1 = (org.okiproject.serviceapi.roles.Person)obj1;
		if(person1!=null) print_person(person1, myFactory);
		cnt1++;
    }

       System.out.println("The total number of Person is " + cnt1);
       System.out.println ("end of people for API " + apiName + " for " + function1.getName());
       System.out.println ();

    /**********************************************************
     * Test 2   given a Function  argument
     **********************************************************/
    System.out.println(" test api :  "+ apiName +"===>Given a function \r\n");

    org.okiproject.serviceapi.common.Agents  peopleList2 = null;
    //org.okiproject.serviceapi.roles.People peopleList2 = null;

	org.okiproject.serviceapi.roles.Function function2 = myFactory.newFunction ("TEST", "BUILD BUDGETS");

    peopleList2 = myFactory.getWhoCanDo(
      function2,
      TRUE
    );

    int cnt2 = 0;
    while (peopleList2.hasMoreAgents()) {
		Object obj = peopleList2.nextAgent();
		System.out.println("object type is : " + obj.getClass().getName());
        org.okiproject.serviceapi.roles.Person person2 = (org.okiproject.serviceapi.roles.Person)obj;
		if(person2!=null) print_person(person2, myFactory);
		cnt2++;
    }

   System.out.println("The total number of Person is " + cnt2);
   System.out.println ("end of people for API " + apiName + " for " + function2.getName());
   System.out.println ();

    /**********************************************************
     * Test 3  given a FunctionCategory  argument
     **********************************************************/
  System.out.println("No.3 test api :  "+ apiName +"===>Given a functionCategory \r\n");

    org.okiproject.serviceapi.common.Agents  peopleList3 = null;
    org.okiproject.serviceapi.roles.FunctionCategory category3 = myFactory.newFunctionCategory ("GRAD");

    peopleList3 = myFactory.getWhoCanDo(
      category3,
      TRUE
    );

    int cnt3 = 0;
    while (peopleList3.hasMoreAgents()) {
		Object obj3 = peopleList3.nextAgent();
		System.out.println("object type is : " + obj3.getClass().getName());
        org.okiproject.serviceapi.roles.Person person3 = (org.okiproject.serviceapi.roles.Person)obj3;
		if(person3!=null) print_person(person3, myFactory);
		cnt3++;
    }

       System.out.println("The total number of Person is " + cnt3);
       System.out.println ("end of people for API " + apiName + " for " + category3.getCategory());
       System.out.println ();


    /***********************************************************
     * Test 4  given a FunctionCategory and a qualifier arguments
     ***********************************************************/
    System.out.println("No.4 test api :  "+ apiName +"===>Given a functionCategory + Qualifier\r\n");

    org.okiproject.serviceapi.common.Agents  peopleList4 = null;
    org.okiproject.serviceapi.roles.FunctionCategory category4 = myFactory.newFunctionCategory ("TEST");
    org.okiproject.serviceapi.roles.Qualifier qualifier4 = myFactory.newQualifier ("ORGU", "321000");
    peopleList4 = myFactory.getWhoCanDo(
      category4,
      qualifier4,
      TRUE
    );

    int cnt4 = 0;
    while (peopleList4.hasMoreAgents()) {
		Object obj4 = peopleList4.nextAgent();
		System.out.println("object type is : " + obj4.getClass().getName());
        org.okiproject.serviceapi.roles.Person person4 = (org.okiproject.serviceapi.roles.Person)obj4;
		if(person4!=null) print_person(person4, myFactory);
		cnt4++;
    }

       System.out.println("The total number of Person is " + cnt4);
       System.out.println ("end of people for API " + apiName + " for " + category4.getCategory());
       System.out.println ();

	   /***********************************************************
		* Test 5  given a qualifier arguments //Failed to test wait for DB
		***********************************************************/
	  /* System.out.println("No.5 test api :  "+ apiName +"===>Given a  Qualifier\r\n");

	   org.okiproject.serviceapi.common.Agents  peopleList5 = null;

	   org.okiproject.serviceapi.roles.Qualifier qualifier5 = myFactory.newQualifier ("FUND", "F1652700");


	   peopleList5= myFactory.getWhoCanDo(
		 qualifier5,
		 TRUE
	   );


	   int cnt5 = 0;
	   while (peopleList5.hasMoreAgents()) { // Print the list of auths.
		 System.out.println ("The person Key is: " + (peopleList5.nextAgent()).getID());
		 cnt5++;
	   }

		  System.out.println("The total number of Person is " + cnt5);
		  System.out.println ("end of people for API " + apiName + " for " + qualifier5.getCode());
		  System.out.println ();
*/

  }

static void test_getCurrentAuthorizationFields(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

    String apiName = "getCurrentAuthorizationFields";

    System.out.println("test api :  "+ apiName +"\r\n");

	org.okiproject.serviceapi.roles.Field[] fields_= myFactory.getCurrentAuthorizationFields();

    System.out.println("\r\n Currently there are  " + fields_.length + " Authorization fields");

    for (int i = 0; i<fields_.length;i++){
	 System.out.println("\r\n the name of Field " + (i+1) + " is " + fields_[i].getName());

	}

    System.out.println ("\r\n End of test for API " + apiName );
    System.out.println ();
}


static void test_getCurrentPersonFields(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

    String apiName = "getCurrentPersonFields";

    System.out.println("test api :  "+ apiName +"\r\n");

	org.okiproject.serviceapi.roles.Field[] fields_= myFactory.getCurrentPersonFields();

    System.out.println("\r\n Currently there are  " + fields_.length + " Person fields");

    for (int i = 0; i<fields_.length;i++){
	 System.out.println("\r\n the name of Field " + (i+1) + " is " + fields_[i].getName());

	}

    System.out.println ("\r\n End of test for API " + apiName );
    System.out.println ();
}

static void test_getCurrentFunctionFields(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

    String apiName = "getCurrentFunctionFields";

    System.out.println("test api :  "+ apiName +"\r\n");

	org.okiproject.serviceapi.roles.Field[] fields_= myFactory.getCurrentPersonFields();

    System.out.println("\r\n Currently there are  " + fields_.length + " Function fields");

    for (int i = 0; i<fields_.length;i++){
	 System.out.println("\r\n the name of Field " + (i+1) + " is " + fields_[i].getName());

	}

    System.out.println ("\r\n End of test for API " + apiName );
    System.out.println ();
}

static void test_getCurrentQualifierFields(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

    String apiName = "getCurrentQualifierFields";

    System.out.println("test api :  "+ apiName +"\r\n");

	org.okiproject.serviceapi.roles.Field[] fields_= myFactory.getCurrentQualifierFields();

    System.out.println("\r\n Currently there are  " + fields_.length + " Qualifier fields");

    for (int i = 0; i<fields_.length;i++){
	 System.out.println("\r\n the name of Field " + (i+1) + " is " + fields_[i].getName());

	}

    System.out.println ("\r\n End of test for API " + apiName );
    System.out.println ();
}

static void test_getFunctionsInCategory(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

    String apiName = "getFunctionsInCategory";

    System.out.println("test api :  "+ apiName +"==> Given a Function Category \r\n");

    org.okiproject.serviceapi.roles.FunctionCategory category = myFactory.newFunctionCategory ("GRAD");

	org.okiproject.serviceapi.roles.Functions functionList = myFactory.getFunctionsInCategory(
		                                                     category);
    int cnt = 0;
    while (functionList.hasMoreFunctions()) {
      System.out.println ("The function name is ==> " + (functionList.nextFunction()).getName());
      cnt++;
    }

    System.out.println("The total number of function is " + cnt);
    System.out.println ("end of the test for API " + apiName + " for functionCategory" + category.getCategory());
    System.out.println ();

}


static void test_getRootQualifier(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

    String apiName = "test_getRootQualifier";

    System.out.println("test api :  "+ apiName +"==> Given a Qualifier Type \r\n");

    org.okiproject.serviceapi.roles.QualifierType qt = myFactory.newQualifierType ("SPGP");

    System.out.println("is the qualifier type found in roles : " + (myFactory.isQualifierTypeFoundInRoles(qt)).toString());

    org.okiproject.serviceapi.roles.Qualifier qualifier = myFactory.getRootQualifier(qt);

    if ( qualifier != null ) {
     System.out.println("-- Root qualifier is: " + qualifier.getCode());
     print_qualifier( qualifier, myFactory );
    }
    System.out.println ("end of the test for API " + apiName + " for qualifier" + qualifier.getCode());
	System.out.println ();



}

static void test_getQualifierChildren(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

    String apiName = "test_getQualifierChildren";

    System.out.println("test api :  "+ apiName +"==> Given a Qualifier \r\n");

    org.okiproject.serviceapi.roles.Qualifier qualifier = myFactory.newQualifier ("SPGP", "SG_RLE");

    org.okiproject.serviceapi.roles.Qualifiers qualifiers = myFactory.getQualifierChildren(qualifier);

    int cnt = 0;
		 while (qualifiers.hasMoreQualifiers()) {
		     System.out.println("=== the list of the qualifiers\r\n");
             org.okiproject.serviceapi.roles.Qualifier q =
                           (org.okiproject.serviceapi.roles.Qualifier)qualifiers.nextQualifier();

		     print_qualifier( qualifier, myFactory );

		     cnt++;
		  }

           System.out.println("The total number of children qualifiers is " + cnt);

}



static void test_isAuthorized(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

    String apiName = "isAuthorized";

    System.out.println("test api :  "+ apiName +"===>Given a person, a function and a qualifier\r\n");

	org.okiproject.serviceapi.roles.Function function = myFactory.newFunction ("GRAD", "ADM_UPDATE_APPLICATION");

    org.okiproject.serviceapi.roles.Qualifier qualifier = myFactory.newQualifier ("FUND", "F1652700");

    org.okiproject.serviceapi.roles.Person  person = myFactory.newPerson ("repa");

    Boolean isAuthorized = myFactory.isAuthorized (
	  person,
      function,
      qualifier
    );

      System.out.println("the isAuthorizd is " + isAuthorized.booleanValue());

      String does = (isAuthorized.booleanValue()== true)?" ":" DOES NOT";

      System.out.println("The person " + person.getID() + does +" have the authorization on function "
                           + function.getName() + " and which qualifier code is " + qualifier.getCode());
      System.out.println ("\r\n End of test for API " + apiName );
      System.out.println ();
}



    /*************************************************************************
    ** Create a new Authorization
    ************************************************************************/

   public static void test_createAuthorization(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

    String apiName = "test_createAuthorization";

    /// test 1
    ///////////////////////////
    System.out.println("test api :  "+ apiName +"==> Given a function, a qualifier and a grantprivilege\r\n");

    org.okiproject.serviceapi.roles.Person  person1 = myFactory.newPerson ("cshubert");
    org.okiproject.serviceapi.roles.Function function1
                   = myFactory.newFunction ("TEST", "TESTFUN1");
    //org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ( "ORGU", "001702");
    //org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ( "ORGU", "321000");
    org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ( "ORGU", "441020");

    //org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ("COST", "I3642600");
    //  org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ("SPGP", "SG_RLE");
    //org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ("COST", "C1450000");
    org.okiproject.serviceapi.roles.GrantPrivilege priv1
        = myFactory.newGrantPrivilege( org.okiproject.serviceapi.roles.GrantPrivilege.NOTGRANTABLE );
    org.okiproject.serviceapi.roles.Authorization authorization1= null ;
    try {
      authorization1 = myFactory.createAuthorization
               ( person1, function1, qualifier1, priv1, TRUE);
      System.out.println (person1.getID()
                          + " is now authorized to do Function "
                          + function1.getName()
                          +"\nwith qualifier "
                          +qualifier1.getCode()
                          +" with type "
                          +qualifier1.getQualifierType().getType()
                          +"\nstarting on "
                          +authorization1.getEffectiveDate()
                          );
      System.out.println ();
      print_authorization(authorization1, myFactory);
    }
    catch (Exception ex1) {
    }

    /// test2
    ////////////
   System.out.println("test api :  "+ apiName +"==> Given a function, a qualifier and a grantprivilege and time\r\n");

	org.okiproject.serviceapi.roles.Person person2 = myFactory.newPerson ("bibolai");
	org.okiproject.serviceapi.roles.Function function2
	                   = myFactory.newFunction ("TEST", "TESTFUN1");
    org.okiproject.serviceapi.roles.Qualifier qualifier2 = myFactory.newQualifier ( "ORGU", "000405");
   //org.okiproject.serviceapi.roles.Qualifier qualifier2 = myFactory.newQualifier ("COST", "I3642600");
   org.okiproject.serviceapi.roles.GrantPrivilege priv2
	        = myFactory.newGrantPrivilege( org.okiproject.serviceapi.roles.GrantPrivilege.NOTGRANTABLE );

    java.util.GregorianCalendar effCal
      = new java.util.GregorianCalendar (2001, java.util.Calendar.NOVEMBER, 1) ;
    long effTime = effCal.getTime().getTime() ;
    java.sql.Timestamp effDate = new java.sql.Timestamp( effTime ) ;
    java.util.GregorianCalendar expCal
      = new java.util.GregorianCalendar (2001, java.util.Calendar.NOVEMBER ,2) ;
    long expTime = expCal.getTime().getTime() ;
    java.sql.Timestamp expDate = new java.sql.Timestamp( expTime ) ;

	org.okiproject.serviceapi.roles.Authorization authorization2= null ;
	try {
	      authorization2 = myFactory.createAuthorization
	               ( person2, function2, qualifier2, priv2, TRUE, effDate,expDate);
	      System.out.println (person2.getID()
	                          + " is now authorized to do Function "
	                          + function2.getName()
	                          +"\nwith qualifier "
	                          +qualifier2.getCode()
	                          +" with type "
	                          +qualifier2.getQualifierType().getType()
	                          +"\nstarting on "
	                          +authorization2.getEffectiveDate()
	                          );
	      System.out.println ();
	      print_authorization(authorization2, myFactory);
	    }
	    catch (Exception ex2) {
    }

}


  /*************************************************************************
    ** Create ... Update ... and delete an Authorization
    ************************************************************************/

    public static void test_updateAuth(org.okiproject.serviceapi.roles.RolesFactory myFactory)
    throws Exception{

		 org.okiproject.serviceapi.roles.Person  person4 = myFactory.newPerson ("cshubert");
		 org.okiproject.serviceapi.roles.Function function4
		                   = myFactory.newFunction ("TEST", "TESTFUN1");
		 System.out.println ("\r\n function "+ function4.getName() + " found in Roles ?: " + (myFactory.isFunctionFoundInRoles(function4)).booleanValue());

		 org.okiproject.serviceapi.roles.Qualifier qualifier4 = myFactory.newQualifier ("ORGU", "441300");
		 System.out.println ("\r\n qualifier4 "+ qualifier4.getCode() + " found in Roles ?: " + (myFactory.isQualifierFoundInRoles(qualifier4)).booleanValue());

		 org.okiproject.serviceapi.roles.GrantPrivilege priv4
		        = myFactory.newGrantPrivilege( org.okiproject.serviceapi.roles.GrantPrivilege.NOTGRANTABLE );
		 org.okiproject.serviceapi.roles.Authorization authorization4 = null ;
         System.out.println("break point");

		 authorization4 = myFactory.createAuthorization
		                 ( person4, function4, qualifier4, priv4, TRUE);
		 print_authorization(  authorization4, myFactory);
		 System.out.println (person4.getID()
		                          + " is now authorized to do Function "
		                          + function4.getName()
		                          +"\nwith qualifier "
		                          +qualifier4.getCode()
		                          +" with type "
		                          +qualifier4.getQualifierType().getType()
		                          +"\nstarting on "
		                          +authorization4.getEffectiveDate()
                          );


    priv4
        = myFactory.newGrantPrivilege ( org.okiproject.serviceapi.roles.GrantPrivilege.GRANTABLEFORGRANTING );
    java.util.GregorianCalendar effCal
      = new java.util.GregorianCalendar (2002, java.util.Calendar.NOVEMBER, 1) ;
    long effTime = effCal.getTime().getTime() ;
    java.sql.Timestamp effDate = new java.sql.Timestamp( effTime ) ;
    java.util.GregorianCalendar expCal
      = new java.util.GregorianCalendar (2002, java.util.Calendar.NOVEMBER ,2) ;
    long expTime = expCal.getTime().getTime() ;
    java.sql.Timestamp expDate = new java.sql.Timestamp( expTime ) ;
    try {
      myFactory.updateAuthorization
        (authorization4,person4, function4, qualifier4, priv4, TRUE, effDate, expDate);
      System.out.println ("updated starting on "
                          +authorization4.getEffectiveDate()
                          +" until "
                          +authorization4.getExpirationDate()
                          +"\nmodified: "
                          +authorization4.getModifiedDate()
                          );

      System.out.println ("\r\nThen delete it ");

      myFactory.deleteAuthorization(authorization4);

    }
    catch (Exception ex4) {
    }

}


 public static void test_newObjects(org.okiproject.serviceapi.roles.RolesFactory myFactory)
 throws Exception {


  //new Person by key
  org.okiproject.serviceapi.roles.Person  person1 = myFactory.newPerson ("bibolai");
  org.okiproject.serviceapi.roles.Person  person2 = myFactory.newPerson ("repa");

  System.out.println ("key "+person1.getID() + " found in Roles ?: " + (myFactory.isPersonFoundInRoles(person1)).booleanValue());

  System.out.println ("\r\n key "+person2.getID() + " found in Roles ?: " + (myFactory.isPersonFoundInRoles(person2)).booleanValue());


  ///--- create function instance --------
  // given by a string of functionCategory and a string of function name
  org.okiproject.serviceapi.roles.Function function1 = myFactory.newFunction ("TEST", "TESTFUN1");
  org.okiproject.serviceapi.roles.Function function2 = myFactory.newFunction ("GRAD", "ADM_UPDATE_APPLICATION");

 System.out.println ("\r\n function "+ function1.getName() + " found in Roles ?: " + (myFactory.isFunctionFoundInRoles(function1)).booleanValue());
 System.out.println ("\r\n function "+ function2.getName() + " found in Roles ?: " + (myFactory.isFunctionFoundInRoles(function2)).booleanValue());

// given by a type of functionCategory and a string of function name
  org.okiproject.serviceapi.roles.FunctionCategory fc = myFactory.newFunctionCategory ("GRAD");
  org.okiproject.serviceapi.roles.Function function3 = myFactory.newFunction (fc, "ADM_UPDATE_APPLICATION");

  System.out.println ("\r\n function "+ function3.getName() + " found in Roles ?: " + (myFactory.isFunctionFoundInRoles(function3)).booleanValue());

////----create function category

  org.okiproject.serviceapi.roles.FunctionCategory fc2 = myFactory.newFunctionCategory ("GRAD");
  System.out.println ("\r\n function "+ fc2.getCategory() + " found in Roles ?: " + (myFactory.isFunctionCategoryFoundInRoles(fc2)).booleanValue());


////----create grantPrivilege

 org.okiproject.serviceapi.roles.GrantPrivilege gp = myFactory.newGrantPrivilege (org.okiproject.serviceapi.roles.GrantPrivilege.GRANTABLE);
 System.out.println ("\r\n GrantPrivilege "+ gp.toString() + " grantable is  " + gp.isGrantable());

////----create qualifier

 org.okiproject.serviceapi.roles.Qualifier q1 = myFactory.newQualifier ("COST", "I3642600");
 System.out.println ("\r\n Qualifier "+ q1.getCode());

 org.okiproject.serviceapi.roles.QualifierType    qt = myFactory.newQualifierType("COST");
 org.okiproject.serviceapi.roles.Qualifier q2 = myFactory.newQualifier (qt, "I3642600");
 System.out.println ("\r\n Qualifier "+ q2.getCode());

 }


 public static void test_new_refresh(org.okiproject.serviceapi.roles.RolesFactory myFactory)
   throws Exception {

 String apiName =  "test_new_refresh objects";

 System.out.println("test api :  "+ apiName +"\r\n");

 //----test qualifier by given a qualifierType and qualifierCode :both are String
  org.okiproject.serviceapi.roles.Qualifier q1 = myFactory.newQualifier ("COST", "I3642600");
  do_test_new_qualifier(q1,myFactory);

 //---- test qualifier by given a qualifierType (type object) and qualifierCode
  org.okiproject.serviceapi.roles.QualifierType    qt = myFactory.newQualifierType("COST");
  org.okiproject.serviceapi.roles.Qualifier q2 = myFactory.newQualifier (qt, "I3642600");
  do_test_new_qualifier(q2,myFactory);

///------------------------------------PERSON---------------------------------------------///
  org.okiproject.serviceapi.roles.Person  person1 = myFactory.newPerson ("bibolai");
  do_test_new_person(person1,myFactory);

  org.okiproject.serviceapi.roles.Person  person2 = myFactory.newPerson ("repa");
  do_test_new_person(person2,myFactory);

//----------------------------------QUALIFIER TYPE----------------------------------------//
  org.okiproject.serviceapi.roles.QualifierType    qt1 = myFactory.newQualifierType("COST");
  do_test_new_qualifierType(qt1, myFactory);

// ---------------------------- FUNCTION -------------------------------------------------//
  org.okiproject.serviceapi.roles.Function function3 = myFactory.newFunction ("TEST", "TESTFUN1");
  do_test_new_function(function3, myFactory);

  //given a  functioncategory object and name
  org.okiproject.serviceapi.roles.FunctionCategory fc = myFactory.newFunctionCategory ("GRAD");
  if(myFactory.isFunctionCategoryFoundInRoles(fc).booleanValue()){
    System.out.println("ok-- the function category exists\r");
    org.okiproject.serviceapi.roles.Function function4 = myFactory.newFunction (fc, "ADM_UPDATE_APPLICATION");
   do_test_new_function(function4, myFactory);}
}


public static void do_test_new_qualifier(org.okiproject.serviceapi.roles.Qualifier q,
                                         org.okiproject.serviceapi.roles.RolesFactory myFactory)
                                          throws Exception{
 System.out.println("\r\n--> before calling refresh:\r\n");

 print_qualifier(q,myFactory);

 System.out.println("\r\n--> after calling refresh:\r\n");

 myFactory.refreshQualifier(q);

 print_qualifier(q,myFactory);

}


 public static void do_test_new_person(org.okiproject.serviceapi.roles.Person person,
                                          org.okiproject.serviceapi.roles.RolesFactory myFactory)
                                           throws Exception{
  System.out.println("\r\n--> before calling refresh:\r\n");

  print_person(person,myFactory);

  System.out.println("\r\n--> after calling refresh:\r\n");

  myFactory.refreshPerson(person);

  print_person(person,myFactory);

 }


public static void do_test_new_qualifierType(org.okiproject.serviceapi.roles.QualifierType qt,
                                         org.okiproject.serviceapi.roles.RolesFactory myFactory)
                                          throws Exception{
 System.out.println("\r\n--> before calling refresh:");

 print_qualifierType(qt,myFactory);

 System.out.println("\r\n--> after calling refresh:\r\n");

 myFactory.refreshQualifierType(qt);

 print_qualifierType(qt,myFactory);

}



 public static void do_test_new_function(org.okiproject.serviceapi.roles.Function f,
                                          org.okiproject.serviceapi.roles.RolesFactory myFactory)
                                           throws Exception{
  System.out.println("\r\n--> before calling refresh:");

  print_function(f,myFactory);

  //System.out.println("\r\n--> after calling refresh:\r\n");

  if (f != null) {
      System.out.println("\r\n--> after calling refresh:\r\n");
     myFactory.refreshFunction(f);
   }
  print_function(f,myFactory);
 }



  public static void test_getMinimumPersonfields(org.okiproject.serviceapi.roles.RolesFactory myFactory)
   throws Exception {

  String apiName =  "test_getMinimumPersonfields";

  System.out.println("test api :  "+ apiName +"\r\n");

  org.okiproject.serviceapi.roles.Field[] f = myFactory.getMinimumPersonFields();

  System.out.println("the length of the array is " + f.length);

}

  public static void test_getDefaultPersonFields(org.okiproject.serviceapi.roles.RolesFactory myFactory)
   throws Exception {

  String apiName =  "test_getDefaultPersonFields";

  System.out.println("test api :  "+ apiName +"\r\n");

  org.okiproject.serviceapi.roles.Field[] f = myFactory.getDefaultPersonFields();

  System.out.println("the length of the array is " + f.length);


}

  public static void test_getCompletePersonFields(org.okiproject.serviceapi.roles.RolesFactory myFactory)
   throws Exception {

  String apiName =  "test_getCompletePersonFields";

  System.out.println("test api :  "+ apiName +"\r\n");

  org.okiproject.serviceapi.roles.Field[] f = myFactory.getCompletePersonFields();

  System.out.println("the length of the array is " + f.length);

}

 public static void test_createFunction(org.okiproject.serviceapi.roles.RolesFactory myFactory)
   throws Exception {

  String apiName =  "test_createFunction ==> given by function name" +
                    "function description and FunctionCategory object and " +
                    " Qualifier type object \r\n";

  System.out.println("test api :  "+ apiName +"\r\n");

  org.okiproject.serviceapi.roles.FunctionCategory fc = myFactory.newFunctionCategory ("TEST");
  org.okiproject.serviceapi.roles.QualifierType    qt = myFactory.newQualifierType("SPGP");
  org.okiproject.serviceapi.roles.Function   function = myFactory.createFunction("FUNCTION_API_SPGP888",
                                                                               "test create a function",
                                                                               fc,qt);

 System.out.println("Created function!");

 print_function ( function, myFactory );

 System.out.println("\r\nUpdate after create");

 myFactory.updateFunction(function,"FUNCTION_NEW_SPGP1_BIBO", "test update", fc, qt);

 System.out.println("\r\nUpdate ok!!! before refresh");

 myFactory.refreshFunction(function);

 print_function(function, myFactory);
 System.out.println("--Now function name is: " + function.getName());

 System.out.println("--Now function description is: " + function.getDescription());

 System.out.println(function.getModifiedBy());

 System.out.println("\r\ndelete the function just ceated");

 myFactory.deleteFunction(function);

 System.out.println("\r\n function deleted!");

}


 public static void test_createQualifier(org.okiproject.serviceapi.roles.RolesFactory myFactory)
   throws Exception {

  String apiName =  "test_createQualifier ==> given by QualifierType object" +
                    "qualifierCode and qualifierDescription and " +
                    " parent a Qalifier \r\n";

  System.out.println("test api :  "+ apiName +"\r\n");

  //get the parent
  org.okiproject.serviceapi.roles.QualifierType qt = myFactory.newQualifierType ("SPGP");

  org.okiproject.serviceapi.roles.Qualifier parent = myFactory.getRootQualifier(qt);

  org.okiproject.serviceapi.roles.Qualifier qualifier = myFactory.createQualifier(
	                                                     qt,
	                                                     "SG_BOGUS_BIBO4",
                                                         "CREATE AND UPDATE",
                                                         parent);
   System.out.println("Qualifier created!");

   print_qualifier ( qualifier, myFactory );

   myFactory.updateQualifier(qualifier,"SG_NEW_CODE4", "TEST UPDATE");

   System.out.println("Update OK1\r\n");

   System.out.println("new code is " + qualifier.getCode());

   System.out.println("Test Create and update done!");

   myFactory.refreshQualifier(qualifier);

   System.out.println("after refresh, what is the code of the qulifier:" + qualifier.getCode());

   myFactory.deleteQualifier(qualifier);

   System.out.println("delete qualifier done!");

}




/********************************************************************************************/
/*                   Start Printing                                                         */
/********************************************************************************************/
  public static void print_function(org.okiproject.serviceapi.roles.Function f
                                     ,org.okiproject.serviceapi.roles.RolesFactory myFactory)
                                      throws Exception{

  System.out.println("======= beginning of function info ========\n");

  System.out.println (" 1. function id is : "+ f.getId());

  System.out.println (" 2. function name is : "+ f.getName());

  if(f.getDescription()!=null)
    System.out.println ("\r\n 3. function description is : "+ f.getDescription());
  else
    System.out.println ("\r\n 3. function description is : null");

  if(f.getFunctionCategory()!=null)
   System.out.println("\r\n 4. function category is : " + f.getFunctionCategory().getCategory());
  else
    System.out.println("\r\n 4. function category is : null");

  if ( f.getQualifierType() != null) print_qualifierType(f.getQualifierType(), myFactory);
  else System.out.println("\r\n 5. Qualifier type of this function is null -- ");

  //System.out.println (" 6. function's PRIMARY_AUTHORIZABLE : "+ f.getPrimaryAuthorizable());

  System.out.println (" 6. function's modified by : "+ f.getModifiedBy());

  System.out.println (" 7. function's modifiedDate : "+ f.getModifiedDate());

  System.out.println("\r\n 8. is this function in roles: "+ myFactory.isFunctionFoundInRoles(f));

  System.out.println("======= end of function info ========\n\r");

 }

 public static void print_qualifierType(org.okiproject.serviceapi.roles.QualifierType qt
                                    ,org.okiproject.serviceapi.roles.RolesFactory myFactory)
                                     throws Exception{

 System.out.println("======= beginning of Qualifier Type info ========\n");

 System.out.println (" 1. Qualifiertype type is : "+ qt.getType());

 System.out.println ("\r\n 2. Qualifier type description is : "+ qt.getDescription());

 System.out.println("\r\n 4. is this qulaifier is roles: "+ myFactory.isQualifierTypeFoundInRoles(qt));

 System.out.println("======= end of Qualifier type info ========\n\r");
 }


 public static void print_grant(org.okiproject.serviceapi.roles.GrantPrivilege gp
                                    ,org.okiproject.serviceapi.roles.RolesFactory myFactory)
                                     throws Exception{

 System.out.println("======= beginning of GrantPrivilege info ========\n");

 System.out.println (" 1. is grantable? : "+ gp.isGrantable());

 System.out.println ("\r\n 2. is GrantableForGranting: "+ gp.isGrantableForGranting());

 System.out.println("======= end of GrantPrivilege info ========\n\r");
 }

  public static void print_person(org.okiproject.serviceapi.roles.Person person
                                     ,org.okiproject.serviceapi.roles.RolesFactory myFactory)
                                      throws Exception{
  System.out.println("======= beginning of Person info ========\n");

  System.out.println (" 1. Person id is : "+ person.getID());

  System.out.println ("\r\n 2. Person  name is : "+ person.getName());

 // System.out.println ("\r\n 3. Person SSN is : "+ person.getSSN());

  //System.out.println ("\r\n 4. Person DOB is : "+ person.getDOB());

  //System.out.println ("\r\n 5. Person MIT id is : "+ person.getMitid());

  //String[] auth_types = person.getAuthenTypes();
  //byte[] credentials  = person.getCredentials();

  //StringBuffer bf1 = new StringBuffer();
  //StringBuffer bf2 = new StringBuffer();
/*
  if(auth_types!=null){
  for(int i = 0; i < auth_types.length; i++) bf1.append(auth_types[i] + " ,");
  System.out.println ("\r\n 6. Person auth types are : "+ bf1.toString());
  }
  //for(int j = 0; j < credentials.length; j++) bf2.append(credentials[j] + " ,");
  //System.out.println ("\r\n 6. Person credentials are : "+ bf2.toString());

  System.out.println("\r\n 7. is this person is roles: "+ myFactory.isPersonFoundInRoles(person));

  System.out.println("======= end of Person info ========\n\r");
*/ }


 public static void print_qualifier(org.okiproject.serviceapi.roles.Qualifier q
                                    ,org.okiproject.serviceapi.roles.RolesFactory myFactory)
                                     throws Exception{

 System.out.println("======= beginning of Qualifier info ========\n");

 System.out.println (" 1. Qualifier id is : "+ q.getId());

 System.out.println ("\r\n 2. Qualifier description is : "+ q.getDescription());

 System.out.println ("\r\n 3. Qualifier Code is : "+ q.getCode());

 if ( q.getQualifierType() != null) print_qualifierType(q.getQualifierType(), myFactory);
 else System.out.println("\r\n --- Qualifier type is null -- ");

 System.out.println("\r\n 4. Does it has child : "+ q.getHasChild().booleanValue());

 System.out.println("\r\n 5. is this qulaifier is roles: "+ myFactory.isQualifierFoundInRoles(q));

 System.out.println("======= end of Qualifier info ========\n\r");
 }


 static void print_authorization(org.okiproject.serviceapi.roles.Authorization auth
                                ,org.okiproject.serviceapi.roles.RolesFactory myFactory)
   throws Exception{

   System.out.println("======= beginning of Auth info ========\n");
   Object id = auth.getId();
   if (id != null) System.out.println("Authorization Id is : " + id.toString());

   org.okiproject.serviceapi.roles.Qualifier qualifier = auth.getQualifier();
   if(qualifier!=null) print_qualifier(qualifier, myFactory);
   else System.out.println("Qualifier for this authorization is null!\r\n");

   org.okiproject.serviceapi.roles.Function function = auth.getFunction();
   if(function!=null) print_function(function, myFactory);
   else System.out.println("Function for this authorization is null!\r\n");

   org.okiproject.serviceapi.roles.Person person = auth.getPerson();
   if(person!=null) print_person(person, myFactory);
   else System.out.println("Person for this authorization is null!\r\n");

   System.out.println("Authorization's modified date is: " + auth.getModifiedDate());
   System.out.println("Authorization's modified_by is: " + auth.getModifiedBy());
   System.out.println("Authorization's Effective date is: " + auth.getEffectiveDate());
   System.out.println("Authorization's Expiration date is: " + auth.getExpirationDate());
   if(auth.isActiveNow()!=null)
   System.out.println("Authorization's is active now is: " + auth.isActiveNow().booleanValue());

   org.okiproject.serviceapi.roles.GrantPrivilege canForUserGrant = auth.getCanForUserGrant();
   if ( null != canForUserGrant ) print_grant(canForUserGrant, myFactory);
   else System.out.println("CanForUserGrant for this authorization is null!\r\n");

   org.okiproject.serviceapi.roles.GrantPrivilege grant = auth.getGrant();
   if ( null != grant ) print_grant(grant, myFactory);
   else System.out.println("Grant for this authorization is null!\r\n");

   System.out.println("======= end of Auth info ========\n\r");
}

/********************************************************************************************/
/*                   End of Printing                                                        */
/********************************************************************************************/


  public static void main (String[] args) {

   try {

    // Show the user the list of symbolic DB Names.
    String[] symbolicDBnameChoices
    	= org.okiproject.serviceapi.roles.RolesFactory.getDatabaseSymbolicNames();
    System.out.println( "Symbolic DB name choices:" ) ;
    for( int i = 0 ; symbolicDBnameChoices.length != i ; i ++ )
    {
      System.out.println( "     " + symbolicDBnameChoices[ i ] ) ;
    }

     System.out.println ("end of name choices") ;
     System.out.println () ;

     org.okiproject.serviceapi.roles.RolesFactory rf = getDefaultRolesFactory();


//    test_getAuthsSimpleForm(rf);  //4 impl tests
//    test_getWhoCanDo(rf); //5 tests but the last one failed. Need to understand the logic
//    test_getAuthsForDoingFWithQ(rf); // 2 impl tests
//    test_isAuthorized(rf);
//    test_getFunctionsInCategory(rf);
//    test_getRootQualifier(rf);
//    test_getQualifierChildren(rf);
//    test_createAuthorization(rf);   //in use
//    test_updateAuth(rf);   //create, update and delete
//    test_newObjects(rf);
//    test_new_refresh(rf);
//    test_createFunction(rf); //create and update and delete
//    test_createQualifier(rf);

       /* test_getCurrentAuthorizationFields(rf);
        test_getCurrentPersonFields(rf);
        test_getCurrentFunctionFields(rf);
        test_getCurrentQualifierFields(rf);
        test_getDefaultPersonFields(rf);
		test_getCompletePersonFields(rf);
        test_getCurrentPersonFields(rf); */    // FIELDS

       //test_getPeopleGeneralForm(rf); //not implemented
       //test_getMinimumPersonfields(rf); //unimplemented

    } //end of try

     catch(Exception exx) {
      exx.printStackTrace() ;
   }
  }
}
