
/**
 * Class roles_api_test2
 *
 *
 * @author
 * @version %I%, %G%
 */
public class roles_api_test2 {

  // Set some constants
  static final Boolean TRUE  = new Boolean(true);
  static final Boolean FALSE = new Boolean(false);

  /**
   * Method getDefaultRolesFactory
   *
   *
   * @return org.okiproject.serviceapi.roles.RolesFactory
   *
   * @throws Exception
   *
   */
  static org.okiproject.serviceapi.roles.RolesFactory getDefaultRolesFactory()
  throws Exception {

    return org.okiproject.serviceapi.roles.RolesFactory.getDefaultRolesFactory(
      "Roles", "test_roles");
  }

  /**
   * Method test_getAuthsSimpleForm
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getAuthsSimpleForm(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "getAuthsSimpleForm";

    /**********************************************************
     * given Person + functioncategory  arguments
     **********************************************************/
    System.out.println("No.1 test api :  " + apiName
                       + "===>Given at Person+functioncategory\r\n");

    org.okiproject.serviceapi.roles.Authorizations   authList1 = null;    //Person + FunctionCategory

    org.okiproject.serviceapi.common.Person          person1   =
      myFactory.newPerson("repa");

    org.okiproject.serviceapi.roles.FunctionCategory category1 =
      myFactory.newFunctionCategory("GRAD");

    authList1 = myFactory.getAuthsSimpleForm(person1,    // 1st argument is a person
                                             category1,    // 2nd argument is a function category
                                             TRUE,    // Let's only find auths. that are active today
                                             FALSE,    // Let's not expand Functions
                                             TRUE    // Let's expand Qualifier
                                               );

    System.out.println(person1.getID()
                       + " has the following authorizations in category: "
                       + category1.getCategory());

    int cnt1 = 0;

    while (authList1.hasMoreAuthorizations()) {    // Print the list of auths.
      System.out.println(authList1.nextAuthorization());

      cnt1++;
    }

    System.out.println("The total authorization is " + cnt1);
    System.out.println("end of authorizations for API " + apiName + " for "
                       + person1.getID());
    System.out.println();

    //test with only Person argument NOT_IMPLEMENTED

    /*    System.out.println("No.2 test api :  "+ apiName +"===>Given at Person \r\n");
        org.okiproject.serviceapi.roles.Authorizations authList2 = null;  //Person
        org.okiproject.serviceapi.common.Person person2 = myFactory.newPerson ("repa");
        authList2 = myFactory.getAuthsSimpleForm (
                  person2,        // 1st argument is a person
                  TRUE,           // Let's only find auths. that are active today
                  FALSE,          // Let's not expand Functions
                  TRUE            // Let's expand Qualifier
        );


             while (authList2.hasMoreAuthorizations()) { // Print the list of auths.
                 System.out.println (authList2.nextAuthorization());
             }

                   System.out.println ("end of authorizations for API " + apiName + " for " + person2.getID());
                   System.out.println ();
    */

    /**********************************************************
         * given Person  + function + qualifier  arguments
     **********************************************************/

    System.out.println("No.3 test api :  " + apiName
                       + "===>Given Person+function+qualifer\r\n");

    org.okiproject.serviceapi.roles.Authorizations authList3  = null;    //Person
    org.okiproject.serviceapi.common.Person        person3    =
      myFactory.newPerson("repa");
    org.okiproject.serviceapi.roles.Function       function3  =
      myFactory.newFunction("GRAD", "ADM_UPDATE_APPLICATION");
    org.okiproject.serviceapi.roles.Qualifier      qualifier3 =
      myFactory.newQualifier("FUND", "F1652700");

    authList3 = myFactory.getAuthsSimpleForm(person3, function3, qualifier3,
                                             TRUE,    // Let's only find auths. that are active today
                                             FALSE,    // Let's not expand Functions
                                             TRUE    // Let's expand Qualifier
                                               );

    while (authList3.hasMoreAuthorizations()) {    // Print the list of auths.
      System.out.println(authList3.nextAuthorization());
    }

    System.out.println("end of authorizations for API " + apiName + " for "
                       + person3.getID());
    System.out.println();

    /**********************************************************
     * given Person  + function  arguments
     **********************************************************/

    System.out.println("No.4 test api :  " + apiName
                       + "===> Given Person+function\r\n");

    org.okiproject.serviceapi.roles.Authorizations authList4 = null;    //Person
    org.okiproject.serviceapi.common.Person        person4   =
      myFactory.newPerson("repa");
    org.okiproject.serviceapi.roles.Function       function4 =
      myFactory.newFunction("GRAD", "ADM_UPDATE_APPLICATION");

    authList4 = myFactory.getAuthsSimpleForm(person4, function4, TRUE,    // Let's only find auths. that are active today
                                             FALSE,    // Let's not expand Functions
                                             TRUE    // Let's expand Qualifier
                                               );

    int cnt = 0;

    while (authList4.hasMoreAuthorizations()) {    // Print the list of auths.
      System.out.println("=== the list of the authorizations\r\n");

      System.out.println(authList4.nextAuthorization());

      cnt++;
    }

    System.out.println("The total authorization is " + cnt);
    System.out.println("\r\nend of authorizations for API " + apiName
                       + " for " + person4.getID());
    System.out.println();

    /**********************************************************
     * given Person  + functionCategory+Qualifier  arguments
     **********************************************************/

    System.out.println(
      "No.5 test api :  " + apiName
      + "===> Given Person + functionCategory + Qualifier\r\n");

    org.okiproject.serviceapi.roles.Authorizations   authList5  = null;    //Person
    org.okiproject.serviceapi.common.Person          person5    =
      myFactory.newPerson("repa");
    org.okiproject.serviceapi.roles.FunctionCategory category5  =
      myFactory.newFunctionCategory("GRAD");
    org.okiproject.serviceapi.roles.Qualifier        qualifier5 =
      myFactory.newQualifier("FUND", "F1652700");

    authList5 = myFactory.getAuthsSimpleForm(person5, category5, qualifier5,
                                             TRUE,    // Let's only find auths. that are active today
                                             FALSE,    // Let's not expand Functions
                                             TRUE    // Let's expand Qualifier
                                               );

    int cnt5 = 0;

    while (authList5.hasMoreAuthorizations()) {    // Print the list of auths.
      System.out.println("=== the list of the authorizations\r\n");

      System.out.println(authList5.nextAuthorization());

      cnt5++;
    }

    System.out.println("The total authorization is " + cnt5);
    System.out.println("\r\nend of authorizations for API " + apiName
                       + " for " + person4.getID());
    System.out.println();

  }

  /**
   * Method test_getAuthsForDoingFWithQ
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getAuthsForDoingFWithQ(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "getAuthsForDoingFWithQ";

    /**********************************************************
     * Test 1   given Function and Qualifier arguments
     **********************************************************/
    System.out.println("No.1 test api :  " + apiName
                       + "===>Given a function and a qualifier\r\n");

    org.okiproject.serviceapi.roles.Authorizations authList1  = null;

    org.okiproject.serviceapi.roles.Function       function1  =
      myFactory.newFunction("GRAD", "ADM_UPDATE_APPLICATION");

    org.okiproject.serviceapi.roles.Qualifier      qualifier1 =
      myFactory.newQualifier("FUND", "F1652700");

    authList1 = myFactory.getAuthsForDoingFWithQ(function1, qualifier1, TRUE);

    int cnt1 = 0;

    while (authList1.hasMoreAuthorizations()) {    // Print the list of auths.
      System.out.println(authList1.nextAuthorization());

      cnt1++;
    }

    System.out.println("The total authorization is " + cnt1);
    System.out.println("end of authorizations for API " + apiName + " for "
                       + function1.getName());
    System.out.println();

    /**********************************************************
     * Test 2 given FunctionCategory and Qualifier arguments
     **********************************************************/
    System.out.println("No.2 test api :  " + apiName
                       + "===>Given a functionCategory and a qualifier\r\n");

    org.okiproject.serviceapi.roles.Authorizations   authList2  = null;    //Person + FunctionCategory

    org.okiproject.serviceapi.roles.FunctionCategory category2  =
      myFactory.newFunctionCategory("GRAD");

    org.okiproject.serviceapi.roles.Qualifier        qualifier2 =
      myFactory.newQualifier("FUND", "F1652700");

    authList2 = myFactory.getAuthsForDoingFWithQ(category2, qualifier2, TRUE);

    int cnt2 = 0;

    while (authList2.hasMoreAuthorizations()) {    // Print the list of auths.
      System.out.println(authList2.nextAuthorization());

      cnt2++;
    }

    System.out.println("The total authorization is " + cnt2);
    System.out.println("end of authorizations for API " + apiName + " for "
                       + category2.getCategory());
    System.out.println();

  }

  /**
   * Method test_getWhoCanDo
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getWhoCanDo(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_getWhoCanDo";

    /**********************************************************
     * Test 1   given Function and Qualifier arguments
     **********************************************************/
    System.out.println("No.1 test api :  " + apiName
                       + "===>Given a function and a qualifier\r\n");

    org.okiproject.serviceapi.common.Agents   peopleList1 = null;    //Person + FunctionCategory

    org.okiproject.serviceapi.roles.Function  function1   =
      myFactory.newFunction("GRAD", "ADM_UPDATE_APPLICATION");

    org.okiproject.serviceapi.roles.Qualifier qualifier1  =
      myFactory.newQualifier("FUND", "F1652700");

    peopleList1 = myFactory.getWhoCanDo(function1, qualifier1, TRUE);

    int cnt1 = 0;

    while (peopleList1.hasMorePeople()) {
      System.out.println(peopleList1.nextPerson());

      cnt1++;
    }

    System.out.println("The total number of Person is " + cnt1);
    System.out.println("end of people for API " + apiName + " for "
                       + function1.getName());
    System.out.println();

    /**********************************************************
     * Test 2   given a Function  argument
     **********************************************************/
    System.out.println("No.2 test api :  " + apiName
                       + "===>Given a function \r\n");

    org.okiproject.serviceapi.common.Agents  peopleList2 = null;

    org.okiproject.serviceapi.roles.Function function2   =
      myFactory.newFunction("GRAD", "ADM_UPDATE_APPLICATION");

    peopleList2 = myFactory.getWhoCanDo(function2, TRUE);

    int cnt2 = 0;

    while (peopleList2.hasMorePeople()) {
      System.out.println(peopleList2.nextPerson());

      cnt2++;
    }

    System.out.println("The total number of Person is " + cnt2);
    System.out.println("end of people for API " + apiName + " for "
                       + function2.getName());
    System.out.println();

    /**********************************************************
     * Test 3  given a FunctionCategory  argument
     **********************************************************/
    System.out.println("No.3 test api :  " + apiName
                       + "===>Given a functionCategory \r\n");

    org.okiproject.serviceapi.common.Agents          peopleList3 = null;

    org.okiproject.serviceapi.roles.FunctionCategory category3   =
      myFactory.newFunctionCategory("GRAD");

    peopleList3 = myFactory.getWhoCanDo(category3, TRUE);

    int cnt3 = 0;

    while (peopleList3.hasMorePeople()) {    // Print the list of auths.
      System.out.println("The person Key is: "
                         + (peopleList3.nextPerson()).getID());

      cnt3++;
    }

    System.out.println("The total number of Person is " + cnt3);
    System.out.println("end of people for API " + apiName + " for "
                       + category3.getCategory());
    System.out.println();

    /***********************************************************
     * Test 4  given a FunctionCategory and a qualifier arguments
     ***********************************************************/
    System.out.println("No.4 test api :  " + apiName
                       + "===>Given a functionCategory + Qualifier\r\n");

    org.okiproject.serviceapi.common.Agents          peopleList4 = null;

    org.okiproject.serviceapi.roles.FunctionCategory category4   =
      myFactory.newFunctionCategory("GRAD");

    org.okiproject.serviceapi.roles.Qualifier        qualifier4  =
      myFactory.newQualifier("FUND", "F1652700");

    peopleList4 = myFactory.getWhoCanDo(category4, qualifier4, TRUE);

    int cnt4 = 0;

    while (peopleList4.hasMorePeople()) {
      System.out.println("The person Key is: "
                         + (peopleList4.nextPerson()).getID());

      cnt4++;
    }

    System.out.println("The total number of Person is " + cnt4);
    System.out.println("end of people for API " + apiName + " for "
                       + category4.getCategory());
    System.out.println();

    /***********************************************************
         * Test 5  given a qualifier arguments //Failed to test wait for DB
         ***********************************************************/

    /* System.out.println("No.5 test api :  "+ apiName +"===>Given a  Qualifier\r\n");

     org.okiproject.serviceapi.roles.People peopleList5 = null;

     org.okiproject.serviceapi.roles.Qualifier qualifier5 = myFactory.newQualifier ("FUND", "F1652700");


     peopleList5= myFactory.getWhoCanDo(
           qualifier5,
           TRUE
     );


     int cnt5 = 0;
     while (peopleList5.hasMorePeople()) { // Print the list of auths.
           System.out.println ("The person Key is: " + (peopleList5.nextPerson()).getID());
           cnt5++;
     }

            System.out.println("The total number of Person is " + cnt5);
            System.out.println ("end of people for API " + apiName + " for " + qualifier5.getCode());
            System.out.println ();
*/

  }

  /**
   * Method test_getCurrentAuthorizationFields
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getCurrentAuthorizationFields(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "getCurrentAuthorizationFields";

    System.out.println("test api :  " + apiName + "\r\n");

    org.okiproject.serviceapi.roles.Field[] fields_ =
      myFactory.getCurrentAuthorizationFields();

    System.out.println("\r\n Currently there are  " + fields_.length
                       + " Authorization fields");

    for (int i = 0; i < fields_.length; i++) {
      System.out.println("\r\n the name of Field " + (i + 1) + " is "
                         + fields_[i].getName());

    }

    System.out.println("\r\n End of test for API " + apiName);
    System.out.println();
  }

  /**
   * Method test_getCurrentPersonFields
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getCurrentPersonFields(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "getCurrentPersonFields";

    System.out.println("test api :  " + apiName + "\r\n");

    org.okiproject.serviceapi.roles.Field[] fields_ =
      myFactory.getCurrentPersonFields();

    System.out.println("\r\n Currently there are  " + fields_.length
                       + " Person fields");

    for (int i = 0; i < fields_.length; i++) {
      System.out.println("\r\n the name of Field " + (i + 1) + " is "
                         + fields_[i].getName());

    }

    System.out.println("\r\n End of test for API " + apiName);
    System.out.println();
  }

  /**
   * Method test_getCurrentFunctionFields
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getCurrentFunctionFields(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "getCurrentFunctionFields";

    System.out.println("test api :  " + apiName + "\r\n");

    org.okiproject.serviceapi.roles.Field[] fields_ =
      myFactory.getCurrentPersonFields();

    System.out.println("\r\n Currently there are  " + fields_.length
                       + " Function fields");

    for (int i = 0; i < fields_.length; i++) {
      System.out.println("\r\n the name of Field " + (i + 1) + " is "
                         + fields_[i].getName());

    }

    System.out.println("\r\n End of test for API " + apiName);
    System.out.println();
  }

  /**
   * Method test_getCurrentQualifierFields
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getCurrentQualifierFields(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "getCurrentQualifierFields";

    System.out.println("test api :  " + apiName + "\r\n");

    org.okiproject.serviceapi.roles.Field[] fields_ =
      myFactory.getCurrentPersonFields();

    System.out.println("\r\n Currently there are  " + fields_.length
                       + " Qualifier fields");

    for (int i = 0; i < fields_.length; i++) {
      System.out.println("\r\n the name of Field " + (i + 1) + " is "
                         + fields_[i].getName());

    }

    System.out.println("\r\n End of test for API " + apiName);
    System.out.println();
  }

  /**
   * Method test_getFunctionsInCategory
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getFunctionsInCategory(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "getFunctionsInCategory";

    System.out.println("test api :  " + apiName
                       + "==> Given a Function Category \r\n");

    org.okiproject.serviceapi.roles.FunctionCategory category     =
      myFactory.newFunctionCategory("GRAD");

    org.okiproject.serviceapi.roles.Functions        functionList =
      myFactory.getFunctionsInCategory(category);
    int                                              cnt          = 0;

    while (functionList.hasMoreFunctions()) {
      System.out.println("The function name is ==> "
                         + (functionList.nextFunction()).getName());

      cnt++;
    }

    System.out.println("The total number of function is " + cnt);
    System.out.println("end of the test for API " + apiName
                       + " for functionCategory" + category.getCategory());
    System.out.println();

  }

  /**
   * Method test_getRootQualifier
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getRootQualifier(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_getRootQualifier";

    System.out.println("test api :  " + apiName
                       + "==> Given a Qualifier Type \r\n");

    org.okiproject.serviceapi.roles.QualifierType qt         =
      myFactory.newQualifierType("SPGP");

    org.okiproject.serviceapi.roles.Qualifier     qualifier4 =
      myFactory.getRootQualifier(qt);

    System.out.println("end of the test for API " + apiName
                       + " for qualifier" + qualifier4.getCode());
    System.out.println();

  }

  /**
   * Method test_getQualifierChildren
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_getQualifierChildren(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_getQualifierChildren";

    System.out.println("test api :  " + apiName
                       + "==> Given a Qualifier \r\n");

    org.okiproject.serviceapi.roles.Qualifier  qualifier  =
      myFactory.newQualifier("SPGP", "SG_RLE");

    org.okiproject.serviceapi.roles.Qualifiers qualifiers =
      myFactory.getQualifierChildren(qualifier);

    int                                        cnt        = 0;

    while (qualifiers.hasMoreQualifiers()) {    // Print the list of auths.
      System.out.println("=== the list of the qualifiers\r\n");

      System.out.println(qualifiers.nextQualifier());

      cnt++;
    }

    System.out.println("The total number of children qualifiers is " + cnt);

  }

  /**
   * Method test_isAuthorized
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  static void test_isAuthorized(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "isAuthorized";

    System.out.println(
      "test api :  " + apiName
      + "===>Given a person, a function and a qualifier\r\n");

    org.okiproject.serviceapi.roles.Function  function     =
      myFactory.newFunction("GRAD", "ADM_UPDATE_APPLICATION");

    org.okiproject.serviceapi.roles.Qualifier qualifier    =
      myFactory.newQualifier("FUND", "F1652700");

    org.okiproject.serviceapi.common.Person   person       =
      myFactory.newPerson("repa");

    Boolean                                   isAuthorized =
      myFactory.isAuthorized(person, function, qualifier);

    System.out.println("the isAuthorizd is " + isAuthorized.booleanValue());

    String does = (isAuthorized.booleanValue() == true)
                  ? " "
                  : " DOES NOT";

    System.out.println("The person " + person.getID() + does
                       + " have the authorization on function "
                       + function.getName() + " and which qualifier code is "
                       + qualifier.getCode());
    System.out.println("\r\n End of test for API " + apiName);
    System.out.println();
  }

  /*
  static void test_getSqlFactory(org.okiproject.serviceapi.roles.RolesFactory myFactory)
      throws Exception{

      String apiName = "test_getSqlFactory";

      System.out.println("test api :  "+ apiName +" to get a sqlFactory\r\n");

          org.okiproject.serviceapi.sql.SqlFactory sf = myFactory.getSqlFactory();

     if (sf !=null) System.out.println("haha,we got one\r\n");

      System.out.println ("\r\n End of test for API " + apiName );
      System.out.println ();
  }
  */

  /*
  static void test_getConnection(org.okiproject.serviceapi.roles.RolesFactory myFactory)
      throws Exception{

      String apiName = "test_getConnection";

      System.out.println("test api :  "+ apiName +" to get a getConnection\r\n");

          org.okiproject.serviceapi.sql.Connection con = myFactory.getConnection();

     if (con !=null) System.out.println("haha,we got one\r\n");

      System.out.println ("\r\n End of test for API " + apiName );
      System.out.println ();
  }
  */

  /* Not done
  static void test_getForUser(org.okiproject.serviceapi.roles.RolesFactory myFactory)
      throws Exception{

      String apiName = "test_getForUser";

      System.out.println("test api :  "+ apiName +"\r\n");

          org.okiproject.serviceapi.common.Person person = myFactory.getForUser();

     if (person !=null) System.out.println("haha,we got one\r\n");

      System.out.println ("\r\n End of test for API " + apiName );
      System.out.println ();
  }*/

  /*************************************************************************
  ** Create a new Authorization
  ************************************************************************/

  public static void test_createAuthorization(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_createAuthorization";

    /// test 1
    ///////////////////////////
    System.out.println(
      "test api :  " + apiName
      + "==> Given a function, a qualifier and a grantprivilege\r\n");

    org.okiproject.serviceapi.common.Person   person1    =
      myFactory.newPerson("bibolai");
    org.okiproject.serviceapi.roles.Function  function1  =
      myFactory.newFunction("TEST", "TESTFUN1");
    org.okiproject.serviceapi.roles.Qualifier qualifier1 =
      myFactory.newQualifier("ORGU", "001702");

    //org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ("COST", "I3642600");
    //org.okiproject.serviceapi.roles.Qualifier qualifier1= myFactory.newQualifier (new Integer(402169));
    // org.okiproject.serviceapi.roles.Qualifier qualifier1 = myFactory.newQualifier ("SPGP", "SG_RLE");
    org.okiproject.serviceapi.roles.GrantPrivilege priv1          =
      myFactory.newGrantPrivilege(
        org.okiproject.serviceapi.roles.GrantPrivilege.NOTGRANTABLE);
    org.okiproject.serviceapi.roles.Authorization  authorization1 = null;

    try {
      authorization1 = myFactory.createAuthorization(person1, function1,
              qualifier1, priv1, TRUE);

      System.out.println(person1.getID()
                         + " is now authorized to do Function "
                         + function1.getName() + "\nwith qualifier "
                         + qualifier1.getCode() + " with type "
                         + qualifier1.getQualifierType().getType()
                         + "\nstarting on "
                         + authorization1.getEffectiveDate());
      System.out.println();
    }
    catch (Exception ex1) {
      System.out.println("create authorization failure: " + ex1.getMessage());
    }

    /// test2
    ////////////

    /* System.out.println("test api :  "+ apiName +"==> Given a function, a qualifier and a grantprivilege and time\r\n");

          org.okiproject.serviceapi.common.Person person2 = myFactory.newPerson ("bibolai");
          org.okiproject.serviceapi.roles.Function function2
                             = myFactory.newFunction ("TEST", "TESTFUN1");
      org.okiproject.serviceapi.roles.Qualifier qualifier2 = myFactory.newQualifier ( "ORGU", "001702");
     //org.okiproject.serviceapi.roles.Qualifier qualifier2 = myFactory.newQualifier ("COST", "I3642600");
     org.okiproject.serviceapi.roles.GrantPrivilege priv2
                  = myFactory.newGrantPrivilege( org.okiproject.serviceapi.roles.GrantPrivilege.NOTGRANTABLE );

      java.util.GregorianCalendar effCal
        = new java.util.GregorianCalendar (2001, java.util.Calendar.NOVEMBER, 1) ;
      long effTime = effCal.getTime().getTime() ;
      java.sql.Timestamp effDate = new java.sql.Timestamp( effTime ) ;
      java.util.GregorianCalendar expCal
        = new java.util.GregorianCalendar (2001, java.util.Calendar.NOVEMBER ,2) ;
      long expTime = expCal.getTime().getTime() ;
      java.sql.Timestamp expDate = new java.sql.Timestamp( expTime ) ;

          org.okiproject.serviceapi.roles.Authorization authorization2= null ;
          try {
                authorization2 = myFactory.createAuthorization
                         ( person2, function2, qualifier2, priv2, TRUE, effDate,expDate);
                System.out.println (person2.getID()
                                    + " is now authorized to do Function "
                                    + function2.getName()
                                    +"\nwith qualifier "
                                    +qualifier2.getCode()
                                    +" with type "
                                    +qualifier2.getQualifierType().getType()
                                    +"\nstarting on "
                                    +authorization2.getEffectiveDate()
                                    );
                System.out.println ();
              }
              catch (Exception ex2) {
                System.out.println ( "create authorization failure: " + ex2.getMessage() );
      }
  */
  }

  /*************************************************************************
    ** Update an Authorization
    ************************************************************************/

  public static void test_updateAuth(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    org.okiproject.serviceapi.common.Person        person4        =
      myFactory.newPerson("cshubert");
    org.okiproject.serviceapi.roles.Function       function4      =
      myFactory.newFunction("TEST", "FUNCTION_API_SPGP1");
    org.okiproject.serviceapi.roles.Qualifier      qualifier4     =
      myFactory.newQualifier("SPGP", "SG_RLE");
    org.okiproject.serviceapi.roles.GrantPrivilege priv4          =
      myFactory.newGrantPrivilege(
        org.okiproject.serviceapi.roles.GrantPrivilege.NOTGRANTABLE);
    org.okiproject.serviceapi.roles.Authorization  authorization4 = null;

    authorization4 = myFactory.createAuthorization(person4, function4,
            qualifier4, priv4, TRUE);

    System.out.println(person4.getID() + " is now authorized to do Function "
                       + function4.getName() + "\nwith qualifier "
                       + qualifier4.getCode() + " with type "
                       + qualifier4.getQualifierType().getType()
                       + "\nstarting on "
                       + authorization4.getEffectiveDate());

    priv4 = myFactory.newGrantPrivilege(
      org.okiproject.serviceapi.roles.GrantPrivilege.GRANTABLEFORGRANTING);

    java.util.GregorianCalendar effCal  =
      new java.util.GregorianCalendar(2001, java.util.Calendar.NOVEMBER, 1);
    long                        effTime = effCal.getTime().getTime();
    java.sql.Timestamp          effDate = new java.sql.Timestamp(effTime);
    java.util.GregorianCalendar expCal  =
      new java.util.GregorianCalendar(2001, java.util.Calendar.NOVEMBER, 2);
    long                        expTime = expCal.getTime().getTime();
    java.sql.Timestamp          expDate = new java.sql.Timestamp(expTime);

    try {
      myFactory.updateAuthorization(authorization4, person4, function4,
                                    qualifier4, priv4, TRUE, effDate,
                                    expDate);
      System.out.println("updated starting on "
                         + authorization4.getEffectiveDate() + " until "
                         + authorization4.getExpirationDate()
                         + "\nmodified: " + authorization4.getModifiedDate());

      System.out.println("\r\nThen delete it ");

      myFactory.deleteAuthorization(authorization4);

    }
    catch (Exception ex4) {
      System.out.println("update authorization failure: " + ex4.getMessage());
    }

  }

  /**
   * Method test_newObjects
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_newObjects(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    //new Person by key
    org.okiproject.serviceapi.common.Person person1 =
      myFactory.newPerson("bibolai");
    org.okiproject.serviceapi.common.Person person2 =
      myFactory.newPerson("repa");

    System.out.println(
      "key " + person1.getID() + " found in Roles ?: "
      + (myFactory.isPersonFoundInRoles(person1)).booleanValue());

    System.out.println(
      "\r\n key " + person2.getID() + " found in Roles ?: "
      + (myFactory.isPersonFoundInRoles(person2)).booleanValue());

    ///--- create function instance --------
    // given by a string of functionCategory and a string of function name
    org.okiproject.serviceapi.roles.Function function1 =
      myFactory.newFunction("TEST", "TESTFUN1");
    org.okiproject.serviceapi.roles.Function function2 =
      myFactory.newFunction("GRAD", "ADM_UPDATE_APPLICATION");

    System.out.println(
      "\r\n function " + function1.getName() + " found in Roles ?: "
      + (myFactory.isFunctionFoundInRoles(function1)).booleanValue());
    System.out.println(
      "\r\n function " + function2.getName() + " found in Roles ?: "
      + (myFactory.isFunctionFoundInRoles(function2)).booleanValue());

    // given by a type of functionCategory and a string of function name
    org.okiproject.serviceapi.roles.FunctionCategory fc        =
      myFactory.newFunctionCategory("GRAD");
    org.okiproject.serviceapi.roles.Function         function3 =
      myFactory.newFunction(fc, "ADM_UPDATE_APPLICATION");

    System.out.println(
      "\r\n function " + function3.getName() + " found in Roles ?: "
      + (myFactory.isFunctionFoundInRoles(function3)).booleanValue());

    // given by an object of the function id
    org.okiproject.serviceapi.roles.Function function4 =
      myFactory.newFunction(new Integer(139));

    System.out.println(
      "\r\n function " + function4.getName() + " found in Roles ?: "
      + (myFactory.isFunctionFoundInRoles(function4)).booleanValue());

    //given a id and functioncategory object and name
    org.okiproject.serviceapi.roles.FunctionCategory fc1       =
      myFactory.newFunctionCategory("GRAD");
    org.okiproject.serviceapi.roles.Function         function5 =
      myFactory.newFunction(new Integer(139), fc1, "ADM_UPDATE_APPLICATION");

    System.out.println(
      "\r\n function " + function5.getName() + " found in Roles ?: "
      + (myFactory.isFunctionFoundInRoles(function5)).booleanValue());

    ////----create function category

    org.okiproject.serviceapi.roles.FunctionCategory fc2 =
      myFactory.newFunctionCategory("GRAD");

    System.out.println(
      "\r\n function " + fc2.getCategory() + " found in Roles ?: "
      + (myFactory.isFunctionCategoryFoundInRoles(fc2)).booleanValue());

    ////----create grantPrivilege

    org.okiproject.serviceapi.roles.GrantPrivilege gp =
      myFactory.newGrantPrivilege(
        org.okiproject.serviceapi.roles.GrantPrivilege.GRANTABLE);

    System.out.println("\r\n GrantPrivilege " + gp.toString()
                       + " grantable is  " + gp.isGrantable());

    ////----create qualifier

    org.okiproject.serviceapi.roles.Qualifier q =
      myFactory.newQualifier(new Integer(402169));

    System.out.println("\r\n Qualifier " + q.getCode());

    org.okiproject.serviceapi.roles.Qualifier q1 =
      myFactory.newQualifier("COST", "I3642600");

    System.out.println("\r\n Qualifier " + q1.getCode());

    org.okiproject.serviceapi.roles.QualifierType qt =
      myFactory.newQualifierType("COST");
    org.okiproject.serviceapi.roles.Qualifier     q2 =
      myFactory.newQualifier(qt, "I3642600");

    System.out.println("\r\n Qualifier " + q2.getCode());

  }

  /**
   * Method test_getPeopleGeneralForm
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_getPeopleGeneralForm(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_getPeopleGeneralForm";

    System.out.println("test api :  " + apiName
                       + "==> Given a list of selection criteria\r\n");

  }

  /**
   * Method test_getMinimumPersonfields
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_getMinimumPersonfields(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_getMinimumPersonfields";

    System.out.println("test api :  " + apiName + "\r\n");

    org.okiproject.serviceapi.roles.Field[] f =
      myFactory.getMinimumPersonFields();

    System.out.println("the length of the array is " + f.length);

  }

  /**
   * Method test_getDefaultPersonFields
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_getDefaultPersonFields(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_getDefaultPersonFields";

    System.out.println("test api :  " + apiName + "\r\n");

    org.okiproject.serviceapi.roles.Field[] f =
      myFactory.getDefaultPersonFields();

    System.out.println("the length of the array is " + f.length);

  }

  /**
   * Method test_getCompletePersonFields
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_getCompletePersonFields(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_getCompletePersonFields";

    System.out.println("test api :  " + apiName + "\r\n");

    org.okiproject.serviceapi.roles.Field[] f =
      myFactory.getCompletePersonFields();

    System.out.println("the length of the array is " + f.length);

  }

  /**
   * Method test_createFunction
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_createFunction(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_createFunction ==> given by function name"
                     + "function description and FunctionCategory object and "
                     + " Qualifier type object \r\n";

    System.out.println("test api :  " + apiName + "\r\n");

    org.okiproject.serviceapi.roles.FunctionCategory fc =
      myFactory.newFunctionCategory("TEST");
    org.okiproject.serviceapi.roles.QualifierType    qt =
      myFactory.newQualifierType("SPGP");

    //org.okiproject.serviceapi.roles.Function   function = myFactory.createFunction("TESTFUNCTION_1",
    //                                                                             "this is a test",
    //                                                                              fc, qt);
    org.okiproject.serviceapi.roles.Function function =
      myFactory.createFunction("FUNCTION_API_SPGP1206D",
                               "test create a function", fc, qt);

    System.out.println("Created function!");

    System.out.println("\r\nUpdate after create");

    myFactory.updateFunction(function, "FUNCTION_NEW_SPGP1206D",
                             "test update", fc, qt);

    System.out.println("\r\ndelete the function just ceated");

    System.out.println(function.getModifiedBy());

    myFactory.deleteFunction(function);

    System.out.println("\r\n function deleted!");

    // function.update("NEW_F_NAME", "update afunction", null, null);

  }

  /**
   * Method test_deleteFunction
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_deleteFunction(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName =
      "deleteFunction ==> Given a function name and functionCategory\r\n";

    System.out.println("test api :  " + apiName + "\r\n");

    org.okiproject.serviceapi.roles.FunctionCategory fc       =
      myFactory.newFunctionCategory("TEST");

    org.okiproject.serviceapi.roles.Function         function =
      myFactory.newFunction("895", fc, "FUNCTION_API_1");

    myFactory.deleteFunction(function);

    System.out.println("\r\n function deleted!");

  }

  /**
   * Method test_createQualifier
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_createQualifier(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_createQualifier ==> given by QualifierType object"
                     + "qualifierCode and qualifierDescription and "
                     + " parent a Qalifier \r\n";

    System.out.println("test api :  " + apiName + "\r\n");

    //get the parent
    org.okiproject.serviceapi.roles.QualifierType qt        =
      myFactory.newQualifierType("SPGP");

    org.okiproject.serviceapi.roles.Qualifier     parent    =
      myFactory.getRootQualifier(qt);

    org.okiproject.serviceapi.roles.Qualifier     qualifier =
      myFactory.createQualifier(qt, "SG_BOGUS_BIBO", "CREATE AND UPDATE",
                                parent);

    System.out.println("Qualifier created!");

    myFactory.updateQualifier(qualifier, "SG_NEW_CODE3", "TEST UPDATE");

    System.out.println("Update OK1\r\n");

    System.out.println("new code is " + qualifier.getCode());

    System.out.println("Test Create and update done!");

  }

  /**
   * Method test_deleteQualifier
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_deleteQualifier(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_deleteQualifier ==>  \r\n";

    System.out.println("test api :  " + apiName + "\r\n");

    //new a qualifier object and delete it from DB

    //org.okiproject.serviceapi.roles.Qualifier qualifier = myFactory.newQualifier("SPGP", "SG_BOGUS");

    // org.okiproject.serviceapi.roles.Qualifier qualifier = myFactory.newQualifier("150532");

    org.okiproject.serviceapi.roles.Qualifier qualifier =
      myFactory.newQualifier("SPGP", "SG_NEW_CODE3");

    myFactory.deleteQualifier(qualifier);

    System.out.println("Qualifier deleted!");

  }

  /**
   * Method test_updateQualifier
   *
   *
   * @param myFactory
   *
   * @throws Exception
   *
   */
  public static void test_updateQualifier(
          org.okiproject.serviceapi.roles.RolesFactory myFactory)
  throws Exception {

    String apiName = "test_updateQualifier ==>  \r\n";

    System.out.println("test api :  " + apiName + "\r\n");

    //new a qualifier object and delete it from DB

    org.okiproject.serviceapi.roles.Qualifier qualifier =
      myFactory.newQualifier("SPGP", "SG_BOGUS1");

    myFactory.updateQualifier(qualifier, "SG_NEW_CODE", "TEST UPDATE");

    System.out.println("Qualifier updated!");

  }

  /**
   * Method main
   *
   *
   * @param args
   *
   */
  public static void main(String[] args) {

    try {

      // Show the user the list of symbolic DB Names.
      String[] symbolicDBnameChoices =
        org.okiproject.serviceapi.roles.RolesFactory.getDatabaseSymbolicNames();

      System.out.println("Symbolic DB name choices:");

      for (int i = 0; symbolicDBnameChoices.length != i; i++) {
        System.out.println("     " + symbolicDBnameChoices[i]);
      }

      System.out.println("end of name choices");
      System.out.println();

      org.okiproject.serviceapi.roles.RolesFactory rf =
        getDefaultRolesFactory();

      //  org.okiproject.serviceapi.sql.Connection con = rf.getConnection();
      //   org.okiproject.serviceapi.sql.SqlFactory  sqlF= rf.getSqlFactory();
      //   org.okiproject.serviceapi.common.Person   person = rf.getForUser();

      //test_getAuthsSimpleForm(rf);  //4 impl tests

      // test_getAuthsForDoingFWithQ(rf); // 2 impl tests

      // test_getWhoCanDo(rf); //5 tests but the last one failed. Need to understand the logic

      //  test_isAuthorized(rf);

      //test_getCurrentAuthorizationFields(rf);

      // test_getCurrentPersonFields(rf);

      //test_getCurrentFunctionFields(rf);

      //test_getCurrentQualifierFields(rf);

      //test_getFunctionsInCategory(rf);

      //  test_getRootQualifier(rf);

      //test_getQualifierChildren(rf);

      //test_getSqlFactory(rf); //not done

      //test_getConnection(rf); //not done

      // test_getForUser(rf); //not tested

      // test_createAuthorization(rf);
      test_updateAuth(rf);

      //*** creation testing, maybe or not in DB***/
      //  test_newObjects(rf);

      //test_getPeopleGeneralForm(rf); //not implemented

      //test_getMinimumPersonfields(rf); //unimplemented

      //test_getDefaultPersonFields(rf);

      // test_getCompletePersonFields(rf);
      //    test_getCurrentPersonFields(rf);

      /*** create new function**/

      // test_createFunction(rf); //create and update and delete

      // test_deleteFunction(rf);

      // test_createQualifier(rf);

      // test_getQualifierChildren(rf);

      //   test_deleteQualifier(rf);

      //  test_updateQualifier(rf);

    }    //end of try

    catch (Exception exx) {
      exx.printStackTrace();
    }
  }
}


/*--- Formatted in OKI Style on Fri, Feb 8, '02 ---*/


/*------ Formatted by Jindent 3.24 Basic 1.0 --- http://www.jindent.de ------*/
