package org.okiproject.serviceapi.usermessage;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/usermessage/UserMsgService.java,v $ 
 */
/**
<p>
Purpose: Abstracts the User Messaging Service which clients can contact
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.1 $ / $Date: 2002/02/16 06:16:18 $
*/
public interface UserMsgService
extends java.io.Serializable {

  /**
   * Method subscribe
   *
   *
   * @param agent
   * @param topic
   *
   */
  public void subscribe(org.okiproject.serviceapi.common.Agent agent,
                        String topic);

  /**
   * Method unsubscribe
   *
   *
   * @param agent
   * @param topic
   *
   */
  public void unsubscribe(org.okiproject.serviceapi.common.Agent agent,
                          String topic);

  /**
   * Method send
   *
   *
   * @param from
   * @param to
   * @param msg
   *
   */
  public void send(org.okiproject.serviceapi.common.Agent from,
                   org.okiproject.serviceapi.common.Agent to, UserMessage msg);

  /**
   * Method broadcast
   *
   *
   * @param from
   * @param msg
   *
   */
  public void broadcast(org.okiproject.serviceapi.common.Agent from,
                        UserMessage msg);
}
