package org.okiproject.serviceimpl.mit.authen.cert;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/authencert/AuthenFactory.java,v $ 
 */
/**
<p>
The Authen API does not contain information that is expected
to be part of the implementation. There may be additional
implementation information that will need to be exposed in
this API.


 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.3 $ / $Date: 2002/02/16 17:10:20 $
*/

public class AuthenFactory
	extends org.okiproject.serviceapi.authentication.AuthenFactory
{
	private static final org.okiproject.serviceapi.authentication.AuthenException UNIMPLEMENTED
		= new org.okiproject.serviceapi.authentication.AuthenException
			( org.okiproject.serviceapi.authentication.AuthenException.UNIMPLEMENTED
			) ;

	private static final String SSL_CERTIFICATE = "SSL CERTIFICATE" ;

	/**
		Returns an Agent that may or may not be anonymous
	*/
	public org.okiproject.serviceapi.common.Agent getAgent()
		throws Throwable
	{
		return getAgentInternal( null , SSL_CERTIFICATE ) ;
	}

	/**
		Returns the types of Authentication that are available
		to the current implementation
	*/
	public String[] getAuthenTypes()
		throws Exception
	{
		String[] types = new String[ 1 ] ;
		types[ 0 ] = SSL_CERTIFICATE ;
		return types ;
	}

	/**
		Returns the types of Authentication that this
		agent currently has.
	*/
	public String[] getAuthenTypes
		( org.okiproject.serviceapi.common.Agent agent
		)
		throws Exception
	{
		if( agent instanceof org.okiproject.serviceimpl.mit.common.Person )
		{
			org.okiproject.serviceimpl.mit.common.Person person
				= ( org.okiproject.serviceimpl.mit.common.Person ) agent ;
			String[] types
				= ( String[] ) person.getProperty
					( org.okiproject.serviceimpl.mit.common.Person.AUTHEN_TYPES ) ;
			return types ;
		}
		throw UNIMPLEMENTED ;
	}

	public org.okiproject.serviceapi.common.Agent getAgent
		( org.okiproject.serviceapi.common.Agent agent
		, String type
		)
		throws Throwable
	{
System.out.println( "getAgent" ) ;
System.out.println( agent ) ;
System.out.println( type ) ;
		if
			((type != null)
			 && ( -1 != type.toLowerCase().indexOf( "ssl certificate" ) )
			&& ( agent instanceof org.okiproject.serviceimpl.mit.common.Person )
			)
		{
			return getAgentInternal( agent , SSL_CERTIFICATE ) ;
		}
		throw UNIMPLEMENTED ;
	}

	public void destroyAuthen
		( org.okiproject.serviceapi.common.Agent agent
		)
		throws Exception
	{
		if
			(  ( agent instanceof org.okiproject.serviceimpl.mit.common.Person )
			)
		{
			org.okiproject.serviceimpl.mit.common.Person person
				= ( org.okiproject.serviceimpl.mit.common.Person ) agent ;
			person.setProperty
				( org.okiproject.serviceimpl.mit.common.Person.AUTHEN_TYPES
				, new String[ 0 ]
				) ;
			return ;
		}
		throw UNIMPLEMENTED ;
	}

	public void destroyAuthen
		( org.okiproject.serviceapi.common.Agent agent
		, String type
		)
		throws Exception
	{
		if
			((type != null)
			 && ( -1 != type.toLowerCase().indexOf( "ssl certificate" ) )
			&& ( agent instanceof org.okiproject.serviceimpl.mit.common.Person )
			)
		{
			org.okiproject.serviceimpl.mit.common.Person person
				= ( org.okiproject.serviceimpl.mit.common.Person ) agent ;
			person.setProperty
				( org.okiproject.serviceimpl.mit.common.Person.AUTHEN_TYPES
				, new String[ 0 ]
				) ;
			return ;
		}
		throw UNIMPLEMENTED ;
	}

	public void destroyAuthen
		( org.okiproject.serviceapi.common.Agent agent
		, String[] types
		)
		throws Exception
	{
		if
			(  isIn( types , "ssl certificate" )
			&& ( agent instanceof org.okiproject.serviceimpl.mit.common.Person )
			)
		{
			org.okiproject.serviceimpl.mit.common.Person person
				= ( org.okiproject.serviceimpl.mit.common.Person ) agent ;
			person.setProperty
				( org.okiproject.serviceimpl.mit.common.Person.AUTHEN_TYPES
				, new String[ 0 ]
				) ;
			return ;
		}
		throw UNIMPLEMENTED ;
	}

	private boolean isIn( String[] types , String type )
	{
		if( ( null != types ) && ( null != type ) )
		{
			for( int i = 0 ; types.length != i ; i ++ )
			{
				if( -1 != types[ i ].toLowerCase().indexOf( type ) )
				{
					return true ;
				}
			}
		}
		return false ;
	}

	private org.okiproject.serviceapi.common.Agent getAgentInternal
		( org.okiproject.serviceapi.common.Agent agent
		, String type
		)
		throws Throwable
	{
		// get request and response from the thread
		javax.servlet.http.HttpServletRequest request =
		  (javax.servlet.http.HttpServletRequest) org.okiproject.serviceimpl.mit.util.ThreadContext.getProperty("request");
		javax.servlet.http.HttpServletResponse response = 
		  (javax.servlet.http.HttpServletResponse)
		  org.okiproject.serviceimpl.mit.util.ThreadContext.getProperty("response");
		String username = (String) request.getAttribute("SSL_CLIENT_S_DN_Email") ;

		String[] types = new String[ 1 ] ;
		types[ 0 ] = SSL_CERTIFICATE ;

		String kerberos_name;
		if (username.indexOf("@") != -1) {
		  kerberos_name = username.substring(0,username.indexOf("@"));
		} else {
		  kerberos_name = username;
		}
		if( null == agent )
		{
			java.util.Properties props = new java.util.Properties() ;
			props.put
				( org.okiproject.serviceimpl.mit.common.Person.KERBEROS_NAME
				  , kerberos_name
				) ;
			props.put
				( org.okiproject.serviceimpl.mit.common.Person.FIRST_NAME
				  , (String) request.getAttribute("SSL_CLIENT_S_DN_CN")
				) ;
			props.put
				( org.okiproject.serviceimpl.mit.common.Person.LAST_NAME
				  , (String) request.getAttribute("SSL_CLIENT_S_DN")
				) ;
			props.put
				( org.okiproject.serviceimpl.mit.common.Person.AUTHEN_TYPES
				, types
				) ;
			agent = new org.okiproject.serviceimpl.mit.common.Person( props ) ;
		}
		else
		{
			( ( org.okiproject.serviceimpl.mit.common.Person ) agent ).setProperty
				( org.okiproject.serviceimpl.mit.common.Person.KERBEROS_NAME
				, username
				) ;
			( ( org.okiproject.serviceimpl.mit.common.Person ) agent ).setProperty
				( org.okiproject.serviceimpl.mit.common.Person.AUTHEN_TYPES
				, types
				) ;
		}
		return 	agent  ;
	}

}
