package org.okiproject.serviceimpl.mit.common ;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/common/Person.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.6 $ / $Date: 2002/02/16 05:02:54 $
*/
public class Person
	implements org.okiproject.serviceapi.common.Person
{
	public static String CREDENTIALS = "CREDENTIALS";
	public static String AUTHEN_TYPES = "AUTHEN_TYPES" ;
	public static String KERBEROS_NAME = "KERBEROS_NAME" ;
	public static String MIT_ID = "MIT_ID" ;
	public static String FIRST_NAME = "FIRST_NAME" ;
	public static String MIDDLE_NAME = "MIDDLE_NAME" ;
	public static String LAST_NAME = "LAST_NAME" ;
	public static String SSN = "SSN" ;
	public static String DOB = "DOB" ;

	private java.util.Properties properties = null ;
	public java.util.Properties getProperties() { return this.properties ; }
	public void setProperties( java.util.Properties properties )
		{ this.properties = properties ; }
	public Object getProperty( String propertyName )
	{
		if( null != this.properties )
		{
			return this.properties.get( propertyName ) ;
		}
		return null ;
	}
	public void setProperty( String propertyName , Object property )
	{
		if( null == this.properties )
		{
			this.properties = new java.util.Properties() ;
		}
		if
			(  ( null != this.properties )
			&& ( null != propertyName )
			&& ( null != property )
			)
		{
			this.properties.put( propertyName , property ) ;
		}
	}

	public Object getID() { return getKerberosName() ; }
	public void setID( Object id )
	{
		setKerberosName( ( String ) id ) ;
	}

	public String getName()
	{
		String name = null ;
		if( null != getFirstName() )
		{
			name = getFirstName() ;
		}
		if( null != getLastName() )
		{
			if( null != name )
			{
				name += " " ;
				name += getLastName() ;
			}
			else
			{
				name = getLastName() ;
			}
		}
		if( null == name )
		{
			name = getKerberosName() ;
		}
		return name ;
	}

	public String getKerberosName()
	{
		return ( String ) getProperty( KERBEROS_NAME ) ;
	}
	protected void setKerberosName( String kerberosName )
	{
		setProperty( KERBEROS_NAME , kerberosName.toUpperCase() ) ;
	}

	public String getMiddleName()
	{
		return ( String ) getProperty( MIDDLE_NAME ) ;
	}
	protected void setMiddleName( String middleName )
	{
		setProperty( MIDDLE_NAME , middleName ) ;
	}

	public String getSSN()
	{
		return ( String ) getProperty( SSN ) ;
	}
	protected void setSSN( String ssn )
	{
		setProperty( SSN , ssn ) ;
	}

	public String getDOB()
	{
		return ( String ) getProperty( DOB ) ;
	}
	protected void setDOB( String dob )
	{
		setProperty( DOB , dob ) ;
	}

	public String getMitid()
	{
		return ( String ) getProperty( MIT_ID ) ;
	}
	protected void setMitid( String mitid )
	{
		setProperty( MIT_ID , mitid ) ;
	}

	public String getLastName()
	{
		return ( String ) getProperty( LAST_NAME ) ;
	}
	protected void setLastName( String lastName )
	{
		setProperty( LAST_NAME , lastName ) ;
	}

	public String getFirstName()
	{
		return ( String ) getProperty( FIRST_NAME ) ;
	}
	protected void setFirstName( String firstName )
	{
		setProperty( FIRST_NAME , firstName ) ;
	}

	public String[] getAuthenTypes()
	{
		return ( String[] ) getProperty( AUTHEN_TYPES ) ;
	}
	protected void setAuthenTypes( String[] authenTypes )
	{
		setProperty( AUTHEN_TYPES , authenTypes ) ;
	}

	public byte[] getCredentials()
	{
		return ( byte[] ) getProperty( CREDENTIALS ) ;
	}
	protected void setCredentials( byte[] credentials )
	{
		setProperty( CREDENTIALS , credentials ) ;
	}

	public Person
		( java.util.Properties properties
		)
	{
		if( null != properties )
		{
			setProperties( properties ) ;
		}
		else
		{
			setProperties( new java.util.Properties() ) ;
		}
	}

	public Person
		( String kerberosName
		, String mitid
		, String firstName
		, String middleName
		, String lastName
		, String ssn
		, String dob
		)
	{
		setProperties( new java.util.Properties() ) ;
		setKerberosName( kerberosName ) ;
		setMitid( mitid ) ;
		setFirstName( firstName ) ;
		setMiddleName( middleName ) ;
		setLastName( lastName ) ;
		setSSN( ssn ) ;
		setDOB( dob ) ;
	}

	public static org.okiproject.serviceimpl.mit.common.Person create
		( String kerberosName
		)
	{
		return new org.okiproject.serviceimpl.mit.common.Person
			( kerberosName
			, null
			, null
			, null
			, null
			, null
			, null
			) ;
	}

}
