package org.okiproject.serviceimpl.mit.guid;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/guid/IDBMSConnectionFactoryImpl.java,v $ 
 */
/**
<p>
************************************************************************
*	Purpose: Quick-and-dirty Connection factory implementation.
* $Source: /cvs/oki/org/okiproject/serviceimpl/mit/guid/IDBMSConnectionFactoryImpl.java,v $
* @version $Revision: 1.4 $
* $Date: 2002/02/16 05:02:54 $
*	@author		<B>Giri Swaminathan, MIT</B>
**********************************************************************
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.4 $ / $Date: 2002/02/16 05:02:54 $
*/
public class IDBMSConnectionFactoryImpl
implements org.okiproject.serviceimpl.mit.guid.IDBMSConnectionFactory
{
	public  java.sql.Connection getConnection( String propFile ) throws 
		Exception {
			java.io.InputStream is = new java.io.FileInputStream( propFile );
			java.util.Properties p = new java.util.Properties();
			p.load( is );
			return getConnection( p );
	}

	public java.sql.Connection getConnection( final java.util.Properties props ) throws Exception {
			String dbDriver = null;
			// JDBC URL
			String dbSpec = null;
			String dbName = null;
			String dbUser = null;
			String dbPass = null;

			if ( (dbDriver = props.getProperty("org.okiproject.serviceimpl.mit.guid.dbDriver")) == null )
				throw new Exception("Property org.okiproject.serviceimpl.mit.guid.dbDriver undefined! Aborting . . .");
		    try {
				Class c = Class.forName( dbDriver );
			} catch ( ClassNotFoundException cnfe ) {
					System.out.println( "Cannot load database driver class '" + dbDriver + "'");
				return null;
		    }
			if ( (dbSpec = props.getProperty("org.okiproject.serviceimpl.mit.guid.dbSpec")) == null )
				throw new Exception("Property org.okiproject.serviceimpl.mit.guid.dbSpec undefined! Aborting . . .");
			if ( (dbUser = props.getProperty("org.okiproject.serviceimpl.mit.guid.dbUser")) == null )
				throw new Exception("Property org.okiproject.serviceimpl.mit.guid.dbUser undefined! Aborting . . .");
			if ( (dbPass = props.getProperty("org.okiproject.serviceimpl.mit.guid.dbPass")) == null )
				throw new Exception("Property org.okiproject.serviceimpl.mit.guid.dbPass undefined! Aborting . . .");
/*
			System.out.println("DEBUG: dbDriver = '" + dbDriver + "', dbSpec = '" + dbSpec + "', dbUser = '" + dbUser + "', dbPass = '" + "XXXX" + "'" );
*/
			return java.sql.DriverManager.getConnection( dbSpec, dbUser, dbPass);

	}

	public java.sql.Connection getConnection( final java.util.PropertyResourceBundle prb) throws Exception {
		final java.util.Properties p = prbToprops( prb );
		return getConnection( p );
	}
	
	private final java.util.Properties prbToprops( 
					final java.util.PropertyResourceBundle prb) {
			java.util.Properties p = new java.util.Properties();
			java.util.Enumeration keys = prb.getKeys();

			while( keys.hasMoreElements() ) {
					String key = ( String ) keys.nextElement();
					p.setProperty( key, (String)prb.handleGetObject(key) );
		    }
		return p;
    }
};
