package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/Authorization.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.10 $ / $Date: 2002/02/16 17:10:36 $
*/
public class Authorization
implements org.okiproject.serviceapi.authorization.Authorization {
  private final static String NO        = "N";
  private final static String YES       = "Y";
  private final static String GRANT_NO  = "N ";
  private final static String GRANT_YES = "Y ";

  // Authorization stored procedures

  private final static String CREATE             =
    "ROLESAPI_CREATE_AUTHORIZATION";
  private final static String DELETE             =
    "ROLESAPI_DELETE_AUTHORIZATION";
  private final static String UPDATE             =
    "ROLESAPI_UPDATE_AUTHORIZATION";
  private final static String IS_USER_AUTHORIZED =
    "ROLESAPI_IS_USER_AUTHORIZED";

  // Authorization field names

  private final static String AUTHORIZATION_ID  = "AUTHORIZATION_ID";
  private final static String FUNCTION_ID       = "FUNCTION_ID";
  private final static String QUALIFIER_ID      = "QUALIFIER_ID";
  private final static String KERBEROS_NAME     = "KERBEROS_NAME";
  private final static String QUALIFIER_CODE    = "QUALIFIER_CODE";
  private final static String FUNCTION_NAME     = "FUNCTION_NAME";
  private final static String FUNCTION_CATEGORY = "FUNCTION_CATEGORY";
  private final static String QUALIFIER_NAME    = "QUALIFIER_DESCRIPTION";
  private final static String MODIFIED_BY       = "MODIFIED_BY";
  private final static String MODIFIED_DATE     = "MODIFIED_DATE";
  private final static String DO_FUNCTION       = "DO_FUNCTION";
  private final static String GRANTANDVIEW      = "GRANTANDVIEW";
  private final static String DESCEND           = "DESCEND";
  private final static String EFFECTIVE_DATE    = "EFFECTIVE_DATE";
  private final static String EXPIRATION_DATE   = "EXPIRATION_DATE";

  private final static String PERSON            = "PERSON";
  private final static String FUNCTION          = "FUNCTION";
  private final static String QUALIFIER         = "QUALIFIER";
  private final static String GRANT             = "GRANT_AUTHORIZATION";
  private final static String CANFORUSERGRANT   = "CANFORUSERGRANT";
  private final static String ACTIVENOW         = "IS_ACTIVE_NOW";

  //      private final static String VIRTUALITY = "VIRTUALITY" ;

  private org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory =
    null;

  /**
   * Method getRolesFactory
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceimpl.mit.roles.RolesFactory getRolesFactory() {
    return rolesFactory;
  }

  protected void setRolesFactory(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rFactory) {
    rolesFactory = rFactory;
  }

  private java.util.Properties properties = null;

  /**
   * Method getProperties
   *
   *
   * @return
   *
   */
  public java.util.Properties getProperties() {
    return this.properties;
  }

  protected void setProperties(java.util.Properties properties) {
    this.properties = properties;
  }

  protected Object getProperty(String propertyName) {
    if ((null != propertyName) && (null != this.properties)) {
      Object obj = this.properties.get(propertyName);

      try {
        if (-1 != propertyName.toUpperCase().indexOf(PERSON)) {

          // make this call to get all the person properties

          ((org.okiproject.serviceimpl.mit.roles.Person) obj).isFoundInRoles();
        }
      }
      catch (Exception ex) {}

      return obj;
    }

    return null;
  }

  protected void setProperty(String propertyName, Object property) {
    if (null == this.properties) {
      this.properties = new java.util.Properties();
    }

    if ((null != this.properties) && (null != propertyName)
            && (null != property)) {
      this.properties.put(propertyName, property);
    }
  }

  /**
   * Method getId
   *
   *
   * @return
   *
   */
  public Object getId() {
    return getProperty(AUTHORIZATION_ID);
  }

  protected void setId(Object id) {
    setProperty(AUTHORIZATION_ID, id);
  }

  /**
   * Method getPerson
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.authorization.Person getPerson() {
    return (org.okiproject.serviceapi.authorization.Person) getProperty(PERSON);
  }

  protected void setPerson(org.okiproject.serviceapi.authorization.Person person) {
    setProperty(PERSON, person);
  }

  /**
   * Method getFunction
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.authorization.Function getFunction() {
    return (org.okiproject.serviceapi.authorization.Function) getProperty(FUNCTION);
  }

  protected void setFunction(
          org.okiproject.serviceapi.authorization.Function function) {
    setProperty(FUNCTION, function);
  }

  /**
   * Method getQualifier
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.authorization.Qualifier getQualifier() {
    return (org.okiproject.serviceapi.authorization.Qualifier) getProperty(QUALIFIER);
  }

  protected void setQualifier(
          org.okiproject.serviceapi.authorization.Qualifier qualifier) {
    setProperty(QUALIFIER, qualifier);
  }

  /**
   * Method getGrant
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.authorization.GrantPrivilege getGrant() {
    return (org.okiproject.serviceapi.authorization.GrantPrivilege) getProperty(
      GRANT);
  }

  protected void setGrant(
          org.okiproject.serviceapi.authorization.GrantPrivilege grant) {
    setProperty(GRANT, grant);
  }

  /**
   * Method getCanForUserGrant
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.authorization.GrantPrivilege getCanForUserGrant() {
    return (org.okiproject.serviceapi.authorization.GrantPrivilege) getProperty(
      CANFORUSERGRANT);
  }

  protected void setCanForUserGrant(
          org.okiproject.serviceapi.authorization.GrantPrivilege canForUserGrant) {
    setProperty(CANFORUSERGRANT, canForUserGrant);
  }

  /**
   * Method getDoFunction
   *
   *
   * @return
   *
   */
  public Boolean getDoFunction() {
    return (Boolean) getProperty(DO_FUNCTION);
  }

  private void setDoFunction(Boolean doFunction) {
    setProperty(DO_FUNCTION, doFunction);
  }

  /**
   * Method getEffectiveDate
   *
   *
   * @return
   *
   */
  public java.sql.Timestamp getEffectiveDate() {
    return (java.sql.Timestamp) getProperty(EFFECTIVE_DATE);
  }

  protected void setEffectiveDate(java.sql.Timestamp effectiveDate) {
    setProperty(EFFECTIVE_DATE, effectiveDate);
  }

  /**
   * Method getExpirationDate
   *
   *
   * @return
   *
   */
  public java.sql.Timestamp getExpirationDate() {
    return (java.sql.Timestamp) getProperty(EXPIRATION_DATE);
  }

  protected void setExpirationDate(java.sql.Timestamp expirationDate) {
    setProperty(EXPIRATION_DATE, expirationDate);
  }

  /**
   * Method isActiveNow
   *
   *
   * @return
   *
   */
  public Boolean isActiveNow() {
    return (Boolean) getProperty(ACTIVENOW);
  }

  protected void setActiveNow(Boolean activeNow) {
    setProperty(ACTIVENOW, activeNow);
  }

  /**
   * Method getModifiedBy
   *
   *
   * @return
   *
   */
  public String getModifiedBy() {
    return (String) getProperty(MODIFIED_BY);
  }

  protected void setModifiedBy(String modifiedBy) {
    setProperty(MODIFIED_BY, modifiedBy);
  }

  /**
   * Method getModifiedDate
   *
   *
   * @return
   *
   */
  public java.sql.Timestamp getModifiedDate() {
    return (java.sql.Timestamp) getProperty(MODIFIED_DATE);
  }

  protected void setModifiedDate(java.sql.Timestamp modifiedDate) {
    setProperty(MODIFIED_DATE, modifiedDate);
  }

  //      public org.okiproject.serviceapi.authorization.Virtuality getVirtuality()

  //      {

  //              return ( org.okiproject.serviceapi.authorization.Virtuality ) getProperty( VIRTUALITY ) ;

  //      }

  //      protected void setVirtuality( org.okiproject.serviceapi.authorization.Virtuality virtuality )

  //      {

  //              setProperty( VIRTUALITY , virtuality ) ;

  //      }

  protected Authorization(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          java.util.Properties properties) {
    setRolesFactory(rolesFactory);
    setProperties(properties);
  }

  protected Authorization(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          Object id, org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          org.okiproject.serviceapi.authorization.GrantPrivilege grant,
          org.okiproject.serviceapi.authorization.GrantPrivilege canForUserGrant,
          Boolean doFunction, java.sql.Timestamp effectiveDate,
          java.sql.Timestamp expirationDate, Boolean activeNow,
          String modifiedBy, java.sql.Timestamp modifiedDate

  //              , org.okiproject.serviceimpl.mit.roles.Virtuality virtuality

  ) {
    setRolesFactory(rolesFactory);
    setId(id);
    setPerson(person);
    setFunction(function);
    setQualifier(qualifier);
    setGrant(grant);
    setCanForUserGrant(canForUserGrant);
    setDoFunction(doFunction);
    setEffectiveDate(effectiveDate);
    setExpirationDate(expirationDate);
    setActiveNow(activeNow);
    setModifiedBy(modifiedBy);
    setModifiedDate(modifiedDate);

    //              setVirtuality( virtuality ) ;

  }

  /**
   * Method delete
   *
   *
   * @throws Exception
   *
   */
  public void delete()
  throws Exception {
    try {
      if ((null != getRolesFactory())
              && (null != getRolesFactory().getConnection())
              && (null != getId())) {
        org.okiproject.serviceapi.dbc.Connection connection =
          getRolesFactory().getConnection();
        Object[]                                 args       = new Object[4];

        args[0] = (null == getId())
                  ? null
                  : getId();
        args[1] = (null == getFunction())
                  ? null
                  : ((null == getFunction().getName())
                     ? null
                     : getFunction().getName());
        args[2] = (null == getQualifier())
                  ? null
                  : ((null == getQualifier().getCode())
                     ? null
                     : getQualifier().getCode());
        args[3] = (null == getRolesFactory())
                  ? null
                  : ((null == getRolesFactory().getForUser())
                     ? null
                     : ((org.okiproject.serviceimpl.mit.roles.Person) getRolesFactory().getForUser()).getKerberosName());

        int[] columnTypes = new int[4];

        columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;

        int[] dataTypes = new int[4];

        dataTypes[0] = java.sql.Types.NUMERIC;
        dataTypes[1] = java.sql.Types.VARCHAR;
        dataTypes[2] = java.sql.Types.VARCHAR;
        dataTypes[3] = java.sql.Types.VARCHAR;

        connection.callProcedure(DELETE, args, columnTypes, dataTypes);
        setId(null);
        setPerson(null);
        setFunction(null);
        setQualifier(null);
        setGrant(null);
        setCanForUserGrant(null);
        setDoFunction(null);
        setEffectiveDate(null);
        setExpirationDate(null);
        setActiveNow(null);
        setModifiedBy(null);
        setModifiedDate(null);

        return;
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.DELETEAUTHORIZATIONFAILED);
  }

  /**
   * Method update
   *
   *
   * @param person
   * @param function
   * @param qualifier
   * @param grant
   * @param doFunction
   * @param effectiveDate
   * @param expirationDate
   *
   * @throws Exception
   *
   */
  public void update(org.okiproject.serviceapi.authorization.Person person,
                     org.okiproject.serviceapi.authorization.Function function,
                     org.okiproject.serviceapi.authorization.Qualifier qualifier,
                     org.okiproject.serviceapi.authorization.GrantPrivilege grant,
                     Boolean doFunction, java.sql.Timestamp effectiveDate,
                     java.sql.Timestamp expirationDate)
  throws Exception {
    try {
      if ((null != getRolesFactory())
              && (null != getRolesFactory().getConnection())
              && (null != getId())) {
        org.okiproject.serviceapi.dbc.Connection connection =
          getRolesFactory().getConnection();
        Object[]                                 args       = new Object[9];

        args[0] = getId();
        args[1] = (null != function)
                  ? ((org.okiproject.serviceimpl.mit.roles.Function) function).getName()
                  : ((org.okiproject.serviceimpl.mit.roles.Function) getFunction()).getName();
        args[2] = (null != qualifier)
                  ? ((org.okiproject.serviceimpl.mit.roles.Qualifier) qualifier).getCode()
                  : ((org.okiproject.serviceimpl.mit.roles.Qualifier) getQualifier()).getCode();
        args[3] = (null != person)
                  ? ((org.okiproject.serviceimpl.mit.roles.Person) person).getKerberosName()
                  : ((org.okiproject.serviceimpl.mit.roles.Person) getPerson()).getKerberosName();
        args[4] = doFunction.booleanValue()
                  ? YES
                  : NO;
        args[5] = grant.isGrantable()
                  ? GRANT_YES
                  : GRANT_NO;
        args[6] = rolesFactory.createRolesDate(effectiveDate);
        args[7] = rolesFactory.createRolesDate(expirationDate);
        args[8] = ((null != getRolesFactory().getForUser())
                   ? ((org.okiproject.serviceimpl.mit.roles.Person) getRolesFactory().getForUser()).getKerberosName()
                   : null);

        int[] columnTypes = new int[11];

        columnTypes[0]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[1]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[4]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[5]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[6]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[7]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[8]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[9]  = java.sql.DatabaseMetaData.procedureColumnOut;
        columnTypes[10] = java.sql.DatabaseMetaData.procedureColumnOut;

        int[] dataTypes = new int[11];

        dataTypes[0]  = java.sql.Types.NUMERIC;
        dataTypes[1]  = java.sql.Types.VARCHAR;
        dataTypes[2]  = java.sql.Types.VARCHAR;
        dataTypes[3]  = java.sql.Types.VARCHAR;
        dataTypes[4]  = java.sql.Types.CHAR;
        dataTypes[5]  = java.sql.Types.VARCHAR;
        dataTypes[6]  = java.sql.Types.VARCHAR;
        dataTypes[7]  = java.sql.Types.VARCHAR;
        dataTypes[8]  = java.sql.Types.VARCHAR;
        dataTypes[9]  = java.sql.Types.VARCHAR;
        dataTypes[10] = java.sql.Types.VARCHAR;

        org.okiproject.serviceapi.dbc.Table table =
          connection.callProcedure(UPDATE, args, columnTypes, dataTypes);

        if (null != table) {
          if (null != person) {
            setPerson(person);
          }

          if (null != function) {
            setFunction(
              (org.okiproject.serviceimpl.mit.roles.Function) function);
          }

          if (null != qualifier) {
            setQualifier(
              (org.okiproject.serviceimpl.mit.roles.Qualifier) qualifier);
          }

          if (null != doFunction) {
            setDoFunction(doFunction);
          }

          if (null != grant) {
            setGrant(grant);
          }

          if (null != effectiveDate) {
            setEffectiveDate(effectiveDate);
          }

          if (null != expirationDate) {
            setExpirationDate(expirationDate);
          }

          org.okiproject.serviceapi.dbc.Rows rows = table.getRows();

          if (rows.hasMoreRows()) {
            Object[] row = rows.nextRow();

            setModifiedBy((String) row[0]);
            setModifiedDate(
              getRolesFactory().createSqlTimestamp((String) row[1]));
          }

          return;
        }
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.UPDATEAUTHORIZATIONFAILED);
  }

  /**
   * Method create
   *
   *
   * @param rolesFactory
   * @param person
   * @param function
   * @param qualifier
   * @param grant
   * @param doFunction
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.authorization.Authorization create(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          org.okiproject.serviceapi.authorization.GrantPrivilege grant,
          Boolean doFunction)
  throws Exception {
    return create(rolesFactory, person, function, qualifier, grant,
                  doFunction,
                  new java.sql.Timestamp(new java.util.Date().getTime()),
                  null);
  }

  /**
   * Method create
   *
   *
   * @param rolesFactory
   * @param person
   * @param function
   * @param qualifier
   * @param grant
   * @param doFunction
   * @param effectiveDate
   * @param expirationDate
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.authorization.Authorization create(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          org.okiproject.serviceapi.authorization.GrantPrivilege grant,
          Boolean doFunction, java.sql.Timestamp effectiveDate,
          java.sql.Timestamp expirationDate)
  throws Exception {
    try {
      if ((null != rolesFactory) && (null != rolesFactory.getConnection())
              && (null != person)
              && (person instanceof org.okiproject.serviceimpl.mit.roles.Person)
              && (null != function)
              && (function instanceof org.okiproject.serviceimpl.mit.roles.Function)
              && (null != qualifier)
              && (qualifier instanceof org.okiproject.serviceimpl.mit.roles.Qualifier)
              && (null != grant)
              && (grant instanceof org.okiproject.serviceimpl.mit.roles.GrantPrivilege)
              && (null != doFunction) && (null != effectiveDate)) {
        org.okiproject.serviceapi.dbc.Connection connection =
          rolesFactory.getConnection();
        Object[]                                 args       = new Object[8];

        args[0] =
          ((org.okiproject.serviceimpl.mit.roles.Function) function).getName();
        args[1] =
          ((org.okiproject.serviceimpl.mit.roles.Qualifier) qualifier).getCode();
        args[2] =
          ((org.okiproject.serviceimpl.mit.roles.Person) person).getKerberosName();
        args[3] = doFunction.booleanValue()
                  ? YES
                  : NO;
        args[4] =
          ((org.okiproject.serviceimpl.mit.roles.GrantPrivilege) grant).isGrantable()
          ? GRANT_YES
          : GRANT_NO;
        args[5] = rolesFactory.createRolesDate(effectiveDate);
        args[6] = rolesFactory.createRolesDate(expirationDate);
        args[7] = ((null != rolesFactory.getForUser())
                   ? ((org.okiproject.serviceimpl.mit.roles.Person) rolesFactory.getForUser()).getKerberosName()
                   : null);

        int[] columnTypes = new int[11];

        columnTypes[0]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[1]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[4]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[5]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[6]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[7]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[8]  = java.sql.DatabaseMetaData.procedureColumnOut;
        columnTypes[9]  = java.sql.DatabaseMetaData.procedureColumnOut;
        columnTypes[10] = java.sql.DatabaseMetaData.procedureColumnOut;

        int[] dataTypes = new int[11];

        dataTypes[0]  = java.sql.Types.VARCHAR;
        dataTypes[1]  = java.sql.Types.VARCHAR;
        dataTypes[2]  = java.sql.Types.VARCHAR;
        dataTypes[3]  = java.sql.Types.CHAR;
        dataTypes[4]  = java.sql.Types.VARCHAR;
        dataTypes[5]  = java.sql.Types.VARCHAR;
        dataTypes[6]  = java.sql.Types.VARCHAR;
        dataTypes[7]  = java.sql.Types.VARCHAR;
        dataTypes[8]  = java.sql.Types.VARCHAR;
        dataTypes[9]  = java.sql.Types.VARCHAR;
        dataTypes[10] = java.sql.Types.NUMERIC;

        org.okiproject.serviceapi.dbc.Table tab =
          connection.callProcedure(CREATE, args, columnTypes, dataTypes);

        if (null != tab) {
          org.okiproject.serviceapi.dbc.Rows rows = tab.getRows();

          if (null != rows) {
            if (rows.hasMoreRows()) {
              Object[]                            row     = rows.nextRow();
              String                              modBy   = (String) row[0];
              java.sql.Timestamp                  modDate =
                rolesFactory.createSqlTimestamp((String) row[1]);
              Number                              id      = (Number) row[2];
              String                              sqlx    =
                getAuthorizationDetailSQL(id);
              org.okiproject.serviceapi.dbc.Table table   =
                connection.executeQuery(sqlx);

              if (null != table) {
                java.util.Properties properties =
                  getPropertiesFromTable(rolesFactory, table);

                if (null != properties) {
                  org.okiproject.serviceimpl.mit.roles.Authorization authorization =
                    new org.okiproject.serviceimpl.mit.roles.Authorization(
                      rolesFactory, properties);

                  return (authorization);
                }
              }
            }
          }
        }
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.CREATEAUTHORIZATIONFAILED);
  }

  /**
   * Method isAuthorized
   *
   *
   * @param rolesFactory
   * @param person
   * @param function
   * @param qualifier
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static Boolean isAuthorized(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceimpl.mit.roles.Function function,
          org.okiproject.serviceimpl.mit.roles.Qualifier qualifier)
  throws Exception {
    try {
      if (null != rolesFactory.getConnection()) {
        org.okiproject.serviceapi.dbc.Connection connection =
          rolesFactory.getConnection();
        Object[]                                 args       = new Object[4];

        args[0] =
          ((org.okiproject.serviceimpl.mit.roles.Person) person).getKerberosName();
        args[1] =
          ((org.okiproject.serviceimpl.mit.roles.FunctionCategory) function.getFunctionCategory()).getCategory();
        args[2] = function.getName();
        args[3] = qualifier.getCode();

        int[] columnTypes = new int[4];

        columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnReturn;
        columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;

        int[] dataTypes = new int[4];

        dataTypes[0] = java.sql.Types.VARCHAR;
        dataTypes[1] = java.sql.Types.VARCHAR;
        dataTypes[2] = java.sql.Types.VARCHAR;
        dataTypes[3] = java.sql.Types.VARCHAR;

        org.okiproject.serviceapi.dbc.Table table =
          connection.callProcedure(IS_USER_AUTHORIZED, args, columnTypes,
                                   dataTypes);

        if (null != table) {
          org.okiproject.serviceapi.dbc.Rows rows = table.getRows();

          if (null != rows) {
            if (rows.hasMoreRows()) {
              Object[] row = rows.nextRow();

              return (((String) row[0]).equals("Y")
                      ? new Boolean(true)
                      : new Boolean(false));
            }
          }
        }
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.QUERYAUTHORIZATIONFAILED);
  }

  private static String getAuthorizationDetailSQL(Number id)
  throws Exception {
    if (null != id) {
      String sql = "select";

      sql += " authorization_id, function_id, qualifier_id,";
      sql += " kerberos_name, function_name, qualifier_name,";
      sql += " function_category, qualifier_code,";
      sql += " modified_by, modified_date,";
      sql += " do_function, grant_and_view,";
      sql += " effective_date, expiration_date";
      sql += " from authorization";
      sql += " where authorization_id = '" + id + "'";

      return sql;
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.NULLARGUMENT);
  }

  private static Object getFieldFromTable(String fieldName,
                                          String[] columnNames, Object[] row)
  throws Exception {
    if ((null != columnNames) && (null != row)) {
      int col = -1;

      for (int i = 0; columnNames.length != i; i++) {
        if (fieldName.equals(columnNames[i])) {
          col = i;

          break;
        }
      }

      if (-1 != col) {
        return row[col];
      }
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.AUTHORIZATIONFIELDDOESNOTEXIST);
  }

  private static java.util.Properties getPropertiesFromTable(
          org.okiproject.serviceimpl.mit.roles.RolesFactory factory,
          org.okiproject.serviceapi.dbc.Table table)
  throws Exception {
    if (null != table) {
      Object                             functionId          = null;
      String                             functionCategoryStr = null;
      String                             kerberosName        = null;
      String                             functionName        = null;
      Object                             qualifierId         = null;
      String                             qualifierCode       = null;
      String                             qualifierName       = null;
      org.okiproject.serviceapi.dbc.Rows rows                =
        table.getRows();

      if (rows.hasMoreRows()) {
        Object[]             row         = rows.nextRow();
        String[]             columnNames = rows.getColumnNames();
        java.util.Properties properties  = new java.util.Properties();

        for (int i = 0; columnNames.length != i; i++) {
          if ((null != columnNames[i]) && (null != row[i])
                  &&!(columnNames[i].equals(""))
                  &&!(columnNames[i].equalsIgnoreCase("NULL"))) {
            if (columnNames[i].equals("KERBEROS_NAME")) {
              kerberosName = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("FUNCTION_CATEGORY")) {
              functionCategoryStr = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("FUNCTION_NAME")) {
              functionName = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("QUALIFIER_CODE")) {
              qualifierCode = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("QUALIFIER_NAME")) {
              qualifierName = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("IS_ACTIVE_NOW")) {
              Boolean isActiveNow = new Boolean("Y".equals((String) row[i]));

              properties.put(columnNames[i], isActiveNow);
            }
            else if (columnNames[i].equals("GRANT_AUTHORIZATION")) {
              Boolean grantAuthorization =
                new Boolean("Y".equals((String) row[i]));

              properties.put(columnNames[i], grantAuthorization);
            }
            else if (columnNames[i].equals("AUTHORIZATION_ID")) {
              properties.put(columnNames[i], row[i]);
              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("FUNCTION_ID")) {
              functionId = row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("QUALIFIER_ID")) {
              qualifierId = row[i];

              properties.put(columnNames[i], row[i]);
            }
            else {
              properties.put(columnNames[i], row[i]);
            }
          }
        }

        org.okiproject.serviceimpl.mit.roles.FunctionCategory functionCategory =
          new org.okiproject.serviceimpl.mit.roles.FunctionCategory(factory,
            functionCategoryStr, null);

        org.okiproject.serviceimpl.mit.roles.Function         function =
          new org.okiproject.serviceimpl.mit.roles.Function(factory,
            functionId, functionName, null, functionCategory, null);

        properties.put("FUNCTION", function);

        org.okiproject.serviceimpl.mit.roles.Qualifier qualifier =
          new org.okiproject.serviceimpl.mit.roles.Qualifier(factory,
            qualifierId, qualifierCode, qualifierName, null);

        properties.put("QUALIFIER", qualifier);

        org.okiproject.serviceimpl.mit.roles.Person person =
          new org.okiproject.serviceimpl.mit.roles.Person( factory, kerberosName,
            null, null, null, null, null, null, null, null, null, null, null);

        properties.put("PERSON", person);

        return properties;
      }
    }

    return null;
  }
}
