package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/Authorizations.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.14 $ / $Date: 2002/02/16 17:10:36 $
*/
public class Authorizations
implements org.okiproject.serviceapi.authorization.Authorizations,
           java.io.Serializable {
  private static final String                                 ALGORITHM_SIMPLE =
    "SIMPLE";
  private static final String                                 ALGORITHM_F_WITH_Q =
    "F_WITH_Q";
  private static final String                                 ALGORITHM_WHO_CAN_DO =
    "WHO_CAN_DO";
  private static final String                                 GETAUTHORIZATIONSQUERYSQL =
    "ROLESAPI_GET_SQL_AUTH1";
  private static final String                                 DONT_EXPAND_FUNCTIONS =
    "N";
  private static final String                                 DONT_EXPAND_QUALIFIERS =
    "N";

  protected org.okiproject.serviceapi.dbc.Rows                rows         =
    null;
  protected org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory =
    null;

  /**
   * Method hasMoreAuthorizations
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public boolean hasMoreAuthorizations()
  throws Exception {
    if (null != this.rows) {
      return this.rows.hasMoreRows();
    }

    return false;
  }

  /**
   * Method nextAuthorization
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorization nextAuthorization()
  throws Exception {
    if (null != this.rows) {
      if (this.rows.hasMoreRows()) {
        return getAuthorization(this.rows.getColumnNames(),
                                this.rows.nextRow());
      }
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.AUTHORIZATIONENUMERATIONFAILED);
  }

  /**
   * Method getAuthorizationsForPerson
   *
   *
   * @param rolesFactory
   * @param person
   * @param functionCategory
   * @param isActiveNow
   * @param start
   * @param number
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthorizationsForPerson(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          Boolean isActiveNow, int start, int number)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE, null,
                                      person, null, null, isActiveNow, null,
                                      null);
  }

  /**
   * Given a Function and a Qualifier
   * returns an enumeration of all Authorizations that would allow people
   * to do the Function with Qualifier. This method differs from the simple
   * form of getAuthsSimpleForm in that this method looks for any Authorization
   * that permits doing the Function with the Qualifier even if the Authorization's
   * Qualifier happens to be a parent of this Qualifier argument.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsForDoingFWithQ(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_F_WITH_Q, null,
                                      null, function, qualifier, isActiveNow,
                                      null, null);
  }

  /**
   * Given a FunctionCategory and a Qualifier
   * returns an enumeration of all Authorizations that would allow people
   * to do Functions in the FunctionCategory with Qualifier. This method differs
   * from getAuthsSimpleForm in that this method looks for any Authorization
   * that permits doing the Function with the Qualifier even if the
   * Authorization's Qualifier happens to be a parent of the Qualifier argument.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsForDoingFWithQ(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_F_WITH_Q,
                                      (Object) null, (String) null,
                                      (Object) null, (String) null,
                                      (String) ((null == functionCategory)
                                                ? null
                                                : functionCategory.getCategory()), (Object) ((null
                                                        == qualifier)
                                                                                             ? null
                                                                                             : qualifier.getId()), (String) ((null
                                                                                                                              == qualifier)
                                                                                                                             ? null
                                                                                                                             : qualifier.getCode()), (String) ((null
                                                                                                                                                                == qualifier)
                                                                                                                                                               ? null
                                                                                                                                                               : ((null
                                                                                                                                                                   == qualifier.getQualifierType().getType())
                                                                                                                                                                  ? null
                                                                                                                                                                  : qualifier.getQualifierType().getType())), (String) ((null == isActiveNow)
                                                                                                                                                                                                                        ? null
                                                                                                                                                                                                                        : (isActiveNow.booleanValue()
                                                                                                                                                                                                                           ? "Y"
                                                                                                                                                                                                                           : "N")), (String) DONT_EXPAND_FUNCTIONS, (String) DONT_EXPAND_QUALIFIERS);
  }

  /**
   * Given at a Person, a Function, and a Qualifier
   * returns an enumeration of matching authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE, null,
                                      person, function, qualifier,
                                      isActiveNow, expandFunctions,
                                      expandQualifiers);
  }

  /**
   * Given at a Person, a FunctionCategory, and a Qualifier
   * returns an enumeration of matching authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE,
                                      (Object) null,
                                      (String) ((null == person)
                                                ? null
                                                : ((org.okiproject.serviceimpl.mit.roles.Person) person).getKerberosName()), (Object) null,
                                                        (String) null,
                                                        (String) ((null
                                                                   == functionCategory)
                                                                  ? null
                                                                  : functionCategory.getCategory()), (Object) ((null
                                                                          == qualifier)
                                                                                                               ? null
                                                                                                               : qualifier.getId()), (String) ((null
                                                                                                                                                == qualifier)
                                                                                                                                               ? null
                                                                                                                                               : qualifier.getCode()), (String) ((null
                                                                                                                                                                                  == qualifier)
                                                                                                                                                                                 ? null
                                                                                                                                                                                 : ((null
                                                                                                                                                                                     == qualifier.getQualifierType().getType())
                                                                                                                                                                                    ? null
                                                                                                                                                                                    : qualifier.getQualifierType().getType())), (String) ((null == isActiveNow)
                                                                                                                                                                                                                                          ? null
                                                                                                                                                                                                                                          : (isActiveNow.booleanValue()
                                                                                                                                                                                                                                             ? "Y"
                                                                                                                                                                                                                                             : "N")), (String) ((null == expandFunctions)
                                                                                                                                                                                                                                                                ? null
                                                                                                                                                                                                                                                                : (expandFunctions.booleanValue()
                                                                                                                                                                                                                                                                   ? "Y"
                                                                                                                                                                                                                                                                   : "N")), (String) ((null == expandQualifiers)
                                                                                                                                                                                                                                                                                      ? null
                                                                                                                                                                                                                                                                                      : (expandQualifiers.booleanValue()
                                                                                                                                                                                                                                                                                         ? "Y"
                                                                                                                                                                                                                                                                                         : "N")));
  }

  /**
   * Given a Person and a Function
   * returns an enumeration of Authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE, null,
                                      person, function, null, isActiveNow,
                                      expandFunctions, expandQualifiers);
  }

  /**
   * Given a Person and a FunctionCategory
   * returns an enumeration of Authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE,
                                      (Object) null,
                                      (String) ((null == person)
                                                ? null
                                                : ((org.okiproject.serviceimpl.mit.roles.Person) person).getKerberosName()), (Object) null,
                                                        (String) null,
                                                        (String) ((null
                                                                   == functionCategory)
                                                                  ? null
                                                                  : functionCategory.getCategory()), (Object) null,
                                                                                                     (String) null,
                                                                                                     (String) null,
                                                                                                     (String) ((null
                                                                                                       == isActiveNow)
                                                                                                               ? null
                                                                                                               : (isActiveNow.booleanValue()
                                                                                                                  ? "Y"
                                                                                                                  : "N")), (String) ((null
                                                                                                                                      == expandFunctions)
                                                                                                                                     ? null
                                                                                                                                     : (expandFunctions.booleanValue()
                                                                                                                                        ? "Y"
                                                                                                                                        : "N")), (String) ((null
                                                                                                                                                            == expandQualifiers)
                                                                                                                                                           ? null
                                                                                                                                                           : (expandQualifiers.booleanValue()
                                                                                                                                                              ? "Y"
                                                                                                                                                              : "N")));
  }

  /**
   * Given a Person and a Qualifier
   * returns an enumeration of Authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE, null,
                                      person, null, qualifier, isActiveNow,
                                      expandFunctions, expandQualifiers);
  }

  /**
   * Given a Person
   * returns an enumeration of Authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Person person,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE, null,
                                      person, null, null, isActiveNow,
                                      expandFunctions, expandQualifiers);
  }

  /**
   * Given a Function and a Qualifier
   * returns an enumeration of matching authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE, null,
                                      null, function, qualifier, isActiveNow,
                                      expandFunctions, expandQualifiers);
  }

  /**
   * Given a Qualifier
   * returns an enumeration of matching authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE, null,
                                      null, null, qualifier, isActiveNow,
                                      expandFunctions, expandQualifiers);
  }

  /**
   * Given a FunctionCategory and a Qualifier
   * returns an enumeration of matching authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE,
                                      (Object) null, (String) null,
                                      (Object) null, (String) null,
                                      (String) ((null == functionCategory)
                                                ? null
                                                : functionCategory.getCategory()), (Object) ((null
                                                        == qualifier)
                                                                                             ? null
                                                                                             : qualifier.getId()), (String) ((null
                                                                                                                              == qualifier)
                                                                                                                             ? null
                                                                                                                             : qualifier.getCode()), (String) ((null
                                                                                                                                                                == qualifier)
                                                                                                                                                               ? null
                                                                                                                                                               : ((null
                                                                                                                                                                   == qualifier.getQualifierType().getType())
                                                                                                                                                                  ? null
                                                                                                                                                                  : qualifier.getQualifierType().getType())), (String) ((null == isActiveNow)
                                                                                                                                                                                                                        ? null
                                                                                                                                                                                                                        : (isActiveNow.booleanValue()
                                                                                                                                                                                                                           ? "Y"
                                                                                                                                                                                                                           : "N")), (String) ((null == expandFunctions)
                                                                                                                                                                                                                                              ? null
                                                                                                                                                                                                                                              : (expandFunctions.booleanValue()
                                                                                                                                                                                                                                                 ? "Y"
                                                                                                                                                                                                                                                 : "N")), (String) ((null == expandQualifiers)
                                                                                                                                                                                                                                                                    ? null
                                                                                                                                                                                                                                                                    : (expandQualifiers.booleanValue()
                                                                                                                                                                                                                                                                       ? "Y"
                                                                                                                                                                                                                                                                       : "N")));
  }

  /**
   * Given a Function
   * returns an enumeration of matching authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Function function,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE, null,
                                      null, function, null, isActiveNow,
                                      expandFunctions, expandQualifiers);
  }

  /**
   *
   * @param rolesFactory
   * @param authorizationID
   * @param isActiveNow
   * @param expandFunctions
   * @param expandQualifiers
   * @return an enumeration of matching authorizations
   * (should return 1 authorization, unless user has requested
   * expansion by Functions or Qualifiers).
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          Object authorizationID, Boolean isActiveNow,
          Boolean expandFunctions, Boolean expandQualifiers)
  throws Exception {
    return getAuthsSimpleFormInternal(rolesFactory, ALGORITHM_SIMPLE,
                                      authorizationID, null, null, null,
                                      isActiveNow, expandFunctions,
                                      expandQualifiers);
  }

  private static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleFormInternal(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String algorithm, Object authorizationId,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    String kerberosName        = (null == person)
                                 ? null
                                 : ((org.okiproject.serviceimpl.mit.roles.Person) person).getKerberosName();
    String functionCategory    = (null == function)
                                 ? null
                                 : ((null == function.getFunctionCategory())
                                    ? null
                                    : function.getFunctionCategory().getCategory());
    String functionName        = (null == function)
                                 ? null
                                 : function.getName();
    Object functionId          = (null == function)
                                 ? null
                                 : function.getId();
    String qualifierType       = (null == qualifier)
                                 ? null
                                 : ((null
                                     == qualifier.getQualifierType().getType())
                                    ? null
                                    : qualifier.getQualifierType().getType());
    String qualifierCode       = (null == qualifier)
                                 ? null
                                 : qualifier.getCode();
    Object qualifierId         = (null == qualifier)
                                 ? null
                                 : qualifier.getId();
    String expandFunctionsStr  = (null == expandFunctions)
                                 ? "N"
                                 : (expandFunctions.booleanValue()
                                    ? "Y"
                                    : "N");
    String expandQualifiersStr = (null == expandQualifiers)
                                 ? "N"
                                 : (expandQualifiers.booleanValue()
                                    ? "Y"
                                    : "N");
    String isActiveNowStr      = (null == isActiveNow)
                                 ? "Y"
                                 : (isActiveNow.booleanValue()
                                    ? "Y"
                                    : "N");

    return getAuthsSimpleFormInternal(rolesFactory, algorithm,
                                      authorizationId, kerberosName,
                                      functionId, functionName,
                                      functionCategory, qualifierId,
                                      qualifierCode, qualifierType,
                                      isActiveNowStr, expandFunctionsStr,
                                      expandQualifiersStr);
  }

  private static org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleFormInternal(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String algorithm, Object authorizationId, String kerberosName,
          Object functionId, String functionName, String functionCategory,
          Object qualifierId, String qualifierCode, String qualifierType,
          String isActiveNowStr, String expandFunctionsStr,
          String expandQualifiersStr)
  throws Exception {
    try {
      if ((null != isActiveNowStr) && (null != expandFunctionsStr)
              && (null != expandQualifiersStr)) {
        String                                         sqlQuery       =
          getAuthSQL(rolesFactory, algorithm, expandQualifiersStr,
                     isActiveNowStr, authorizationId, functionCategory,
                     functionName, functionId, qualifierType, qualifierCode,
                     qualifierId, kerberosName);
        org.okiproject.serviceapi.authorization.Authorizations authorizations =
          getAuthorizations(rolesFactory, sqlQuery);

        if (!authorizations.hasMoreAuthorizations()) {
          org.okiproject.serviceapi.authorization.Person person = null;

          if (null != kerberosName) {
            person =
              new org.okiproject.serviceimpl.mit.roles.Person(rolesFactory,
                kerberosName, null, null, null, null, null, null, null, null,
                null, null, null);

            if (null != person) {
              if (!person.isFoundInRoles().booleanValue()) {
                throw new org.okiproject.serviceapi.authorization.RolesException(
                  org.okiproject.serviceapi.authorization.RolesException.PERSONNOTFOUNDINROLES);
              }
            }
          }

          org.okiproject.serviceapi.authorization.Function function = null;

          if ((null != functionName)
                  && ((null != functionCategory)
                      || (null != qualifierType))) {
            org.okiproject.serviceapi.authorization.FunctionCategory fc = null;

            if (null != functionCategory) {
              fc = new org.okiproject.serviceimpl.mit.roles.FunctionCategory(
                rolesFactory, functionCategory, null);
            }

            org.okiproject.serviceapi.authorization.QualifierType qt = null;

            if (null != qualifierType) {
              qt = new org.okiproject.serviceimpl.mit.roles.QualifierType(
                rolesFactory, qualifierType, null);
            }

            function =
              new org.okiproject.serviceimpl.mit.roles.Function(rolesFactory,
                functionName, (String) null, fc, qt);

            if (!rolesFactory.isFunctionFoundInRoles(
                    function).booleanValue()) {
              throw new org.okiproject.serviceapi.authorization.RolesException(
                org.okiproject.serviceapi.authorization.RolesException.FUNCTIONNOTFOUNDINROLES);
            }
          }

          org.okiproject.serviceapi.authorization.Qualifier qualifier = null;

          if (null != qualifierCode) {
            org.okiproject.serviceapi.authorization.QualifierType qt = null;

            if (null != qualifierType) {
              qt = new org.okiproject.serviceimpl.mit.roles.QualifierType(
                rolesFactory, qualifierType, null);
            }

            qualifier =
              new org.okiproject.serviceimpl.mit.roles.Qualifier(rolesFactory,
                qualifierCode, (String) null, qt);

            if (!rolesFactory.isQualifierFoundInRoles(
                    qualifier).booleanValue()) {
              throw new org.okiproject.serviceapi.authorization.RolesException(
                org.okiproject.serviceapi.authorization.RolesException.QUALIFIERNOTFOUNDINROLES);
            }
          }
        }

        return authorizations;
      }

      throw new org.okiproject.serviceapi.authorization.RolesException(
        org.okiproject.serviceapi.authorization.RolesException.QUERYAUTHORIZATIONFAILED);
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        new String(
          org.okiproject.serviceapi.authorization.RolesException.QUERYAUTHORIZATIONFAILED
          + ex.getMessage()));
    }
  }

  /**
   * Given a list of selection criteria field/value pairs
   * returns an enumeration of Authorizations.
   */
  public static org.okiproject.serviceapi.authorization.Authorizations getAuthsGeneralForm(
          org.okiproject.serviceapi.authorization.FieldValue[] selectionCriteria)
  throws Exception {
    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.UNIMPLEMENTED);
  }

  protected static org.okiproject.serviceapi.authorization.Authorizations getAuthorizations(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String sqlQuery)
  throws Exception {
    try {
      if ((null != rolesFactory) && (null != sqlQuery)) {
        org.okiproject.serviceapi.dbc.Connection            connection     =
          rolesFactory.getConnection();
        org.okiproject.serviceapi.dbc.Table                 table          =
          connection.executeQuery(sqlQuery);
        org.okiproject.serviceimpl.mit.roles.Authorizations authorizations =
          new org.okiproject.serviceimpl.mit.roles.Authorizations();

        authorizations.rolesFactory = rolesFactory;
        authorizations.rows         = table.getRows();

        return authorizations;
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.QUERYAUTHORIZATIONFAILED);
  }

  /**
   * @param algorithm is "SIMPLE" or "F_WITH_Q" or "WHO_CAN_DO"
   * @param expandQualifiers is either "Y" or "N", default is "N"
   * @param isActiveNow is either "Y" or "N", default is "N"
   */
  private static String getAuthSQL(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String algorithm, String expandQualifiers, String isActiveNow,
          Object authorizationId, String functionCategory,
          String functionName, Object functionId, String qualifierType,
          String qualifierCode, Object qualifierId, String kerberosName)
  throws Exception {
    if (null != rolesFactory) {
      org.okiproject.serviceapi.dbc.Connection connection =
        rolesFactory.getConnection();
      Object[]                                 args       = new Object[11];

      args[0]  = algorithm;
      args[1]  = expandQualifiers;
      args[2]  = isActiveNow;
      args[3]  = (null == authorizationId)
                 ? ""
                 : authorizationId.toString();
      args[4]  = functionCategory;
      args[5]  = functionName;
      args[6]  = (null == functionId)
                 ? ""
                 : functionId.toString();
      args[7]  = qualifierType;
      args[8]  = qualifierCode;
      args[9]  = (null == qualifierId)
                 ? ""
                 : qualifierId.toString();
      args[10] = kerberosName;

      int[] columnTypes = new int[12];

      columnTypes[0]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[4]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[5]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[6]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[7]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[8]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[9]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[10] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[11] = java.sql.DatabaseMetaData.procedureColumnOut;

      int[] dataTypes = new int[12];

      dataTypes[0]  = java.sql.Types.VARCHAR;
      dataTypes[1]  = java.sql.Types.VARCHAR;
      dataTypes[2]  = java.sql.Types.VARCHAR;
      dataTypes[3]  = java.sql.Types.VARCHAR;
      dataTypes[4]  = java.sql.Types.VARCHAR;
      dataTypes[5]  = java.sql.Types.VARCHAR;
      dataTypes[6]  = java.sql.Types.VARCHAR;
      dataTypes[7]  = java.sql.Types.VARCHAR;
      dataTypes[8]  = java.sql.Types.VARCHAR;
      dataTypes[9]  = java.sql.Types.VARCHAR;
      dataTypes[10] = java.sql.Types.VARCHAR;
      dataTypes[11] = java.sql.Types.VARCHAR;

      org.okiproject.serviceapi.dbc.Table tab =
        connection.callProcedure(GETAUTHORIZATIONSQUERYSQL, args,
                                 columnTypes, dataTypes);

      if (null != tab) {
        if (null != tab.getRows()) {
          org.okiproject.serviceapi.dbc.Rows rows = tab.getRows();

          if (rows.hasMoreRows()) {
            Object[] row = rows.nextRow();

            if (null != row) {
              String sql = (String) row[0];

              return sql;
            }
          }
        }
      }
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.AUTHORIZATIONENUMERATIONFAILED);
  }

  private org.okiproject.serviceapi.authorization.Authorization getAuthorization(
          String[] columnNames, Object[] row)
  throws Exception {
    if ((null != columnNames) && (null != row)) {
      java.util.Properties properties          = new java.util.Properties();
      Object               functionId          = null;
      String               functionCategoryStr = null;
      String               functionName        = null;
      Object               qualifierId         = null;
      String               qualifierCode       = null;
      String               qualifierName       = null;
      Boolean              grantAuthorization  = null;
      Boolean              isActiveNow         = null;
      Object               authorizationId     = null;
      String               kerberosName        = null;

      for (int i = 0; columnNames.length != i; i++) {
        if (columnNames[i].equals("KERBEROS_NAME")) {
          kerberosName = (String) row[i];
        }
        else if (columnNames[i].equals("FUNCTION_CATEGORY")) {
          functionCategoryStr = (String) row[i];
        }
        else if (columnNames[i].equals("FUNCTION_NAME")) {
          functionName = (String) row[i];
        }
        else if (columnNames[i].equals("QUALIFIER_CODE")) {
          qualifierCode = (String) row[i];
        }
        else if (columnNames[i].equals("QUALIFIER_NAME")) {
          qualifierName = (String) row[i];
        }
        else if (columnNames[i].equals("IS_ACTIVE_NOW")) {
          isActiveNow = new Boolean("Y".equals((String) row[i]));
        }
        else if (columnNames[i].equals("GRANT_AUTHORIZATION")) {
          grantAuthorization = new Boolean("Y".equals((String) row[i]));
        }
        else if (columnNames[i].equals("AUTHORIZATION_ID")) {
          authorizationId = row[i];
        }
        else if (columnNames[i].equals("FUNCTION_ID")) {
          functionId = row[i];
        }
        else if (columnNames[i].equals("QUALIFIER_ID")) {
          qualifierId = row[i];
        }

      }

      org.okiproject.serviceimpl.mit.roles.FunctionCategory functionCategory =
        new org.okiproject.serviceimpl.mit.roles.FunctionCategory(
          this.rolesFactory, functionCategoryStr, null);

      org.okiproject.serviceimpl.mit.roles.Function         function         =
        new org.okiproject.serviceimpl.mit.roles.Function(this.rolesFactory,
          functionId, functionName, null, functionCategory, null);

      org.okiproject.serviceimpl.mit.roles.Qualifier        qualifier        =
        new org.okiproject.serviceimpl.mit.roles.Qualifier(this.rolesFactory,
          qualifierId, qualifierCode, qualifierName, null);

      org.okiproject.serviceimpl.mit.roles.Person          person           =
        new org.okiproject.serviceimpl.mit.roles.Person(this.rolesFactory, kerberosName, null,
          null, null, null, null, null, null, null, null, null, null);

      properties.put("AUTHORIZATION_ID", authorizationId);
      properties.put("PERSON", person);
      properties.put("GRANT_AUTHROIZATION", grantAuthorization);
      properties.put("IS_ACTIVE_NOW", isActiveNow);
      properties.put("FUNCTION", function);
      properties.put("QUALIFIER", qualifier);

      return new org.okiproject.serviceimpl.mit.roles.Authorization(
        this.rolesFactory, properties);
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.AUTHORIZATIONENUMERATIONFAILED);
  }

}
