package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/Function.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.17 $ / $Date: 2002/02/16 17:10:36 $
*/
public class Function
implements org.okiproject.serviceapi.authorization.Function {
  private final static String                               FUNCTION_ID    =
    "FUNCTION_ID";
  private final static String                               FUNCTION_NAME  =
    "FUNCTION_NAME";
  private final static String                               FUNCTION_DESCRIPTION =
    "FUNCTION_DESCRIPTION";
  private final static String                               FUNCTION_CATEGORY =
    "FUNCTION_CATEGORY";
  private final static String                               QUALIFIER_TYPE =
    "QUALIFIER_TYPE";
  private final static String                               PRIMARY_AUTHORIZABLE =
    "PRIMARY_AUTHORIZABLE";
  private final static String                               MODIFIED_BY    =
    "MODIFIED_BY";
  private final static String                               MODIFIED_DATE  =
    "MODIFIED_DATE";

  private org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory   =
    null;

  /**
   * Method getRolesFactory
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceimpl.mit.roles.RolesFactory getRolesFactory() {
    return rolesFactory;
  }

  protected void setRolesFactory(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory) {
    this.rolesFactory = rolesFactory;
  }

  private java.util.Properties properties = null;

  /**
   * Method getProperties
   *
   *
   * @return
   *
   */
  public java.util.Properties getProperties() {
    return this.properties;
  }

  private void setProperties(java.util.Properties properties) {
    this.properties = properties;
  }

  protected Object getProperty(String propertyName) {
    if (null != this.properties) {
      Object obj = this.properties.get(propertyName);

      if (null == obj) {
        try {
          if (isFoundInRoles().booleanValue()) {
            obj = this.properties.get(propertyName);
          }
        }
        catch (Exception ex) {}
      }

      return obj;
    }

    return null;
  }

  protected void setProperty(String propertyName, Object property) {
    if (null == this.properties) {
      this.properties = new java.util.Properties();
    }

    if ((null != this.properties) && (null != propertyName)
            && (null != property)) {
      this.properties.put(propertyName, property);
    }
  }

  /**
   * Method getId
   *
   *
   * @return
   *
   */
  public Object getId() {
    return getProperty(FUNCTION_ID);
  }

  /**
   * Method setId
   *
   *
   * @param id
   *
   */
  public void setId(Object id) {
    setProperty(FUNCTION_ID, id);
  }

  /**
   * Method getName
   *
   *
   * @return
   *
   */
  public String getName() {
    return (String) getProperty(FUNCTION_NAME);
  }

  /**
   * Method setName
   *
   *
   * @param name
   *
   */
  public void setName(String name) {
    setProperty(FUNCTION_NAME, name);
  }

  /**
   * Method getDescription
   *
   *
   * @return
   *
   */
  public String getDescription() {
    return (String) getProperty(FUNCTION_DESCRIPTION);
  }

  protected void setDescription(String description) {
    setProperty(FUNCTION_DESCRIPTION, description);
  }

  /**
   * Method getFunctionCategory
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.authorization.FunctionCategory getFunctionCategory() {
    return (org.okiproject.serviceapi.authorization.FunctionCategory) getProperty(
      FUNCTION_CATEGORY);
  }

  /**
   * Method setFunctionCategory
   *
   *
   * @param functionCategory
   *
   */
  public void setFunctionCategory(
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory) {
    setProperty(FUNCTION_CATEGORY, functionCategory);
  }

  /**
   * Method getQualifierType
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.authorization.QualifierType getQualifierType() {
    return (org.okiproject.serviceapi.authorization.QualifierType) getProperty(
      QUALIFIER_TYPE);
  }

  /**
   * Method setQualifierType
   *
   *
   * @param qualifierType
   *
   */
  public void setQualifierType(
          org.okiproject.serviceapi.authorization.QualifierType qualifierType) {
    setProperty(QUALIFIER_TYPE, qualifierType);
  }

  // Y(es) N(o) D(eptartment)

  /**
   * Method getPrimaryAuthorizable
   *
   *
   * @return
   *
   */
  public String getPrimaryAuthorizable() {
    return (String) getProperty(PRIMARY_AUTHORIZABLE);
  }

  protected void setPrimaryAuthorizable(String primaryAuthorizable) {
    setProperty(PRIMARY_AUTHORIZABLE, primaryAuthorizable);
  }

  /**
   * Method getModifiedBy
   *
   *
   * @return
   *
   */
  public String getModifiedBy() {
    return (String) getProperty(MODIFIED_BY);
  }

  protected void setModifiedBy(String modifiedBy) {
    setProperty(MODIFIED_BY, modifiedBy);
  }

  /**
   * Method getModifiedDate
   *
   *
   * @return
   *
   */
  public java.sql.Timestamp getModifiedDate() {
    return (java.sql.Timestamp) getProperty(MODIFIED_DATE);
  }

  protected void setModifiedDate(java.sql.Timestamp modifiedDate) {
    setProperty(MODIFIED_DATE, modifiedDate);
  }

  private Boolean foundInRoles = new Boolean(false);

  /**
   * Method isFoundInRoles
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isFoundInRoles()
  throws Exception {
    if (!this.foundInRoles.booleanValue()) {
      this.foundInRoles = new Boolean(isIdInRoles()
                                      || isNameAndCategoryInRoles());
    }

    return this.foundInRoles;
  }

  /**
   * Method refresh
   *
   *
   * @throws Exception
   *
   */
  public void refresh()
  throws Exception {
    if (!isIdInRoles()) {
      isNameAndCategoryInRoles();
    }
  }

  /**
   * Constructor Function
   *
   *
   * @param rolesFactory
   * @param properties
   *
   */
  public Function(org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
                  java.util.Properties properties) {
    setRolesFactory(
      (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory);
    setProperties(properties);
  }

  /**
   * Constructor Function
   *
   *
   * @param rolesFactory
   * @param name
   * @param description
   * @param functionCategory
   * @param qualifierType
   *
   */
  public Function(
          org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
          String name, String description,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType) {
    setRolesFactory(
      (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory);
    setName(name);
    setDescription(description);
    setFunctionCategory(functionCategory);
    setQualifierType(qualifierType);
  }

  /**
   * Constructor Function
   *
   *
   * @param rolesFactory
   * @param id
   * @param name
   * @param description
   * @param functionCategory
   * @param qualifierType
   *
   */
  public Function(
          org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
          Object id, String name, String description,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType) {
    setRolesFactory(
      (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory);
    setId(id);
    setName(name);
    setDescription(description);
    setFunctionCategory(functionCategory);
    setQualifierType(qualifierType);
  }

  protected Function(
          org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
          Object id, String name, String description,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType,
          String primaryAuthorizable, String modifiedBy,
          java.sql.Timestamp modifiedDate) {
    setRolesFactory(
      (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory);
    setId(id);
    setName(name);
    setDescription(description);
    setFunctionCategory(functionCategory);
    setQualifierType(qualifierType);
    setPrimaryAuthorizable(primaryAuthorizable);
    setModifiedBy(modifiedBy);
    setModifiedDate(modifiedDate);
  }

  /**
   * Method delete
   *
   *
   * @throws Exception
   *
   */
  public void delete()
  throws Exception {
    try {
      org.okiproject.serviceimpl.mit.roles.RolesFactory factory =
        getRolesFactory();

      if ((null != factory) && (null != factory.getConnection())) {
        org.okiproject.serviceapi.dbc.Connection connection =
          factory.getConnection();
        Object[]                                 args       = new Object[3];

        args[0] = this.properties.get(FUNCTION_NAME);
        args[1] = (null == this.properties.get(FUNCTION_CATEGORY))
                  ? ""
                  : ((org.okiproject.serviceimpl.mit.roles.FunctionCategory) this.properties.get(
                    FUNCTION_CATEGORY)).getCategory();
        args[2] = ((null != factory.getForUser())
                   ? ((org.okiproject.serviceimpl.mit.common.Person) factory.getForUser()).getKerberosName()
                   : null);

        int[] columnTypes = new int[3];

        columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;

        int[] dataTypes = new int[3];

        dataTypes[0] = java.sql.Types.VARCHAR;
        dataTypes[1] = java.sql.Types.VARCHAR;
        dataTypes[2] = java.sql.Types.VARCHAR;

        connection.callProcedure("ROLESAPI_DELETE_FUNCTION", args,
                                 columnTypes, dataTypes);
        setRolesFactory(null);
        setId(null);
        setName(null);
        setDescription(null);
        setFunctionCategory(null);
        setQualifierType(null);
        setModifiedBy(null);
        setModifiedDate(null);

        return;
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDFUNCTION);
  }

  /**
   * Method update
   *
   *
   * @param newName
   * @param newDescription
   * @param newFunctionCategory
   * @param newQualifierType
   *
   * @throws Exception
   *
   */
  public void update(
          String newName, String newDescription,
          org.okiproject.serviceapi.authorization.FunctionCategory newFunctionCategory,
          org.okiproject.serviceapi.authorization.QualifierType newQualifierType)
  throws Exception {
    try {
      org.okiproject.serviceimpl.mit.roles.RolesFactory factory =
        getRolesFactory();

      if ((null != factory) && (null != factory.getConnection())
              && (null != this.properties.get(FUNCTION_ID))) {
        org.okiproject.serviceapi.dbc.Connection connection =
          factory.getConnection();
        Object[]                                 args       = new Object[7];

        args[0] = this.getName();
        args[1] =
          ((org.okiproject.serviceimpl.mit.roles.FunctionCategory) this.properties.get(
            FUNCTION_CATEGORY)).getCategory();
        args[2] = (null != newName)
                  ? newName
                  : this.properties.get(FUNCTION_NAME);
        args[3] = (null != newDescription)
                  ? newDescription
                  : this.properties.get(FUNCTION_DESCRIPTION);
        args[4] = (null != newFunctionCategory)
                  ? newFunctionCategory.getCategory()
                  : ((null != this.properties.get(FUNCTION_CATEGORY))
                     ? ((org.okiproject.serviceimpl.mit.roles.FunctionCategory) this.properties.get(
                       FUNCTION_CATEGORY)).getCategory()
                     : null);
        args[5] = (null != newQualifierType)
                  ? newQualifierType.getType()
                  : ((null != this.properties.get(QUALIFIER_TYPE))
                     ? ((org.okiproject.serviceimpl.mit.roles.QualifierType) this.properties.get(
                       QUALIFIER_TYPE)).getType()
                     : null);
        args[6] = ((null != factory.getForUser())
                   ? ((org.okiproject.serviceimpl.mit.common.Person) factory.getForUser()).getKerberosName()
                   : null);

        int[] columnTypes = new int[9];

        columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[4] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[5] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[6] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[7] = java.sql.DatabaseMetaData.procedureColumnOut;
        columnTypes[8] = java.sql.DatabaseMetaData.procedureColumnOut;

        int[] dataTypes = new int[9];

        dataTypes[0] = java.sql.Types.VARCHAR;
        dataTypes[1] = java.sql.Types.VARCHAR;
        dataTypes[2] = java.sql.Types.VARCHAR;
        dataTypes[3] = java.sql.Types.VARCHAR;
        dataTypes[4] = java.sql.Types.VARCHAR;
        dataTypes[5] = java.sql.Types.VARCHAR;
        dataTypes[6] = java.sql.Types.VARCHAR;
        dataTypes[7] = java.sql.Types.VARCHAR;
        dataTypes[8] = java.sql.Types.VARCHAR;

        org.okiproject.serviceapi.dbc.Table table =
          connection.callProcedure("ROLESAPI_UPDATE_FUNCTION", args,
                                   columnTypes, dataTypes);

        if (null != table) {
          setName((String) args[2]);
          setDescription((String) args[3]);

          org.okiproject.serviceimpl.mit.roles.FunctionCategory functionCategory =
            new org.okiproject.serviceimpl.mit.roles.FunctionCategory(factory,
              (String) args[4], null);

          setFunctionCategory(functionCategory);

          org.okiproject.serviceimpl.mit.roles.QualifierType qualifierType =
            new org.okiproject.serviceimpl.mit.roles.QualifierType(factory,
              (String) args[5], (String) null);

          setQualifierType(qualifierType);

          org.okiproject.serviceapi.dbc.Rows rows = table.getRows();

          if (rows.hasMoreRows()) {
            Object[] row = rows.nextRow();

            setModifiedBy((String) row[0]);
            setModifiedDate(factory.createSqlTimestamp((String) row[1]));
          }

          return;
        }
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDFUNCTION);
  }

  /**
   * Method create
   *
   *
   * @param rolesFactory
   * @param name
   * @param description
   * @param functionCategory
   * @param qualifierType
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.authorization.Function create(
          org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
          String name, String description,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType)
  throws Exception {
    try {
      org.okiproject.serviceimpl.mit.roles.RolesFactory factory =
        (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory;

      if ((null != factory) && (null != factory.getConnection())
              && (null != name) && (null != description)
              && (null != functionCategory) && (null != qualifierType)) {
        org.okiproject.serviceapi.dbc.Connection connection =
          factory.getConnection();
        Object[]                                 args       = new Object[5];

        args[0] = name.toUpperCase();
        args[1] = description;
        args[2] = functionCategory.getCategory().toUpperCase();
        args[3] = qualifierType.getType().toUpperCase();
        args[4] = ((null != factory.getForUser())
                   ? ((org.okiproject.serviceimpl.mit.common.Person) factory.getForUser()).getKerberosName()
                   : null);

        int[] columnTypes = new int[8];

        columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[4] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[5] = java.sql.DatabaseMetaData.procedureColumnOut;
        columnTypes[6] = java.sql.DatabaseMetaData.procedureColumnOut;
        columnTypes[7] = java.sql.DatabaseMetaData.procedureColumnOut;

        int[] dataTypes = new int[8];

        dataTypes[0] = java.sql.Types.VARCHAR;
        dataTypes[1] = java.sql.Types.VARCHAR;
        dataTypes[2] = java.sql.Types.VARCHAR;
        dataTypes[3] = java.sql.Types.VARCHAR;
        dataTypes[4] = java.sql.Types.VARCHAR;
        dataTypes[5] = java.sql.Types.VARCHAR;
        dataTypes[6] = java.sql.Types.VARCHAR;
        dataTypes[7] = java.sql.Types.VARCHAR;

        org.okiproject.serviceapi.dbc.Table      table    =
          connection.callProcedure("ROLESAPI_CREATE_FUNCTION", args,
                                   columnTypes, dataTypes);
        org.okiproject.serviceapi.authorization.Function function =
          getFunction(factory, name.toUpperCase(), functionCategory);

        if (null != function) {
          return (org.okiproject.serviceapi.authorization.Function) function;
        }
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDFUNCTION);
  }

  /**
   * Method getFunction
   *
   *
   * @param rolesFactory
   * @param functionName
   * @param functionCategory
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.authorization.Function getFunction(
          org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
          String functionName,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory)
  throws Exception {
    try {
      org.okiproject.serviceimpl.mit.roles.RolesFactory factory =
        (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory;

      if ((null != factory) && (null != factory.getConnection())) {
        org.okiproject.serviceapi.dbc.Connection connection =
          factory.getConnection();
        org.okiproject.serviceapi.dbc.Table      table      =
          connection.executeQuery(
            getFunctionSQL(functionName, functionCategory.getCategory()));

        if (null != table) {
          java.util.Properties properties = getPropertiesFromTable(factory,
                                              table);

          if (null != properties) {
            org.okiproject.serviceimpl.mit.roles.Function function =
              new org.okiproject.serviceimpl.mit.roles.Function(rolesFactory,
                properties);

            return function;
          }
        }
        else {
          if (!factory.isFunctionCategoryFoundInRoles(
                  functionCategory).booleanValue()) {
            throw new org.okiproject.serviceapi.authorization.RolesException(
              org.okiproject.serviceapi.authorization.RolesException.FUNCTIONCATEGORYNOTFOUNDINROLES);
          }
        }
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDFUNCTION);
  }

  private static String getFunctionSQL(String functionName,
                                       String functionCategory) {
    String sql = "select";

    sql +=
      " function_id, function_name, function_description, function_category,";
    sql += " modified_by, modified_date, qualifier_type";
    sql += " from function";
    sql += " where function_name = '" + functionName + "'";
    sql += " and function_category = '" + functionCategory + "'";

    return sql;
  }

  private boolean isIdInRoles()
  throws Exception {
    org.okiproject.serviceimpl.mit.roles.RolesFactory factory =
      getRolesFactory();

    if ((null != factory) && (null != factory.getConnection())
            && (null != this.properties.get(FUNCTION_ID))) {
      org.okiproject.serviceapi.dbc.Connection connection =
        factory.getConnection();
      org.okiproject.serviceapi.dbc.Table      table      =
        connection.executeQuery(
          new String(
            "select function_id," + " function_name, function_description,"
            + " function_category, qualifier_type,"
            + " primary_authorizable, modified_by," + " modified_date"
            + " from function" + " where function_id = '"
            + this.properties.get(FUNCTION_ID) + "'"));

      if (null != table) {
        java.util.Properties properties = getPropertiesFromTable(factory,
                                            table);

        if (null != properties) {
          setProperties(properties);

          return true;
        }
      }
    }

    return false;
  }

  private boolean isNameAndCategoryInRoles()
  throws Exception {
    org.okiproject.serviceimpl.mit.roles.RolesFactory factory =
      getRolesFactory();

    if ((null != factory) && (null != factory.getConnection())
            && (null != this.properties.get(FUNCTION_NAME))
            && (null != this.properties.get(FUNCTION_CATEGORY))
            && (null
                != ((org.okiproject.serviceimpl.mit.roles.FunctionCategory) this.properties.get(
                  FUNCTION_CATEGORY)).getCategory())) {
      org.okiproject.serviceapi.dbc.Connection connection =
        factory.getConnection();
      org.okiproject.serviceapi.dbc.Table      table      = connection.executeQuery(
        new String(
          "select" + " function_id, function_name, function_description, "
          + " function_category, qualifier_type, "
          + " primary_authorizable, modified_by, " + " modified_date "
          + " from function " + " where function_name = '"
          + this.properties.get(FUNCTION_NAME) + "'"
          + " and function_category = '"
          + ((org.okiproject.serviceimpl.mit.roles.FunctionCategory) this.properties.get(FUNCTION_CATEGORY)).getCategory()
          + "'"));

      if (null != table) {
        java.util.Properties properties = getPropertiesFromTable(factory,
                                            table);

        if (null != properties) {
          setProperties(properties);

          return true;
        }
      }
    }

    return false;
  }

  private static java.util.Properties getPropertiesFromTable(
          org.okiproject.serviceimpl.mit.roles.RolesFactory factory,
          org.okiproject.serviceapi.dbc.Table table)
  throws Exception {
    if (null != table) {
      org.okiproject.serviceapi.dbc.Rows rows = table.getRows();

      if (rows.hasMoreRows()) {
        Object[]             row         = rows.nextRow();
        String[]             columnNames = rows.getColumnNames();

        java.util.Properties properties  = new java.util.Properties();

        for (int i = 0; columnNames.length != i; i++) {
          if ((null != columnNames[i]) && (null != row[i])
                  &&!(columnNames[i].equals(""))
                  &&!(columnNames[i].equalsIgnoreCase("NULL"))) {
            if (columnNames[i].trim().equals("FUNCTION_CATEGORY")) {
              properties.put(
                columnNames[i],
                new org.okiproject.serviceimpl.mit.roles.FunctionCategory(
                  factory, (String) row[i], (String) null));
            }
            else if (columnNames[i].trim().equals("QUALIFIER_TYPE")) {
              properties.put(
                columnNames[i],
                new org.okiproject.serviceimpl.mit.roles.QualifierType(
                  factory, (String) row[i], (String) null));
            }
            else {
              properties.put(columnNames[i], row[i]);
            }
          }
        }

        return properties;
      }
    }

    return null;
  }
}
