package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/FunctionCategory.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.7 $ / $Date: 2002/02/16 17:10:36 $
*/
public class FunctionCategory
implements org.okiproject.serviceapi.authorization.FunctionCategory {
  private final static String                                      FUNCTION_DESCRIPTION =
    "FUNCTION_CATEGORY_DESC";

  private static org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory =
    null;

  /**
   * Method getRolesFactory
   *
   *
   * @return
   *
   */
  public static org.okiproject.serviceimpl.mit.roles.RolesFactory getRolesFactory() {
    return rolesFactory;
  }

  protected static void setRolesFactory(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rFactory) {
    rolesFactory = rFactory;
  }

  private String category = null;

  /**
   * Method getCategory
   *
   *
   * @return
   *
   */
  public String getCategory() {
    return this.category;
  }

  /**
   * Method setCategory
   *
   *
   * @param category
   *
   */
  public void setCategory(String category) {
    this.category = category;
  }

  private String description = null;

  /**
   * Method getDescription
   *
   *
   * @return
   *
   */
  public String getDescription() {
    if (null == this.description) {
      try {
        refresh();
      }
      catch (Exception ex) {}
    }

    return this.description;
  }

  private void setDescription(String description) {
    this.description = description;
  }

  private Boolean foundInRoles = new Boolean(false);

  /**
   * Method isFoundInRoles
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isFoundInRoles()
  throws Exception {
    if (!this.foundInRoles.booleanValue()) {
      refresh();
    }

    return this.foundInRoles;
  }

  /**
   * Method refresh
   *
   *
   * @throws Exception
   *
   */
  public void refresh()
  throws Exception {
    if ((null != getCategory()) && (null != getRolesFactory())
            && (null != getRolesFactory().getConnection())) {
      org.okiproject.serviceapi.dbc.Connection connection =
        getRolesFactory().getConnection();
      org.okiproject.serviceapi.dbc.Table      table      =
        connection.executeQuery(new String("select"
                                           + " function_category_desc"
                                           + " from category"
                                           + " where function_category = '"
                                           + getCategory() + "'"));

      if (null != table) {
        org.okiproject.serviceapi.dbc.Rows rows = table.getRows();

        if (rows.hasMoreRows()) {
          Object[] row = rows.nextRow();

          setDescription((String) row[rows.getColumn(FUNCTION_DESCRIPTION)]);

          this.foundInRoles = new Boolean(true);
        }
      }
    }
  }

  /**
   * Constructor FunctionCategory
   *
   *
   * @param rolesFactory
   * @param category
   * @param description
   *
   */
  public FunctionCategory(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String category, String description) {
    setRolesFactory(rolesFactory);
    setCategory(category);
    setDescription(description);
  }

}
