package org.okiproject.serviceimpl.mit.roles ;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/Person.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.6 $ / $Date: 2002/02/16 17:10:36 $
*/
public class Person
extends org.okiproject.serviceimpl.mit.common.Person
implements org.okiproject.serviceapi.authorization.Person
{
	private static String EMAIL_ADDR = "EMAIL_ADDR" ;
	private static String DEPT_CODE = "DEPT_CODE" ;
	private static String DEPT_NAME = "DEPT_NAME" ;
	private static String PRIMARY_PERSON_TYPE = "PRIMARY_PERSON_TYPE" ;
	private static String ACTIVE = "ACTIVE" ;
	private static String STATUS_CODE = "STATUS_CODE" ;
	private static String STATUS_DATE = "STATUS_DATE" ;

	private org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory = null ;
	public org.okiproject.serviceimpl.mit.roles.RolesFactory getRolesFactory() { return rolesFactory ; }

	public void setRolesFactory( org.okiproject.serviceimpl.mit.roles.RolesFactory rFactory )
		{ rolesFactory = rFactory ; }

    public Object getProperty( String propertyName )
		{
			if( null != getProperties() )
			{
				Object obj = getProperties().get( propertyName ) ;

				if( null == obj )
				{
					try
					{
						if( isFoundInRoles().booleanValue() )
						{
							obj = getProperties().get( propertyName ) ;
						}
					}
					catch( Exception ex )
					{
					}
				}
				return obj ;
			}
			return null ;
		}

	protected String getEmailAddr()
	{
		return ( String ) getProperty( EMAIL_ADDR ) ;
	}
	private void setEmailAddr( String emailAddr )
	{
		setProperty( EMAIL_ADDR , emailAddr ) ;
	}

	protected String getDeptCode()
	{
		return ( String ) getProperty( DEPT_CODE ) ;
	}
	private void setDeptCode( String deptCode )
	{
		setProperty( DEPT_CODE , deptCode ) ;
	}

	protected String getDeptName()
	{
		return ( String ) getProperty( DEPT_NAME ) ;
	}
	private void setDeptName( String deptName )
	{
		setProperty( DEPT_NAME , deptName ) ;
	}

	protected String getPrimaryPersonType()
	{
		return ( String ) getProperty( PRIMARY_PERSON_TYPE ) ;
	}
	private void setPrimaryPersonType( String primaryPersonType )
	{
		setProperty( PRIMARY_PERSON_TYPE , primaryPersonType ) ;
	}

	// A(ctive) I(nactive)
	protected String getActive()
	{
		return ( String ) getProperty( ACTIVE ) ;
	}
	private void setActive( String active )
	{
		setProperty( ACTIVE , active ) ;
	}

	protected String getStatusCode()
	{
		return ( String ) getProperty( STATUS_CODE ) ;
	}
	private void setStatusCode( String statusCode )
	{
		setProperty( STATUS_CODE , statusCode ) ;
	}

	protected java.sql.Timestamp getStatusDate()
	{
		return ( java.sql.Timestamp ) getProperty( STATUS_DATE ) ;
	}
	private void setStatusDate( java.sql.Timestamp statusDate )
	{
		setProperty( STATUS_DATE , statusDate ) ;
	}

	private Boolean foundInRoles = new Boolean( false ) ;
	public Boolean isFoundInRoles()
		throws Exception
	{
		if( ! this.foundInRoles.booleanValue() )
		{
			findInRoles() ;
		}
		return this.foundInRoles ;
	}

	private void findInRoles()
		throws Exception
	{
		if( ( null != getProperties() )
		&&  ( null != getProperties().get( KERBEROS_NAME )  )
		&&  ( null != getRolesFactory() )
		&&  ( null != getRolesFactory().getConnection() )
		)
		{
			String sql
				= new String
					( "select kerberos_name, "
					+ " mit_id, last_name,"
					+ " first_name, email_addr,"
					+ " dept_code, primary_person_type,"
					+ " active, status_code, status_date"
					+ " from person"
					+ " where kerberos_name = '" + getProperties().get( KERBEROS_NAME ) + "'"
					) ;

			org.okiproject.serviceapi.dbc.Connection connection = getRolesFactory().getConnection() ;
			org.okiproject.serviceapi.dbc.Table table
				= connection.executeQuery
					( sql
					) ;

			if( null != table )
			{
	            java.util.Properties properties = getPropertiesFromTable( getRolesFactory(), table );
				if ( null != properties )
				{
				  setProperties( properties ) ;
				  this.foundInRoles = new Boolean( true ) ;
				  return ;
				}
			}
		}
		this.foundInRoles = new Boolean( false ) ;
	}

	public void refresh()
		throws Exception
	{
		findInRoles() ;
	}

	public Person
		( org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory
		, java.util.Properties properties
		)
	{
		super( properties ) ;
		setRolesFactory( rolesFactory ) ;
	}

	public Person
		( org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory
		, String kerberosName
		, String mitid
		, String firstName
		, String middleName
		, String lastName
		, String ssn
		, String dob
		, String emailAddr
		, String deptCode
		, String deptName
		, String primaryPersonType
		, String statusCode
		)
	{
		super( kerberosName , mitid , firstName , middleName , lastName , ssn , dob ) ;
		setRolesFactory( rolesFactory ) ;
		setEmailAddr( emailAddr ) ;
		setDeptCode( deptCode ) ;
		setDeptName( deptName ) ;
		setPrimaryPersonType( primaryPersonType  ) ;
		setStatusCode( statusCode ) ;
	}

	public static org.okiproject.serviceimpl.mit.roles.Person create
		( org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory
		, String kerberosName
		)
	{
		return new org.okiproject.serviceimpl.mit.roles.Person
			( rolesFactory
			, kerberosName
			, null
			, null
			, null
			, null
			, null
			, null
			, null
			, null
			, null
			, null
			, null
			) ;
	}

	private  java.util.Properties getPropertiesFromTable
			( org.okiproject.serviceimpl.mit.roles.RolesFactory factory
			, org.okiproject.serviceapi.dbc.Table table
			)
			throws Exception
		{
			java.util.Properties properties = new java.util.Properties() ;
			if( null != table )
			{
				org.okiproject.serviceapi.dbc.Rows rows = table.getRows() ;
				if( rows.hasMoreRows() )
				{
					Object[] row = rows.nextRow() ;
					String [] columnNames = rows.getColumnNames();

					for( int i = 0;  columnNames.length != i ; i++ )
					{
						if
							(  ( null != columnNames[i] )
							&& ( null != row[i] )
							&& ! ( columnNames[i].equals("") )
							&& ! ( columnNames[i].equalsIgnoreCase("NULL") )
							)
						{
							if( columnNames[i].trim().equals( STATUS_DATE ) )
							{
							    properties.put
							    	( columnNames[i]
							    	, getRolesFactory().createSqlTimestamp
							    	  ( ( String ) row[ i ] )
									);
							}
							else
							{
								properties.put( columnNames[i], row[i] ) ;
							}
						}
					}
				}
			}
			return properties ;
	}

}