package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/Qualifier.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.13 $ / $Date: 2002/02/16 17:10:36 $
*/
public class Qualifier
implements org.okiproject.serviceapi.authorization.Qualifier {
  private static String                                     QUALIFIER_ID   =
    "QUALIFIER_ID";
  private static String                                     QUALIFIER_CODE =
    "QUALIFIER_CODE";
  private static String                                     QUALIFIER_DESCRIPTION =
    "QUALIFIER_NAME";
  private static String                                     QUALIFIER_TYPE =
    "QUALIFIER_TYPE";
  private static String                                     HAS_CHILD      =
    "HAS_CHILD";

  private org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory   =
    null;

  /**
   * Method getRolesFactory
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceimpl.mit.roles.RolesFactory getRolesFactory() {
    return rolesFactory;
  }

  protected void setRolesFactory(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rFactory) {
    rolesFactory = rFactory;
  }

  private java.util.Properties properties = null;

  /**
   * Method getProperties
   *
   *
   * @return
   *
   */
  public java.util.Properties getProperties() {
    return this.properties;
  }

  private void setProperties(java.util.Properties properties) {
    this.properties = properties;
  }

  protected Object getProperty(String propertyName) {
    if (null != this.properties) {
      Object obj = this.properties.get(propertyName);

      if (null == obj) {
        try {
          if (isFoundInRoles().booleanValue()) {
            obj = this.properties.get(propertyName);
          }
        }
        catch (Exception ex) {}
      }

      return obj;
    }

    return null;
  }

  protected void setProperty(String propertyName, Object property) {
    if (null == this.properties) {
      this.properties = new java.util.Properties();
    }

    if ((null != this.properties) && (null != propertyName)
            && (null != property)) {
      this.properties.put(propertyName, property);
    }
  }

  /**
   * Method getId
   *
   *
   * @return
   *
   */
  public Object getId() {
    return getProperty(QUALIFIER_ID);
  }

  /**
   * Method setId
   *
   *
   * @param id
   *
   */
  public void setId(Object id) {
    setProperty(QUALIFIER_ID, id);
  }

  /**
   * Method getCode
   *
   *
   * @return
   *
   */
  public String getCode() {
    return (String) getProperty(QUALIFIER_CODE);
  }

  /**
   * Method setCode
   *
   *
   * @param code
   *
   */
  public void setCode(String code) {
    setProperty(QUALIFIER_CODE, code);
  }

  /**
   * Method getDescription
   *
   *
   * @return
   *
   */
  public String getDescription() {
    return (String) getProperty(QUALIFIER_DESCRIPTION);
  }

  protected void setDescription(String description) {
    setProperty(QUALIFIER_DESCRIPTION, description);
  }

  /**
   * Method getQualifierType
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.authorization.QualifierType getQualifierType() {
    return (org.okiproject.serviceapi.authorization.QualifierType) getProperty(
      QUALIFIER_TYPE);
  }

  /**
   * Method setQualifierType
   *
   *
   * @param qualifierType
   *
   */
  public void setQualifierType(
          org.okiproject.serviceapi.authorization.QualifierType qualifierType) {
    setProperty(QUALIFIER_TYPE, qualifierType);
  }

  /**
   * Method getHasChild
   *
   *
   * @return
   *
   */
  public Boolean getHasChild() {
    return (Boolean) getProperty(HAS_CHILD);
  }

  protected void setHasChild(Boolean hasChild) {
    setProperty(HAS_CHILD, hasChild);
  }

  private Boolean foundInRoles = new Boolean(false);

  /**
   * Method isFoundInRoles
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isFoundInRoles()
  throws Exception {
    if (!this.foundInRoles.booleanValue()) {
      this.foundInRoles = new Boolean(isIdInRoles()
                                      || isCodeAndTypeInRoles());
    }

    return this.foundInRoles;
  }

  /**
   * Method refresh
   *
   *
   * @throws Exception
   *
   */
  public void refresh()
  throws Exception {
    if (!isIdInRoles()) {
      isCodeAndTypeInRoles();
    }
  }

  /**
   * Constructor Qualifier
   *
   *
   * @param rolesFactory
   * @param properties
   *
   */
  public Qualifier(org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
                   java.util.Properties properties) {
    setRolesFactory(
      (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory);
    setProperties(properties);
  }

  /**
   * Constructor Qualifier
   *
   *
   * @param rolesFactory
   * @param code
   * @param description
   * @param qualifierType
   *
   */
  public Qualifier(
          org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
          String code, String description,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType) {
    setRolesFactory(
      (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory);
    setCode(code);
    setDescription(description);
    setQualifierType(qualifierType);
  }

  /**
   * Constructor Qualifier
   *
   *
   * @param rolesFactory
   * @param id
   * @param code
   * @param description
   * @param qualifierType
   *
   */
  public Qualifier(
          org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
          Object id, String code, String description,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType) {
    setRolesFactory(
      (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory);
    setId(id);
    setCode(code);
    setDescription(description);
    setQualifierType(qualifierType);
  }

  protected Qualifier(
          org.okiproject.serviceapi.authorization.RolesFactory rolesFactory,
          Object id, String code, String description,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType,
          Boolean hasChild) {
    setRolesFactory(
      (org.okiproject.serviceimpl.mit.roles.RolesFactory) rolesFactory);
    setId(id);
    setCode(code);
    setDescription(description);
    setQualifierType(qualifierType);
    setHasChild(hasChild);
  }

  /**
   * Method delete
   *
   *
   * @throws Exception
   *
   */
  public void delete()
  throws Exception {
    if ((null != getRolesFactory())
            && (null != getRolesFactory().getConnection())
            && ((null != this.properties.get(QUALIFIER_ID))
                || ((null != this.properties.get(QUALIFIER_TYPE))
                    && (null != this.properties.get(QUALIFIER_CODE))))) {
      org.okiproject.serviceapi.dbc.Connection connection =
        getRolesFactory().getConnection();

      Object[]                                 args       = new Object[3];

      args[0] =
        ((org.okiproject.serviceimpl.mit.roles.QualifierType) this.properties.get(
          QUALIFIER_TYPE)).getType();
      args[1] = this.properties.get(QUALIFIER_CODE);
      args[2] = ((null != getRolesFactory().getForUser())
                 ? ((org.okiproject.serviceimpl.mit.common.Person) getRolesFactory().getForUser()).getKerberosName()
                 : null);

      int[] columnTypes = new int[4];

      columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnOut;

      int[] dataTypes = new int[4];

      dataTypes[0] = java.sql.Types.VARCHAR;
      dataTypes[1] = java.sql.Types.VARCHAR;
      dataTypes[2] = java.sql.Types.VARCHAR;
      dataTypes[3] = java.sql.Types.VARCHAR;

      connection.callProcedure("AUTH_SP_DELETE_QUAL", args, columnTypes,
                               dataTypes);
      setRolesFactory(null);
      setId(null);
      setCode(null);
      setDescription(null);
      setQualifierType(null);
      setHasChild(null);

      return;
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  /**
   * Method update
   *
   *
   * @param newQualifierCode
   * @param newDescription
   *
   * @throws Exception
   *
   */
  public void update(String newQualifierCode, String newDescription)
  throws Exception {
    if ((null != getRolesFactory())
            && (null != getRolesFactory().getConnection())
            && (null != this.properties.get(QUALIFIER_CODE))
            && (null != this.properties.get(QUALIFIER_TYPE))
            && (null != this.properties.get(QUALIFIER_ID))) {
      org.okiproject.serviceapi.dbc.Connection connection =
        getRolesFactory().getConnection();
      Object[]                                 args       = new Object[4];

      args[0] =
        ((org.okiproject.serviceimpl.mit.roles.QualifierType) this.properties.get(
          QUALIFIER_TYPE)).getType();
      args[1] = this.properties.get(QUALIFIER_CODE);
      args[3] = ((null != getRolesFactory().getForUser())
                 ? ((org.okiproject.serviceimpl.mit.common.Person) getRolesFactory().getForUser()).getKerberosName()
                 : null);

      int[] columnTypes = new int[5];

      columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[4] = java.sql.DatabaseMetaData.procedureColumnOut;

      int[] dataTypes = new int[5];

      dataTypes[0] = java.sql.Types.VARCHAR;
      dataTypes[1] = java.sql.Types.VARCHAR;
      dataTypes[2] = java.sql.Types.VARCHAR;
      dataTypes[3] = java.sql.Types.VARCHAR;
      dataTypes[4] = java.sql.Types.VARCHAR;

      if (null != newDescription) {
        args[2] = newDescription;

        connection.callProcedure("AUTH_SP_UPDATE_QUALNAME", args,
                                 columnTypes, dataTypes);
        setDescription(newDescription);
      }

      if (null != newQualifierCode) {
        args[2] = newQualifierCode;

        connection.callProcedure("AUTH_SP_UPDATE_QUALCODE", args,
                                 columnTypes, dataTypes);
        setCode(newQualifierCode);
      }

      return;
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  /**
   * Method addLink
   *
   *
   * @param parent
   *
   * @throws Exception
   *
   */
  public void addLink(org.okiproject.serviceapi.authorization.Qualifier parent)
  throws Exception {
    if ((null != getRolesFactory())
            && (null != getRolesFactory().getConnection())
            && (null != this.properties.get(QUALIFIER_CODE))
            && (null != this.properties.get(QUALIFIER_TYPE))
            && (null != this.properties.get(QUALIFIER_ID))
            && (null != parent)) {
      org.okiproject.serviceapi.dbc.Connection connection =
        getRolesFactory().getConnection();
      Object[]                                 args       = new Object[5];

      args[0] =
        ((org.okiproject.serviceimpl.mit.roles.QualifierType) this.properties.get(
          QUALIFIER_TYPE)).getType();
      args[1] = this.properties.get(QUALIFIER_CODE);
      args[2] =
        ((org.okiproject.serviceimpl.mit.roles.Qualifier) parent).getId();
      args[3] = null;
      args[4] = ((null != getRolesFactory().getForUser())
                 ? ((org.okiproject.serviceimpl.mit.common.Person) getRolesFactory().getForUser()).getKerberosName()
                 : null);

      int[] columnTypes = new int[5];

      columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[4] = java.sql.DatabaseMetaData.procedureColumnIn;

      int[] dataTypes = new int[5];

      dataTypes[0] = java.sql.Types.VARCHAR;
      dataTypes[1] = java.sql.Types.VARCHAR;
      dataTypes[2] = java.sql.Types.VARCHAR;
      dataTypes[3] = java.sql.Types.VARCHAR;
      dataTypes[4] = java.sql.Types.VARCHAR;

      connection.callProcedure("AUTH_SP_UPDATE_QUALPAR", args, columnTypes,
                               dataTypes);

      return;
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  /**
   * Method deleteLink
   *
   *
   * @throws Exception
   *
   */
  public void deleteLink()
  throws Exception {
    if ((null != getRolesFactory())
            && (null != getRolesFactory().getConnection())
            && (null != this.properties.get(QUALIFIER_CODE))
            && (null != this.properties.get(QUALIFIER_TYPE))
            && (null != this.properties.get(QUALIFIER_ID))) {
      org.okiproject.serviceapi.dbc.Connection connection =
        getRolesFactory().getConnection();
      Object[]                                 args       = new Object[5];

      args[0] =
        ((org.okiproject.serviceimpl.mit.roles.QualifierType) this.properties.get(
          QUALIFIER_TYPE)).getType();
      args[1] = this.properties.get(QUALIFIER_CODE);
      args[2] = null;
      args[3] = null;
      args[4] = ((null != getRolesFactory().getForUser())
                 ? ((org.okiproject.serviceimpl.mit.common.Person) getRolesFactory().getForUser()).getKerberosName()
                 : null);

      int[] columnTypes = new int[5];

      columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[4] = java.sql.DatabaseMetaData.procedureColumnIn;

      int[] dataTypes = new int[5];

      dataTypes[0] = java.sql.Types.VARCHAR;
      dataTypes[1] = java.sql.Types.VARCHAR;
      dataTypes[2] = java.sql.Types.VARCHAR;
      dataTypes[3] = java.sql.Types.VARCHAR;
      dataTypes[4] = java.sql.Types.VARCHAR;

      connection.callProcedure("AUTH_SP_UPDATE_QUALPAR", args, columnTypes,
                               dataTypes);

      return;
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  /**
   * Method moveLink
   *
   *
   * @param oldParent
   * @param newParent
   *
   * @throws Exception
   *
   */
  public void moveLink(org.okiproject.serviceapi.authorization.Qualifier oldParent,
                       org.okiproject.serviceapi.authorization.Qualifier newParent)
  throws Exception {
    if ((null != getRolesFactory()) && (null != getRolesFactory().getConnection()) && (null != this.properties.get(
            QUALIFIER_CODE)) && (null != this.properties.get(
            QUALIFIER_TYPE)) && (null != this.properties.get(
            QUALIFIER_ID)) && (null != ((org.okiproject.serviceimpl.mit.roles.QualifierType) this.properties.get(
              QUALIFIER_TYPE)).getType()) && (null != oldParent) && (null != newParent)) {
      org.okiproject.serviceapi.dbc.Connection connection =
        getRolesFactory().getConnection();
      Object[]                                 args       = new Object[5];

      args[0] =
        ((org.okiproject.serviceimpl.mit.roles.QualifierType) this.properties.get(
          QUALIFIER_TYPE)).getType();
      args[1] = this.properties.get(QUALIFIER_CODE);
      args[2] =
        ((org.okiproject.serviceimpl.mit.roles.Qualifier) oldParent).getId();
      args[3] =
        ((org.okiproject.serviceimpl.mit.roles.Qualifier) newParent).getId();
      args[4] = ((null != getRolesFactory().getForUser())
                 ? ((org.okiproject.serviceimpl.mit.common.Person) getRolesFactory().getForUser()).getKerberosName()
                 : null);

      int[] columnTypes = new int[5];

      columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[4] = java.sql.DatabaseMetaData.procedureColumnIn;

      int[] dataTypes = new int[5];

      dataTypes[0] = java.sql.Types.VARCHAR;
      dataTypes[1] = java.sql.Types.VARCHAR;
      dataTypes[2] = java.sql.Types.VARCHAR;
      dataTypes[3] = java.sql.Types.VARCHAR;
      dataTypes[4] = java.sql.Types.VARCHAR;

      connection.callProcedure("AUTH_SP_UPDATE_QUALPAR", args, columnTypes,
                               dataTypes);

      return;
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  /**
   * Method create
   *
   *
   * @param rolesFactory
   * @param qualifierType
   * @param qualifierCode
   * @param qualifierDescription
   * @param parent
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.authorization.Qualifier create(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType,
          String qualifierCode, String qualifierDescription,
          org.okiproject.serviceapi.authorization.Qualifier parent)
  throws Exception {
    if ((null != rolesFactory) && (null != rolesFactory.getConnection())
            && (null != qualifierType) && (null != qualifierCode)
            && (null != qualifierDescription) && (null != parent)) {
      org.okiproject.serviceapi.dbc.Connection connection =
        rolesFactory.getConnection();
      Object[]                                 args       = new Object[5];

      args[0] =
        ((org.okiproject.serviceimpl.mit.roles.QualifierType) qualifierType).getType();
      args[1] = qualifierCode;
      args[2] = (((null != parent) && (null != parent.getCode()))
                 ? parent.getCode()
                 : null);
      args[3] = qualifierDescription;
      args[4] = ((null != rolesFactory.getForUser())
                 ? ((org.okiproject.serviceimpl.mit.common.Person) rolesFactory.getForUser()).getKerberosName()
                 : null);

      int[] columnTypes = new int[6];

      columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[4] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[5] = java.sql.DatabaseMetaData.procedureColumnOut;

      int[] dataTypes = new int[6];

      dataTypes[0] = java.sql.Types.VARCHAR;
      dataTypes[1] = java.sql.Types.VARCHAR;
      dataTypes[2] = java.sql.Types.VARCHAR;
      dataTypes[3] = java.sql.Types.VARCHAR;
      dataTypes[4] = java.sql.Types.VARCHAR;
      dataTypes[5] = java.sql.Types.VARCHAR;

      connection.callProcedure("AUTH_SP_INSERT_QUAL", args, columnTypes,
                               dataTypes);

      org.okiproject.serviceimpl.mit.roles.Qualifier qualifier =
        getQualifier(rolesFactory, qualifierCode, qualifierType);

      if (null != qualifier) {
        return (org.okiproject.serviceapi.authorization.Qualifier) qualifier;
      }
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  private static String getQualifierCode(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String qualifierId)
  throws Exception {
    if ((null != rolesFactory) && (null != rolesFactory.getConnection())
            && (null != qualifierId)) {
      org.okiproject.serviceapi.dbc.Connection connection =
        rolesFactory.getConnection();
      org.okiproject.serviceapi.dbc.Table      table      =
        connection.executeQuery(new String("select" + " qualifier_code"
                                           + " from qualifier"
                                           + " where qualifier_id = '"
                                           + qualifierId + "'"));

      if (null != table) {
        org.okiproject.serviceapi.dbc.Rows rows = table.getRows();

        if (rows.hasMoreRows()) {
          Object[] row           = rows.nextRow();
          String   qualifierCode =
            (String) row[rows.getColumn(QUALIFIER_CODE)];

          return qualifierCode;
        }
      }

      throw new org.okiproject.serviceapi.authorization.RolesException(
        org.okiproject.serviceapi.authorization.RolesException.QUALIFIERNOTFOUNDINROLES);
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  /**
   * Method getRootQualifier
   *
   *
   * @param rolesFactory
   * @param qualifierType
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceimpl.mit.roles.Qualifier getRootQualifier(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType)
  throws Exception {
    if ((null != rolesFactory) && (null != rolesFactory.getConnection())) {
      org.okiproject.serviceapi.dbc.Connection connection =
        rolesFactory.getConnection();
      org.okiproject.serviceapi.dbc.Table      table      = connection.executeQuery(
        new String(
          "select" + " q.qualifier_id, q.qualifier_code, q.qualifier_name,"
          + " q.qualifier_type, q.has_child" + " from qualifier q" + " where"
          + " qualifier_type = '"
          + ((org.okiproject.serviceimpl.mit.roles.QualifierType) qualifierType).getType()
          + "'" + " and q.qualifier_level = '1'"));

      if (null != table) {
        java.util.Properties properties = getPropertiesFromTable(rolesFactory,
                                            table);

        if (null != properties) {
          org.okiproject.serviceimpl.mit.roles.Qualifier rootQualifier =
            new org.okiproject.serviceimpl.mit.roles.Qualifier(rolesFactory,
              properties);

          return rootQualifier;
        }
      }
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  private static org.okiproject.serviceimpl.mit.roles.Qualifier getQualifier(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String qualifierCode,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType)
  throws Exception {
    if ((null != rolesFactory) && (null != rolesFactory.getConnection())
            && (null != qualifierType) && (null != qualifierCode)) {
      org.okiproject.serviceapi.dbc.Connection connection =
        rolesFactory.getConnection();
      org.okiproject.serviceapi.dbc.Table      table      = connection.executeQuery(
        new String(
          "select" + " q.qualifier_id, q.qualifier_code, q.qualifier_name,"
          + " q.qualifier_type, q.has_child" + " from qualifier q" + " where"
          + " q.qualifier_type = '"
          + ((org.okiproject.serviceimpl.mit.roles.QualifierType) qualifierType).getType()
          + "'" + " and q.qualifier_code = '" + qualifierCode + "'"));

      if (null != table) {
        java.util.Properties properties = getPropertiesFromTable(rolesFactory,
                                            table);

        if (null != properties) {
          org.okiproject.serviceimpl.mit.roles.Qualifier qualifier =
            new org.okiproject.serviceimpl.mit.roles.Qualifier(rolesFactory,
              properties);

          return qualifier;
        }
      }
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  private static org.okiproject.serviceimpl.mit.roles.Qualifier getQualifier(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          Number qualifierId)
  throws Exception {
    if ((null != rolesFactory) && (null != rolesFactory.getConnection())
            && (null != qualifierId)) {
      org.okiproject.serviceapi.dbc.Connection connection =
        rolesFactory.getConnection();
      org.okiproject.serviceapi.dbc.Table      table      =
        connection.executeQuery(
          new String(
            "select" + " q.qualifier_id, q.qualifier_code, q.qualifier_name,"
            + " q.qualifier_type, q.has_child" + " from qualifier q"
            + " where" + " q.qualifier_id = '" + qualifierId + "'"));

      if (null != table) {
        java.util.Properties properties = getPropertiesFromTable(rolesFactory,
                                            table);

        if (null != properties) {
          org.okiproject.serviceimpl.mit.roles.Qualifier qualifier =
            new org.okiproject.serviceimpl.mit.roles.Qualifier(rolesFactory,
              properties);

          return qualifier;
        }
      }
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  private boolean isIdInRoles()
  throws Exception {
    if ((null != this.properties.get(QUALIFIER_ID))
            && (null != getRolesFactory())
            && (null != getRolesFactory().getConnection())) {
      org.okiproject.serviceapi.dbc.Connection connection =
        getRolesFactory().getConnection();
      org.okiproject.serviceapi.dbc.Table      table      =
        connection.executeQuery(
          new String(
            "select qualifier_id," + " qualifier_code, qualifier_name,"
            + " qualifier_type, has_child" + " from qualifier "
            + " where qualifier_id = '" + this.properties.get(QUALIFIER_ID)
            + "'"));

      if (null != table) {
        java.util.Properties properties =
          getPropertiesFromTable(getRolesFactory(), table);

        if (null != properties) {
          setProperties(properties);

          return true;
        }
      }
    }

    return false;
  }

  private boolean isCodeAndTypeInRoles()
  throws Exception {
    if ((null != this.properties.get(
            QUALIFIER_CODE)) && (null != this.properties.get(
            QUALIFIER_TYPE)) && (null != ((org.okiproject.serviceimpl.mit.roles.QualifierType) this.properties.get(
              QUALIFIER_TYPE)).getType()) && (null != getRolesFactory()) && (null != getRolesFactory().getConnection())) {
      org.okiproject.serviceapi.dbc.Connection connection =
        getRolesFactory().getConnection();
      org.okiproject.serviceapi.dbc.Table      table      = connection.executeQuery(
        new String(
          "select qualifier_code, qualifier_type,"
          + " qualifier_id , qualifier_name," + " has_child"
          + " from qualifier" + " where qualifier_code = '"
          + this.properties.get(QUALIFIER_CODE) + "'"
          + " and qualifier_type = '"
          + ((org.okiproject.serviceimpl.mit.roles.QualifierType) this.properties.get(QUALIFIER_TYPE)).getType()
          + "'"));

      if (null != table) {
        java.util.Properties properties =
          getPropertiesFromTable(getRolesFactory(), table);

        if (null != properties) {
          setProperties(properties);

          return true;
        }
      }
    }

    return false;
  }

  private static java.util.Properties getPropertiesFromTable(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.dbc.Table table)
  throws Exception {
    java.util.Properties properties = new java.util.Properties();

    if (null != table) {
      org.okiproject.serviceapi.dbc.Rows rows = table.getRows();

      if (rows.hasMoreRows()) {
        Object[] row         = rows.nextRow();
        String[] columnNames = rows.getColumnNames();

        for (int i = 0; columnNames.length != i; i++) {
          if ((null != columnNames[i]) && (null != row[i])
                  &&!(columnNames[i].equals(""))
                  &&!(columnNames[i].equalsIgnoreCase("NULL"))) {
            if (columnNames[i].trim().equals(QUALIFIER_TYPE)) {
              properties.put(
                columnNames[i],
                new org.okiproject.serviceimpl.mit.roles.QualifierType(
                  rolesFactory, (String) row[i], (String) null));
            }
            else if (columnNames[i].trim().equals(HAS_CHILD)) {
              properties.put(columnNames[i],
                             new Boolean("Y".equals((String) row[i])));
            }
            else {
              properties.put(columnNames[i], row[i]);
            }
          }
        }
      }
    }

    return properties;
  }
}
