package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/QualifierType.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.6 $ / $Date: 2002/02/16 17:10:37 $
*/
public class QualifierType
implements org.okiproject.serviceapi.authorization.QualifierType {
  private static String                                            QUALIFIER_TYPE_DESC =
    "QUALIFIER_TYPE_DESC";

  private static org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory =
    null;

  /**
   * Method getRolesFactory
   *
   *
   * @return
   *
   */
  public static org.okiproject.serviceimpl.mit.roles.RolesFactory getRolesFactory() {
    return rolesFactory;
  }

  protected static void setRolesFactory(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rFactory) {
    rolesFactory = rFactory;
  }

  private String type = null;

  /**
   * Method getType
   *
   *
   * @return
   *
   */
  public String getType() {
    return this.type;
  }

  /**
   * Method setType
   *
   *
   * @param type
   *
   */
  public void setType(String type) {
    this.type = type;
  }

  private String description = null;

  /**
   * Method getDescription
   *
   *
   * @return
   *
   */
  public String getDescription() {
    if (null == this.description) {
      try {
        refresh();
      }
      catch (Exception ex) {}
    }

    return this.description;
  }

  private void setDescription(String description) {
    this.description = description;
  }

  private Boolean foundInRoles = new Boolean(false);

  /**
   * Method isFoundInRoles
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isFoundInRoles()
  throws Exception {
    if (!this.foundInRoles.booleanValue()) {
      refresh();
    }

    return this.foundInRoles;
  }

  /**
   * Method refresh
   *
   *
   * @throws Exception
   *
   */
  public void refresh()
  throws Exception {
    if ((null != getType()) && (null != getRolesFactory())) {
      org.okiproject.serviceapi.dbc.Connection connection =
        getRolesFactory().getConnection();
      org.okiproject.serviceapi.dbc.Table      table      =
        connection.executeQuery(new String("select" + " qualifier_type_desc"
                                           + " from qualifier_type"
                                           + " where qualifier_type = '"
                                           + getType() + "'"));

      if (null != table) {
        org.okiproject.serviceapi.dbc.Rows rows = table.getRows();

        if (rows.hasMoreRows()) {
          Object[] row = rows.nextRow();

          setDescription((String) row[rows.getColumn(QUALIFIER_TYPE_DESC)]);

          this.foundInRoles = new Boolean(true);
        }
      }
    }
  }

  /**
   * Constructor QualifierType
   *
   *
   * @param rolesFactory
   * @param type
   * @param description
   *
   */
  public QualifierType(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String type, String description) {
    setRolesFactory(rolesFactory);
    setType(type);
    setDescription(description);
  }

}
