package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/Virtuality.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.3 $ / $Date: 2002/02/16 05:02:55 $
*/
public class Virtuality {
  private final static String LINEFEED = "\n";

  public static final int     UNKNOWN  = 0;
  public static final int     REAL     = -1;
  public static final int     VIRTUAL  = 1;

  private int                 value    = UNKNOWN;

  /**
   * Method getValue
   *
   *
   * @return
   *
   */
  public int getValue() {
    return this.value;
  }

  /**
   * Method setValue
   *
   *
   * @param value
   *
   */
  public void setValue(int value) {
    this.value = value;
  }

  /**
   * Constructor Virtuality
   *
   *
   * @param value
   *
   */
  public Virtuality(int value) {
    setValue(value);
  }

  /**
   * Method toString
   *
   *
   * @return
   *
   */
  public String toString() {
    String str = super.toString();

    str += LINEFEED + value;

    return str;
  }

  /**
   * Method isReal
   *
   *
   * @return
   *
   */
  public boolean isReal() {
    return (0 > value);
  }

  /**
   * Method isVirtual
   *
   *
   * @return
   *
   */
  public boolean isVirtual() {
    return (0 < value);
  }

}
