package org.okiproject.serviceimpl.mit.sql ;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/sql/Rows.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.3 $ / $Date: 2002/02/16 17:10:52 $
*/
public class Rows
	implements org.okiproject.serviceapi.dbc.Rows
{
	protected static int MAXNUMBEROFROWS = 1000 ;
	private static final Object[] NOARGS = new Object[ 0 ] ;
	private static final Class[] NOARGSTYPES = new Class[ 0 ] ;
	private static final String GETROWS = "getRows" ;

	private static final org.okiproject.serviceapi.dbc.TableException LOCALGETROWSFAILED
		= new org.okiproject.serviceapi.dbc.TableException
			( org.okiproject.serviceapi.dbc.TableException.GETROWSFAILED
			) ;

	private static final org.okiproject.serviceapi.dbc.TableException LOCALGETCOLUMNFAILED
		= new org.okiproject.serviceapi.dbc.TableException
			( org.okiproject.serviceapi.dbc.TableException.GETCOLUMNFAILED
			) ;

	private String catalog = null ;
	private String schemaPattern = null ;
	private String procedureNamePattern = null ;
	private String columnNamePattern = null ;
	private String procedureName = null ;
	private String tableNamePattern = null ;
	private String[] tableTypes = null ;

	protected org.okiproject.serviceimpl.mit.sql.Table table = null ;
	private String sql = null ;
	private Object[] objs = null ;
	private int[] targetSqlTypes = null ;
	private int[] scales = null ;

	private Object[] rows = null ;
	private int index = 0 ;
	private int offset = 0 ;

	private org.okiproject.serviceapi.dbc.RowsMetaData rowsMetaData = null ;
	public org.okiproject.serviceapi.dbc.RowsMetaData getRowsMetaData()
	{
		return this.rowsMetaData ;
	}

	public String[] getColumnNames()
		throws Exception
	{
		String[] columnNames
			= new String[ this.rowsMetaData.getColumnCount() ] ;
		for( int i = 0 ; columnNames.length != i ; i ++ )
		{
			org.okiproject.serviceapi.dbc.ColumnMetaData colMetaData
				= this.rowsMetaData.getColumnsMetaData()[ i ] ;
			columnNames[ i ]
				= colMetaData.getColumnName() ;
		}
		return columnNames ;

	}

	public int getColumn( String columnName )
		throws Exception
	{
		String[] columnNames = getColumnNames() ;
		for( int i = 0 ; columnNames.length != i ; i ++ )
		{
			if( columnName.equals( columnNames[ i ] ) )
			{
				return i ;
			}
		}
		throw LOCALGETCOLUMNFAILED ;
	}

	public boolean hasMoreRows()
		throws Exception
	{
		if( null != rows )
		{
			if( index < rows.length )
			{
				return true ;
			}
			else
			{
				this.offset += index ;
				index = 0 ;
				rows = null ;
				if( null != table )
				{
					getRows() ;
					return( null != this.rows ) ;
				}
			}
		}
		return false ;
	}

	public Object[] nextRow()
		throws Exception
	{
		if( null != rows )
		{
			return ( Object[] ) rows[ index ++ ] ;
		}
		throw LOCALGETROWSFAILED ;
	}

	public Object clone()
	{
		try
		{
			return new org.okiproject.serviceimpl.mit.sql.Rows( this.rowsMetaData , rows ) ;
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
		return null ;
	}

	protected Rows
		( org.okiproject.serviceapi.dbc.RowsMetaData rowsMetaData
		, Object[] rows
		)
		throws Exception
	{
		this.rowsMetaData = rowsMetaData ;
		this.rows = rows ;
	}

	protected Rows
		( org.okiproject.serviceimpl.mit.sql.Table table
		, String catalog
		, String schemaPattern
		, String tableNamePattern
		, String[] tableTypes
		)
		throws Exception
	{
		this.table = table ;
		this.catalog = catalog ;
		this.schemaPattern = schemaPattern ;
		this.tableNamePattern = tableNamePattern ;
		this.tableTypes = tableTypes ;

		getRows() ;
	}

	protected Rows
		( org.okiproject.serviceimpl.mit.sql.Table table
		, String catalog
		, String schemaPattern
		, String procedureNamePattern
		)
		throws Exception
	{
		this.table = table ;
		this.catalog = catalog ;
		this.schemaPattern = schemaPattern ;
		this.procedureNamePattern = procedureNamePattern ;

		getRows() ;
	}

	protected Rows
		( org.okiproject.serviceimpl.mit.sql.Table table
		, String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		)
		throws Exception
	{
		this.table = table ;
		this.catalog = catalog ;
		this.schemaPattern = schemaPattern ;
		this.procedureName = procedureName ;
		this.columnNamePattern = columnNamePattern ;

		getRows() ;
	}

	protected Rows
		( org.okiproject.serviceimpl.mit.sql.Table table
		, String sql
		, Object[] objs
		, int[] targetSqlTypes
		, int[] scales
		)
		throws Exception
	{
		this.table = table ;
		this.sql = sql ;
		this.objs = objs ;
		this.scales = scales ;

		getRows() ;
	}

	public void getRows()
		throws Exception
	{
		org.okiproject.serviceimpl.mit.sql.Connection connection
			= ( org.okiproject.serviceimpl.mit.sql.Connection )
				( ( org.okiproject.serviceimpl.mit.sql.Table ) table ).getConnection() ;
		if( connection.hasClient() )
		{
			getRowsRemotely() ;
		}
		else
		{
			getRowsLocally() ;
		}
	}

	private void getRowsRemotely()
		throws Exception
	{
		org.okiproject.serviceimpl.mit.sql.Connection connection
			= ( org.okiproject.serviceimpl.mit.sql.Connection )
				( ( org.okiproject.serviceimpl.mit.sql.Table ) table ).getConnection() ;
		org.okiproject.serviceimpl.mit.rmissl.Client client = connection.getClient() ;
		client.invoke( this , GETROWS , NOARGSTYPES , NOARGS ) ;
	}

	public void getRowsLocally()
		throws Exception
	{
		java.sql.ResultSet rs = getResultSet() ;
		java.sql.ResultSetMetaData rsMeta = rs.getMetaData() ;
		this.rowsMetaData = new org.okiproject.serviceimpl.mit.sql.RowsMetaData( rsMeta ) ;
		this.rows = createRows( rs ) ;
		java.sql.Statement statement = rs.getStatement() ;
		rs.close() ;
		statement.close() ;
	}

	protected java.sql.ResultSet getResultSet()
		throws Exception
	{
		if
			(  ( null != tableNamePattern )
			|| ( null != tableTypes )
			)
		{
			return getTables() ;
		}
		else if( null != this.sql )
		{
			return getQuery() ;
		}
		else if
			(  ( null != this.procedureName )
			|| ( null != this.columnNamePattern )
			)
		{
			return getProcedureColumns() ;
		}
		else
		{
			return getProcedures() ;
		}
	}

	private java.sql.Connection getConnection()
		throws Exception
	{
		org.okiproject.serviceapi.dbc.Connection conn =
			( ( org.okiproject.serviceimpl.mit.sql.Table ) this.table
			).getConnection() ;

		java.sql.Connection connection =
			( ( org.okiproject.serviceimpl.mit.sql.Connection ) conn
			).getConnection() ;
		return connection ;
	}

	private java.sql.ResultSet getTables()
		throws Exception
	{
		java.sql.DatabaseMetaData meta
			= getConnection().getMetaData() ;

		return meta.getTables
				( this.catalog
				, this.schemaPattern
				, this.tableNamePattern
				, this.tableTypes
				) ;
	}

	private java.sql.ResultSet getQuery()
		throws Exception
	{
		java.sql.Connection connection
			= getConnection() ;
		java.sql.ResultSet rs = null ;
		if( null == objs )
		{
			java.sql.Statement statement
				= connection.createStatement() ;
			rs = statement.executeQuery( sql ) ;
		}
		else
		{
			java.sql.PreparedStatement statement
				= connection.prepareStatement( sql ) ;
			for( int i = 0 ; objs.length != i ; i ++ )
			{
				if( null != this.scales )
				{
					statement.setObject
						( i + 1
						, objs[ i ]
						, targetSqlTypes[ i ]
						, scales[ i ]
						) ;
				}
				else if ( null != targetSqlTypes )
				{
					statement.setObject
						( i + 1
						, objs[ i ]
						, targetSqlTypes[ i ]
						) ;
				}
				else
				{
					statement.setObject
						( i + 1
						, objs[ i ]
						) ;
				}
			}
			rs = statement.executeQuery() ;
		}
		return rs ;
	}

	private java.sql.ResultSet getProcedureColumns()
		throws Exception
	{
		java.sql.DatabaseMetaData meta
			= getConnection().getMetaData() ;

		return meta.getProcedureColumns
				( this.catalog
				, this.schemaPattern
				, this.procedureName
				, this.columnNamePattern
				) ;
	}

	private java.sql.ResultSet getProcedures()
		throws Exception
	{
		java.sql.DatabaseMetaData meta
			= getConnection().getMetaData() ;

		return meta.getProcedures
				( this.catalog
				, this.schemaPattern
				, this.procedureNamePattern
				) ;
	}

	private Object[] createRows( java.sql.ResultSet rs )
		throws Exception
	{
		try
		{
			int rsType = rs.getType() ;
			if( rs.TYPE_FORWARD_ONLY == rsType )
			{
				if( rs.next() )
				{
					return createCells( rs ) ;
				}
			}
			else if( rs.TYPE_SCROLL_INSENSITIVE == rsType )
			{
				rs.setFetchDirection( rs.FETCH_FORWARD ) ;
				if( rs.first() )
				{
					return createCells( rs ) ;
				}
			}
			else if( rs.TYPE_SCROLL_SENSITIVE == rsType )
			{
				rs.setFetchDirection( rs.FETCH_FORWARD ) ;
				boolean isRowAvailable = rs.first() ;
				if( rs.first() )
				{
					return createCells( rs ) ;
				}
			}
		}
		catch( Exception ex )
		{
			String message = LOCALGETROWSFAILED.getMessage() ;
			message += ex.getMessage() ;
			throw new org.okiproject.serviceapi.dbc.TableException( message ) ;
		}
		return null ;
	}

	private Object[] createCells( java.sql.ResultSet rs )
		throws Exception
	{
		Object[] rows = new Object[ MAXNUMBEROFROWS ] ;
		int cursor = 0 ;
		int rowsAdded = 0 ;
		boolean isRowAvailable = true ;
		while( isRowAvailable )
		{
			if( cursor >= this.offset )
			{
				Object[] columns
					= new Object
						[ this.rowsMetaData.getColumnCount()
						] ;
				for( int i = 0 ; columns.length != i ; i ++ )
				{
					columns[ i ] = createCell( rs.getObject( i + 1 ) , rowsAdded , i ) ;
				}
				rows[ rowsAdded ] = columns ;
				rowsAdded ++ ;

			}
			if( MAXNUMBEROFROWS == rowsAdded )
			{
				break ;
			}
			cursor ++ ;
			isRowAvailable = rs.next() ;
		}
		if( 0 == rowsAdded )
		{
			return null ;
		}
		if( MAXNUMBEROFROWS > rowsAdded )
		{
			Object[] newRows = new Object[ rowsAdded ] ;
			for( int j = 0 ; rowsAdded != j ; j ++ )
			{
				newRows[ j ] = rows[ j ] ;
			}
			rows = newRows ;
		}
		return rows ;
	}

	private Object createCell
		( Object obj
		, int row
		, int col
		)
		throws Exception
	{
		Object cell = obj ;
		if( obj instanceof java.sql.Blob )
		{
			cell = makeBlob( ( java.sql.Blob ) obj , row , col ) ;
		}
		else if( obj instanceof java.sql.Clob )
		{
			cell = makeClob( ( java.sql.Clob ) obj , row , col ) ;
		}
		return obj ;
	}

	private org.okiproject.serviceapi.dbc.Blob makeBlob
		( java.sql.Blob blob
		, int row
		, int col
		)
		throws Exception
	{
		return new org.okiproject.serviceimpl.mit.sql.Blob
			( ( org.okiproject.serviceimpl.mit.sql.Rows ) this.clone()
			, blob.length()
			, row
			, col
			) ;
	}

	private org.okiproject.serviceapi.dbc.Clob makeClob
		( java.sql.Clob clob
		, int row
		, int col
		)
		throws Exception
	{
		return new org.okiproject.serviceimpl.mit.sql.Clob
			( ( org.okiproject.serviceimpl.mit.sql.Rows ) this.clone()
			, clob.length()
			, row
			, col
			) ;
	}

}