package org.okiproject.serviceimpl.mit.sql ;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/sql/Table.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.3 $ / $Date: 2002/02/16 17:10:52 $
*/
public class Table
	implements org.okiproject.serviceapi.dbc.Table
{
	private static final org.okiproject.serviceapi.dbc.TableException GETTABLEFAILED
		= new org.okiproject.serviceapi.dbc.TableException
			( org.okiproject.serviceapi.dbc.TableException.GETROWSFAILED
			) ;

	private org.okiproject.serviceapi.dbc.Connection connection = null ;
	public org.okiproject.serviceapi.dbc.Connection getConnection()
	{
		return this.connection ;
	}

	private org.okiproject.serviceapi.dbc.Rows rows = null ;
	public org.okiproject.serviceapi.dbc.Rows getRows()
	{
		if( null != this.rows )
		{
			return ( org.okiproject.serviceapi.dbc.Rows ) ( ( ( org.okiproject.serviceimpl.mit.sql.Rows ) this.rows ).clone() ) ;
		}
		return null ;
	}

	public static org.okiproject.serviceapi.dbc.Table getTables
		( org.okiproject.serviceapi.dbc.Connection connection
		)
		throws Exception
	{
		String[] tableTypes = new String[ 2 ] ;
		tableTypes[ 0 ] = "TABLE" ;
		tableTypes[ 1 ] = "VIEW" ;
		return getTables
			( connection
			, null
			, null
			, null
			, tableTypes
			) ;
	}

	public static org.okiproject.serviceapi.dbc.Table getTables
		( org.okiproject.serviceapi.dbc.Connection connection
		, String catalog
		, String schemaPattern
		, String tableNamePattern
		, String[] tableTypes
		)
		throws Exception
	{
		return new org.okiproject.serviceimpl.mit.sql.Table
			( connection
			, catalog
			, schemaPattern
			, tableNamePattern
			, tableTypes
			) ;
	}

	public static org.okiproject.serviceapi.dbc.Table executeQuery
		( org.okiproject.serviceapi.dbc.Connection connection
		, String sql
		)
		throws Exception
	{
		org.okiproject.serviceapi.dbc.Table table
			= new org.okiproject.serviceimpl.mit.sql.Table
				( connection
				, sql
				, ( Object[] ) null
				, ( int[] ) null
				, ( int[] ) null
				) ;
		return table ;
	}

	public static org.okiproject.serviceapi.dbc.Table executeQuery
		( org.okiproject.serviceapi.dbc.Connection connection
		, String sql
		, Object[] objs
		)
		throws Exception
	{
		org.okiproject.serviceapi.dbc.Table table
			= new org.okiproject.serviceimpl.mit.sql.Table
				( connection
				, sql
				, objs
				, ( int[] ) null
				, ( int[] ) null
				) ;
		return table ;
	}

	public static org.okiproject.serviceapi.dbc.Table executeQuery
		( org.okiproject.serviceapi.dbc.Connection connection
		, String sql
		, Object[] objs
		, int[] targetSqlTypes
		)
		throws Exception
	{
		org.okiproject.serviceapi.dbc.Table table
			= new org.okiproject.serviceimpl.mit.sql.Table
				( connection
				, sql
				, objs
				, targetSqlTypes
				, ( int[] ) null
				) ;
		return table ;
	}

	public static org.okiproject.serviceapi.dbc.Table executeQuery
		( org.okiproject.serviceapi.dbc.Connection connection
		, String sql
		, Object[] objs
		, int[] targetSqlTypes
		, int[] scales
		)
		throws Exception
	{
		org.okiproject.serviceapi.dbc.Table table
			= new org.okiproject.serviceimpl.mit.sql.Table
				( connection
				, sql
				, objs
				, targetSqlTypes
				, scales
				) ;
		return table ;
	}

	public static org.okiproject.serviceapi.dbc.Table getProcedureColumns
		( org.okiproject.serviceapi.dbc.Connection connection
		, String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		)
		throws Exception
	{
		org.okiproject.serviceapi.dbc.Table table
			= new org.okiproject.serviceimpl.mit.sql.Table
				( connection
				, catalog
				, schemaPattern
				, procedureName
				, columnNamePattern
				) ;
		return table ;
	}

	public static org.okiproject.serviceapi.dbc.Table getProcedures
		( org.okiproject.serviceapi.dbc.Connection connection
		, String catalog
		, String schemaPattern
		, String procedureNamePattern
		)
		throws Exception
	{
		org.okiproject.serviceapi.dbc.Table table
			= new org.okiproject.serviceimpl.mit.sql.Table
				( connection
				, catalog
				, schemaPattern
				, procedureNamePattern
				) ;
		return table ;
	}

	protected Table
		( org.okiproject.serviceapi.dbc.Connection connection
		, org.okiproject.serviceapi.dbc.Rows rows
		)
		throws Exception
	{
		this.connection = connection ;
		this.rows = rows ;
	}

	private Table
		( org.okiproject.serviceapi.dbc.Connection connection
		, String catalog
		, String schemaNamePattern
		, String tableNamePattern
		, String[] tableTypes
		)
		throws Exception
	{
		this.connection = connection ;
		this.rows
			= new org.okiproject.serviceimpl.mit.sql.Rows
				( this
				, catalog
				, schemaNamePattern
				, tableNamePattern
				, tableTypes
				) ;
	}

	private Table
		( org.okiproject.serviceapi.dbc.Connection connection
		, String sql
		, Object[] objs
		, int[] targetSqlTypes
		, int[] scales
		)
		throws Exception
	{
		this.connection = connection ;
		this.rows
			= new org.okiproject.serviceimpl.mit.sql.Rows
				( this
				, sql
				, objs
				, targetSqlTypes
				, scales
				) ;
	}

	private Table
		( org.okiproject.serviceapi.dbc.Connection connection
		, String catalog
		, String schemaPattern
		, String procedureNamePattern
		)
		throws Exception
	{
		this.connection = connection ;
		this.rows
			= new org.okiproject.serviceimpl.mit.sql.Rows
				( this
				, catalog
				, schemaPattern
				, procedureNamePattern
				) ;
	}

	private Table
		( org.okiproject.serviceapi.dbc.Connection connection
		, String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		)
		throws Exception
	{
		this.connection = connection ;
		this.rows
			= new org.okiproject.serviceimpl.mit.sql.Rows
				( this
				, catalog
				, schemaPattern
				, procedureName
				, columnNamePattern
				) ;
	}

}