package org.okiproject.serviceimpl.mit.util ;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/util/RuntimeContext.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.2 $ / $Date: 2002/02/16 05:02:55 $
*/
public class RuntimeContext
{
	private static java.util.Hashtable contexts = new java.util.Hashtable() ;

	public static boolean contains( Object key )
	{
		try
		{
			if( null != key )
			{
				Runtime runtime = Runtime.getRuntime() ;
				if( contexts.containsKey( runtime ) )
				{
					java.util.Hashtable context
						= ( java.util.Hashtable ) contexts.get( runtime ) ;
					return( context.containsKey( key ) ) ;
				}
			}
		}
		catch( Exception ex )
		{
		}
		return false ;
	}

	public static void setProperty( Object key , Object value )
	{
		try
		{
			if( null != key )
			{
				Runtime runtime = Runtime.getRuntime() ;
				if( ! contexts.containsKey( runtime ) )
				{
					contexts.put( runtime , new java.util.Hashtable() ) ;
				}
				java.util.Hashtable context
					= ( java.util.Hashtable ) contexts.get( runtime ) ;
				if( null != value )
				{
					context.put( key , value ) ;

				}
				else
				{
					context.remove( key ) ;
				}
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
	}

	public static Object getProperty( Object key )
	{
		try
		{
			if( null != key )
			{
				Runtime runtime = Runtime.getRuntime() ;
				if( contexts.containsKey( runtime) )
				{
					java.util.Hashtable context
						= ( java.util.Hashtable ) contexts.get( runtime ) ;
					return( context.get( key ) ) ;
				}
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
		return null ;
	}

	public static java.util.Enumeration getKeys()
	{
		try
		{
			Runtime runtime = Runtime.getRuntime() ;
			if( contexts.containsKey( runtime ) )
			{
				java.util.Hashtable context
					= ( java.util.Hashtable ) contexts.get( runtime ) ;
				return( context.keys() ) ;
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
		return null ;
	}

	public static Object removeProperty( String key )
	{
		try
		{
			if( null != key )
			{
				Runtime runtime = Runtime.getRuntime() ;
				if( ! contexts.containsKey( runtime ) )
				{
					java.util.Hashtable context
						= ( java.util.Hashtable ) contexts.get( runtime) ;
					if( context.containsKey( key ) )
					{
						Object value = context.get( key ) ;
						if( value instanceof java.sql.Connection )
						{
							( ( java.sql.Connection ) value ).close() ;
						}
						else if( value instanceof java.sql.ResultSet )
						{
							( ( java.sql.ResultSet ) value ).close() ;
						}
						Object obj = context.remove( key ) ;
						System.gc() ;
						return( obj ) ;
					}
				}
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
		return null ;
	}

}