package org.okiproject.serviceimpl.mit.util ;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/util/ThreadContext.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.2 $ / $Date: 2002/02/16 05:02:55 $
*/
public class ThreadContext
extends Thread
{
	private static java.util.Hashtable contexts = new java.util.Hashtable() ;

	private static void gc()
	{
		java.util.Enumeration keys = contexts.keys() ;
		while( keys.hasMoreElements() )
		{
			Thread thread = ( Thread ) keys.nextElement() ;
			if( ! thread.isAlive() )
			{
				contexts.remove( thread ) ;
				keys = contexts.keys() ;
			}
		}
		System.gc() ;
	}

	public static void setProperty( Object key , Object value )
	{
		try
		{
			gc() ;
			if( null != key )
			{
				Thread thread = Thread.currentThread() ;
				if( ! contexts.containsKey( thread ) )
				{
					contexts.put( thread , new java.util.Hashtable() ) ;
				}
				java.util.Hashtable context = ( java.util.Hashtable ) contexts.get( thread ) ;
				if( null != value )
				{
					context.put( key , value ) ;
				}
				else
				{
					context.remove( key ) ;
				}
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
	}

	public static Object getProperty( Object key )
	{
		try
		{
			gc() ;
			if( null != key )
			{
				Thread thread = Thread.currentThread() ;
				if( contexts.containsKey( thread ) )
				{
					java.util.Hashtable context = ( java.util.Hashtable ) contexts.get( thread ) ;
					return( context.get( key ) ) ;
				}
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
		return null ;
	}

	public static java.util.Enumeration getPropertyNames()
	{
		try
		{
			gc() ;
			Thread thread = Thread.currentThread() ;
			if( ! contexts.containsKey( thread ) )
			{
				java.util.Hashtable context = ( java.util.Hashtable ) contexts.get( thread ) ;
				return( context.keys() ) ;
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
		return null ;
	}

	public static Object removeProperty( String name )
	{
		try
		{
			gc() ;
			if( null != name )
			{
				Thread thread = Thread.currentThread() ;
				if( ! contexts.containsKey( thread ) )
				{
					java.util.Hashtable context = ( java.util.Hashtable ) contexts.get( thread ) ;
					return( context.remove( name ) ) ;
				}
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
		return null ;
	}

	public static void purge()
	{
		try
		{
			java.util.Enumeration threads = contexts.keys() ;
			while( threads.hasMoreElements() )
			{
				java.util.Hashtable context = ( java.util.Hashtable ) threads.nextElement() ;
				java.util.Enumeration keys = context.keys() ;
				while( keys.hasMoreElements() )
				{
					Object key = keys.nextElement() ;
					context.remove( key ) ;
				}
				contexts.remove( context ) ;
			}
			contexts = new java.util.Hashtable() ;
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
		System.gc() ;
	}

}